Package: tigre
Version: 1.66.0
Date: 2021-08-04
Title: Transcription factor Inference through Gaussian process
        Reconstruction of Expression
Author: Antti Honkela, Pei Gao, Jonatan Ropponen, Miika-Petteri
        Matikainen, Magnus Rattray, Neil D. Lawrence
Maintainer: Antti Honkela <antti.honkela@helsinki.fi>
Depends: R (>= 2.11.0), BiocGenerics, Biobase
Imports: methods, AnnotationDbi, gplots, graphics, grDevices, stats,
        utils, annotate, DBI, RSQLite
Suggests: drosgenome1.db, puma, lumi, BiocStyle, BiocManager
Description: The tigre package implements our methodology of Gaussian
        process differential equation models for analysis of gene
        expression time series from single input motif networks. The
        package can be used for inferring unobserved transcription
        factor (TF) protein concentrations from expression measurements
        of known target genes, or for ranking candidate targets of a
        TF.
License: AGPL-3
URL: https://github.com/ahonkela/tigre
BugReports: https://github.com/ahonkela/tigre/issues
biocViews: Microarray, TimeCourse, GeneExpression, Transcription,
        GeneRegulation, NetworkInference, Bayesian
Config/pak/sysreqs: libpng-dev libxml2-dev libssl-dev zlib1g-dev
Repository: https://bioc-release.r-universe.dev
Date/Publication: 2026-04-28 12:34:33 UTC
RemoteUrl: https://github.com/bioc/tigre
RemoteRef: RELEASE_3_23
RemoteSha: 3987af6e456b1bf43e1269a86c532327a6af0aa2
NeedsCompilation: yes
Packaged: 2026-04-30 09:51:40 UTC; root
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-30 10:01:15 UTC; unix

useDynLib("tigre", "_ClnDiffErfs")

importFrom(BiocGenerics, updateObject, getObjectSlots)

importClassesFrom(Biobase, AnnotatedDataFrame, AssayData, eSet, ExpressionSet,
                  MIAME, Versioned, VersionedBiobase, Versions)

importClassesFrom(methods, character, list, matrix, numeric)

importMethodsFrom(AnnotationDbi, as.list, colnames, exists, get, ncol,
                  revmap)

importMethodsFrom(Biobase, annotation, experimentData, exprs,
                 featureData, featureNames, phenoData)

importMethodsFrom(DBI, dbCommit, dbConnect, dbDisconnect, dbDriver,
                  dbExecute, dbGetQuery, dbListTables)

importMethodsFrom(methods, initialize, show)

importMethodsFrom(RSQLite, dbBeginTransaction)

importFrom(annotate, getAnnMap)

importFrom(Biobase, assayDataElement, assayDataElementNames,
          assayDataElementReplace, assayDataNew, contents)

importFrom(gplots, plotCI)

importFrom(graphics, layout, lines, par, plot, title, polygon)

importFrom(grDevices, dev.off, png)

importFrom(methods, callNextMethod, new, slotNames)

importFrom(RSQLite, SQLite)

importFrom(stats, optim, optimize, qgamma, qnorm, rnorm, sd)

importFrom(utils, sessionInfo, write.table, tail)

##export everything that does not start with a . or an _
exportPattern("^[^\\._]")

<div align="center">
  <picture>
    <source media="(prefers-color-scheme: dark)" srcset="https://github.com/brenodupin/tigre/releases/download/v0.1.0-alpha/tigre_logo_dark_mode.png">
    <source media="(prefers-color-scheme: light)" srcset="https://github.com/brenodupin/tigre/releases/download/v0.1.0-alpha/tigre_logo_light_mode.png">
    <img src="https://github.com/brenodupin/tigre/releases/download/v0.1.0-alpha/tigre_logo_light_mode.png" width="50%" alt="TIGRE Logo">
  </picture>

![Build Status](https://img.shields.io/badge/tests-in_development-yellow)
[![Checked with mypy](https://www.mypy-lang.org/static/mypy_badge.svg)](https://mypy-lang.org/)
[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)
[![Linting: Ruff](https://img.shields.io/endpoint?url=https://raw.githubusercontent.com/charliermarsh/ruff/main/assets/badge/v2.json)](https://github.com/astral-sh/ruff)
[![License](https://img.shields.io/badge/license-MIT-purple)](https://github.com/brenodupin/gdt/blob/master/LICENSE)
[![DOI](https://zenodo.org/badge/1013921186.svg)](https://zenodo.org/badge/latestdoi/1013921186)
</div>

# TIGRE - Tool for InterGenic Region Extraction

TIGRE is a Python CLI tool that extracts intergenic regions from GFF3 file(s). It is designed to handle overlapping features and provides options for customizing the extraction process. It has 3 main commands: `clean`, `extract`, and `getfasta`, which cleans and prepares GFF3 files, extracts intergenic regions (or just regions between features), and retrieves sequences from a FASTA file, respectively.

In `clean` command, TIGRE optionally supports the use of a [GDT](https://github.com/brenodupin/gdt) .gdict file to standardize feature names.

##  Features

- **Clean & Standardize**: Process and prepares GFF3 files with optional support for [GDT](https://github.com/brenodupin/gdt) to standardize gene names.
- **Extract Regions**: Extract intergenic regions with customizable feature filtering.
- **Generate Sequences**: Retrieve FASTA sequences from extracted regions.
- **Parallel Processing**: On demand multi-thread/multi-process execution for batch operations.

## Table of Contents
 - [Quick Start](#quick-start)
   - [Installation](#installation)
   - [Example Usage](#example-usage)
 
 - [Usage Modes](#usage-modes)
   - [Single Mode](#single-mode)
   - [Multiple Mode](#multiple-mode)
     - [TSV format](#tsv-format)
     - [Input organization requirement](#input-organization-requirement)

 - [Detailed Usage](#detailed-usage)
   - [Global Options](#global-options)
   - [`tigre clean`](#tigre-clean)
     - [Processing Details](#processing-details)
   - [`tigre extract`](#tigre-extract)
     - [Intergenic Region Creation](#intergenic-region-creation)
   - [`tigre getfasta`](#tigre-getfasta)
     - [FASTA Header Format](#fasta-header-format)
   - [`tigre combine`](#tigre-combine)
   - [Advanced Usage](#advanced-usage)

## Quick Start

### Installation

**Dependencies:**
- [Python](https://www.python.org/) `(>=3.12)`
- [pandas](https://pandas.pydata.org/) `(>=1.5.3,<3.0.0)`

**Optional Dependencies:**
- [biopython](https://biopython.org) `(>=1.80)`
- [gdt](https://github.com/brenodupin/gdt) `(>=1.0.1)`

```bash
# Basic installation
pip install tigre

# With optional dependencies
pip install tigre[bio]    # for biopython (getfasta command)
pip install tigre[gdt]    # for GDT support in clean command
pip install tigre[all]    # for all optional dependencies
```
### Example Usage

```bash
# Download plants_mit.tar.zst dataset from our github
wget TODO: add link here
zstd -d -c plants_mit.tar.zst | tar -xf -
cd plants_mit

# Run TIGRE pipeline
tigre clean multiple -v --log tigre_clean.log --gdict plants_mit.gdict --tsv plants_mit.tsv
tigre extract multiple -v --log tigre_extract.log --tsv plants_mit.tsv
tigre getfasta multiple -v --log tigre_getfasta.log --tsv plants_mit.tsv --bedtools-compatible
```

Commands

 - `clean` → Prepares GFF3 files (sorting, overlap resolution, attribute formatting, optional GDT normalization).
 - `extract` → Extracts intergenic regions from cleaned GFF3s.
 - `getfasta` → Retrieves FASTA sequences for extracted regions.

More examples in [EXAMPLES.md](examples/EXAMPLES.md)

## Usage Modes

### Single Mode
Processes individual files by specifying direct file paths:

```bash
tigre <command> single --gff-in input.gff3 --gff-out output.gff3 [options]
```
<div align="center">

| Flag | Description | `clean` | `extract` | `getfasta` |
| :---: | :---: | :---: | :---: | :---: |
| `--gff-in`    | Input GFF3 file path   | ✅ | ✅ | ✅ |
| `--gff-out`   | Output GFF3 file path  | ✅ | ✅ | ❌ |
| `--fasta-in`  | Input FASTA file path  | ❌ | ❌ | ✅ |
| `--fasta-out` | Output FASTA file path | ❌ | ❌ | ✅ |

</div>

### Multiple Mode

The `multiple` mode allows TIGRE to process batches of files indexed by the input TSV file containing accession numbers.
For each accession, TIGRE builds the expected file paths using suffixes and extensions.
Each command has its own default suffixes and extensions, which are applied automatically unless the user overrides them.

#### TSV format:
The TSV must have a column with accession numbers.
By default, the column name is `AN`, but it can be changed with the `--an-column` flag.
Example:
```
AN          other_columns
NC_123456.1   ...
NC_999999.1   ...
```

#### Input organization requirement:
The TSV file and the accession-number folders must be located in the **same directory**.
Each folder must be named exactly after the corresponding accession number from the TSV.

The file paths are constructed as:
```
<AN>/<AN><suffix><extension>
```

Using the example above, the corresponding folder structure should look like this:
```
your_project/
├──example.tsv
├── NC_123456.1/
│   ├── NC_123456.1.gff3
│   └── NC_123456.1.fasta (if applicable)
└── NC_999999.1/
    ├── NC_999999.1.gff3
    └── NC_999999.1.fasta (if applicable)
```

<div align="center">

File extension default values for each command

| Flag | Default |`clean` | `extract` | `getfasta` |
| :---: | :---: | :---: | :---: | :---: |
| `--gff-in-ext`    | ".gff3"  | ✅ | ✅ | ✅ |
| `--gff-out-ext`   | ".gff3"  |✅ | ✅ | ❌ |
| `--fasta-in-ext`  | ".fasta" |❌ | ❌ | ✅ |
| `--fasta-out-ext` | ".fasta" |❌ | ❌ | ✅ |

File suffix default values for each command

| Flag | `clean` | `extract` | `getfasta` |
| :---: | :---: | :---: | :---: |
| `--gff-in-suffix`    | "" | "_clean" | "_intergenic" |
| `--gff-out-suffix`   | "_clean" | "_intergenic" | ❌ |
| `--fasta-in-suffix`  | ❌ | ❌ | "" |
| `--fasta-out-suffix` | ❌ | ❌ | "_intergenic" |

</div>

## Detailed Usage

### Global Options
Available for all commands:

#### Logging Options

TIGRE has extensive logging capabilities, allowing users to customize the verbosity and destination of log messages, by default logs are saved to `tigre_<command>-<timestamp>.log` in the current working directory.

- `-v, --verbose`: Increase verbosity level. Use multiple times for more verbose output: -v (INFO console, TRACE file), -vv (DEBUG console, TRACE file), -vvv (TRACE console, TRACE file). Default: INFO console + DEBUG file.
- `--log PATH`: Custom log file path.
- `--no-log-file`: Disable file logging.
- `--quiet`: Suppress console output.

#### Output Options
- `--overwrite`: Overwrite existing output files. By default, TIGRE will not even execute if one of the output files already exists, to prevent accidental overwrites.

#### Multiple Mode Options
- `--tsv PATH`: TSV file with accession numbers and other columns.
- `--an-column STR`: Column name for accession numbers in TSV (default: `"AN"`).
- `--workers INT`: Number of workers for parallel processing (default: `0`, which uses all available CPU cores).

### `tigre clean`

The `clean` command processes GFF3 files by retaining features that match the `--query-string` criteria, resolving overlapping annotations, and optionally normalizing gene names using GDT.

**Options:**
- `--gdict PATH`: GDT .gdict file for standardizing gene names.
- `--query-string STR`: pandas query string for feature filtering (default: `"type in ('gene', 'tRNA', 'rRNA', 'region')"`).
- `--keep-orfs`: Keep ORF sequences in output.
- `--extended-filtering`: Enable extended filtering to more aggressively remove ORFs and their related features. This may remove more features than intended in some cases. Default: False.
- `--overwrite`: Overwrite existing output files. By default, TIGRE will not even execute if one of the output files already exists, to prevent accidental overwrites.

**Single Mode Options:**
- `--gff-in PATH`: Input GFF3 file path.
- `--gff-out PATH`: Output GFF3 file path.

**Multiple Mode Options:**
- `--tsv PATH`: TSV file with accession numbers and other columns.
- `--an-column STR`: Column name for accession numbers in TSV (default: `"AN"`).
- `--workers INT`: Number of workers for parallel processing (default: `0`, which uses all available CPU cores).
- `--gff-in-suffix STR`: Suffix for input GFF3 files (default: `""`).
- `--gff-in-ext STR`: Extension for input GFF3 files (default: `".gff3"`).
- `--gff-out-suffix STR`: Suffix for output GFF3 files (default: `"_clean"`).
- `--gff-out-ext STR`: Extension for output GFF3 files (default: `".gff3"`).

When `clean` is called with a GDT file in `multiple` mode, TIGRE automatically uses a server-client architecture to optimize memory usage. A dedicated dictionary server process loads and queries the gene dictionary (gdict), while worker processes communicate with it via inter-process queues and pipes to perform gene name lookups. This design prevents each worker from loading its own copy of the potentially large gdict file, significantly reducing overall memory overhead.

#### Processing Details
TIGRE handles complex genomic scenarios including overlapping features and circular genome boundaries. For detailed information about overlap resolution, circular genome handling, and the underlying algorithms, see [PROCESSING.md](https://github.com/brenodupin/tigre/blob/master/PROCESSING.md#tigre-clean)

### `tigre extract`

The `extract` command identifies and extracts intergenic regions (spaces between features) from cleaned GFF3 files, creating new annotations for these intervening sequences.

**Options:**
- `--add-region`: Add region line to the output GFF3 file.
- `--feature-type STR`: Feature type name for intergenic regions (default: `"intergenic_region"`).
- `--overwrite`: Overwrite existing output files. By default, TIGRE will not even execute if one of the output files already exists, to prevent accidental overwrites.

**Single Mode Options:**
- `--gff-in PATH`: Input GFF3 file path.
- `--gff-out PATH`: Output GFF3 file path.

**Multiple Mode Options:**
- `--tsv PATH`: TSV file with accession numbers and other columns.
- `--an-column STR`: Column name for accession numbers in TSV (default: `"AN"`).
- `--workers INT`: Number of workers for parallel processing (default: `0`, which uses all available CPU cores).
- `--gff-in-suffix STR`: Suffix for input GFF3 files (default: `"_clean"`).
- `--gff-int-ext STR`: Extension for input GFF3 files (default: `".gff3"`).
- `--gff-out-suffix STR`: Suffix for output GFF3 files (default: `"_intergenic"`).
- `--gff-out-ext STR`: Extension for output GFF3 files (default: `".gff3"`).

#### Intergenic Region Creation

TIGRE identifies and extracts intergenic regions (spaces between annotated features) from GFF3 files, creating annotations for these intervening sequences. For detailed information about the algorithm and how circular genomes are handled, see [PROCESSING.md](https://github.com/brenodupin/tigre/blob/master/PROCESSING.md#tigre-extract).


### `tigre getfasta`

`tigre getfasta` retrieves the nucleotide sequences of the intergenic regions extracted by `tigre extract`. The nucleotide sequences are saved in a multi-FASTA file (one per Accession Number).

**Requirements:**
- Requires [biopython](https://biopython.org) (`pip install tigre[bio]`)

**Options:**
- `--bedtools-compatible`: Use 0-based indexing in FASTA headers for bedtools compatibility
- `--overwrite`: Overwrite existing output files. By default, TIGRE will not even execute if one of the output files already exists, to prevent accidental overwrites.

**Single Mode Options:**
- `--gff-in PATH`: Input GFF3 file path.
- `--fasta-in PATH`: Input FASTA file path.
- `--fasta-out PATH`: Output FASTA file path.

**Multiple Mode Options:**
- `--tsv PATH`: TSV file with accession numbers and other columns.
- `--an-column STR`: Column name for accession numbers in TSV (default: `"AN"`).
- `--workers INT`: Number of workers for parallel processing (default: `0`, which uses all available CPU cores).
- `--gff-in-suffix STR`: Suffix for input GFF3 files (default: `"_intergenic"`).
- `--gff-in-ext STR`: Extension for input GFF3 files (default: `".gff3"`).
- `--fasta-in-suffix STR`: Suffix for input FASTA files (default: `""`).
- `--fasta-in-ext STR`: Extension for input FASTA files (default: `".fasta"`).
- `--fasta-out-suffix STR`: Suffix for output FASTA files (default: `"_intergenic"`).
- `--fasta-out-ext STR`: Extension for output FASTA files (default: `".fasta"`).

#### FASTA Header Format
The FASTA headers are formatted as follows:
`>type::seqid:start-end`

Where:
- `type`: Type of the feature (e.g., `intergenic_region`, `intergenic_region_merged`).
- `seqid`: `seqid` column from the GFF3 file (mostly the accession number).
- `start`: Start position of the intergenic region (1-based index).
- `end`: End position of the intergenic region (1-based index).

By default, TIGRE uses 1-based indexing in sequence headers matching GFF3 conventions. When `--bedtools-compatible` is enabled, headers use 0-based indexing for seamless integration with bedtools workflows, while the actual sequences remain unchanged.

### `tigre combine`

`tigre combine` merges two GFF3 files into a single GFF3 file. It follows the same input/output conventions as the other commands, when calcutaling paths.

**Options:**
- `--overwrite`: Overwrite existing output files. By default, TIGRE will not even execute if one of the output files already exists, to prevent accidental overwrites.

**Single Mode Options:**
- `--gff-in-1 PATH`: First input GFF3 file path.
- `--gff-in-2 PATH`: Second input GFF3 file path.
- `--gff-out PATH`: Output GFF3 file path.

**Multiple Mode Options:**
- `--tsv PATH`: TSV file with accession numbers and other columns.
- `--an-column STR`: Column name for accession numbers in TSV (default: `"AN"`).
- `--workers INT`: Number of workers for parallel processing (default: `0`, which uses all available CPU cores).
- `--gff-in-suffix-1 STR`: Suffix for first input GFF3 files (default: `""`).
- `--gff-in-ext-1 STR`: Extension for first input GFF3 files (default: `".gff3"`).
- `--gff-in-suffix-2 STR`: Suffix for second input GFF3 files (default: `"_intergenic"`).
- `--gff-in-ext-2 STR`: Extension for second input GFF3 files (default: `".gff3"`).
- `--gff-out-suffix STR`: Suffix for output GFF3 files (default: `"_combined"`).
- `--gff-out-ext STR`: Extension for output GFF3 files (default: `".gff3"`).

This combination follows the procedure:
1. Read both GFF3 files as DataFrames.
2. Copy region line (first row of GFF3) from the `gff-in-1` file.
3. Remove region lines (`type == 'region'`) from both DataFrames.
4. Check for duplicated IDs between both files and log a warning if any is found.
5. Concatenate both DataFrames, with the region line extracted earlier as the first row.
6. Write the combined DataFrame to a `gff-out` path, preserving the header from the `gff-in-1` file.

## Advanced Usage

### Experimental Extraction of Introns  

TIGRE can be used to extract intronic regions by iterating through tigre `clean`, `extract` and `combine` commands in a specific way. The process involves three main steps:

1. **Extract Intergenic Regions**: use `tigre clean` to prepare the input GFF3 files. Next, extract the corresponding intergenic regions with `tigre extract`.

2. **Combine GFF3 Files**: use `tigre combine` to merge the original GFF3 files with their corresponding "intergenic" GFF3 files (from step 1). The combined files contain the original annotated genome features (e.g., CDS, gene, tRNA, etc) and the newly extracted intergenic regions.

3. **Extract Intronic Regions**: run `tigre clean` and `tigre extract` again, while keeping only `region`, `exon`, `CDS`, `intergenic_regions` and `intergenic_regions_merged` feature types (defined in --query-string). This "workaround" extracts the intronic regions from the combined GFF3 file.


Below you can find a step-by-step example of this advanced usage of TIGRE. The example input GFF3 files are stored in the `advanced_usage` folder in the examples directory. These genomes already contain annotated introns, so these annotations will serve as benchmark to showcase our process.


First, run the TIGRE pipeline to get the intergenic regions:

```bash
cd examples/advanced_usage
tigre clean multiple -v --log tigre_clean.log --tsv plants_introns.tsv
tigre extract multiple -v --log tigre_extract.log --tsv plants_introns.tsv
```

Now, combine the original GFF3 files with the newly created intergenic GFF3 files. As the original GFF3 files do not have suffixes, set `--gff-in-suffix-1` to "". The intergenic GFF files have the default suffix `_intergenic`, so set `--gff-in-suffix-2` to "_intergenic". To distinguish the output files, set `--gff-out-suffix` to "_combined".

```bash
tigre combine multiple -v --log tigre_combine.log --tsv plants_introns.tsv --gff-in-suffix-1 "" --gff-in-suffix-2 "_intergenic" --gff-out-suffix "_combined"
```

Create a special 'clean' version of the genomes of interest. To extract the introns (and nothing else), filter the genomic features to keep only `region`, `exon`, `CDS`, `intergenic_regions` and `intergenic_regions_merged` types. The `--query-string` argument should be set accordingly (see command below; note that `genes` are not included in query string). The input files have the suffix `_combined`, and the output files will have the suffix `_clean_to_introns`. Deploy `--extended-filtering` to remove all ORFs and their associated features.

```bash
tigre clean multiple -v --log tigre_clean_to_introns.log --tsv plants_introns.tsv --query-string "type in ('region', 'exon', 'CDS', 'intergenic_region', 'intergenic_region_merged')" --gff-in-suffix "_combined" --gff-out-suffix "_clean_to_introns" --extended-filtering
```

Finally, extract the intronic regions from the `_clean_to_introns` files. The output files will have the suffix `_intronic`.

```bash
tigre extract multiple -v --log tigre_extract_introns.log --tsv plants_introns.tsv --gff-in-suffix "_clean_to_introns" --gff-out-suffix "_intronic" --feature-type "maybe_intron"
```
A detailed explanation on how this process works can be found in [PROCESSING.md](PROCESSING.md#experimental-intron-extraction).

[![Documentation Status](https://readthedocs.org/projects/tigre/badge/?version=latest)](https://tigre.readthedocs.io/en/latest/?badge=latest)


TIGRE: Tomographic Iterative GPU-based Reconstruction Toolbox
======

TIGRE is an open-source toolbox for fast and accurate 3D tomographic 
reconstruction for any geometry.  Its focus is on iterative algorithms 
for improved image quality that have all been optimized to run on GPUs 
(including multi-GPUs) for improved speed. It combines the higher level 
abstraction of MATLAB or Python with the performance of CUDA at a lower level in order to make 
it both fast and easy to use.

TIGRE is free to download and distribute: use it, modify it, add to it, 
share it. Our aim is to provide a wide range of easy-to-use algorithms 
for the tomographic community "off the shelf".  We would like to build a 
stronger bridge between algorithm developers and imaging 
researchers/clinicians by encouraging and supporting contributions from 
both sides into TIGRE.

TIGRE remains under development as we are still adding new features 
(e.g., motion compensation).  If you have any request for a specific 
application, do not hesitate to [contact us](#contact) or open a  [discussion thread](https://github.com/CERN/TIGRE/discussions)!

 - [TIGRE features](#features)
 
 - [Installation instructions](#installation)
 
 - [FAQ](#faq)
  
 - [Further reading](#further-reading)
 
 - [Contact](#contact) 
 
 - [Licensing](#licensing)


## TIGRE features

TIGRE is a GPU-based CT reconstruction software repository that contains a wide variety of iterative algorithms.

- **MATLAB** and **Python** libraries for high-performance x-ray absorption tomographic reconstruction.

- State-of-the-art implementations of projection and backprojection operations on **GPUs** (including **multi-GPUs**), with a simple interface using higher level languages to facilitate the development of new methods.

- **Flexible CT geometry:** Cone Beam, Parallel Beam, Digital Tomosynthesis, C-arm CT, and any other geometry.  Geometric parameters are defined per projection, not per scan.

- A wide range of reconstruction algorithms for CT.

    - Filtered backprojection (FBP,FDK) and variations (different filters, Parker weights, ...)
   
    - **Iterative algorithms**
       
        - Gradient-based algorithms (SART, OS-SART, SIRT) with multiple tuning parameters (Nesterov acceleration, initialization, parameter reduction, ...)
       
        - Krylov subspace algorithms (CGLS)
       
        - Statistical reconstruction (MLEM)
       
        - Total variation regularization based algorithms: proximal-based (FISTA, SART-TV) and POCS-based (ASD-POCS, OS-ASD-POCS, B-ASD-POCS-β, PCSD, AwPCSD, Aw-ASD-POCS)
       
- TV denoising for 3D images.
       
- Basic image loading functionality.
       
- A variety of plotting functions.
       
- Image quality metrics.

- Nikon and Varian and Phillips (DICOM) scanner data loaders. 

## Installation

MATLAB and Python builds are both fully supported.

- [Installation instructions and requirements for MATLAB](Frontispiece/MATLAB_installation.md).

- [Installation instructions and requirements for Python](Frontispiece/python_installation.md). 

**Advanced, not required to run TIGRE**, will change the source code. Only do if performance is critical.

- [Tune TIGRE for machine. Tricks to slightly speed up the code](Frontispiece/Tune_TIGRE.md)


## FAQ

For answers to frequently asked questions [click here](Frontispiece/FAQ.md).

If you have new question not answered in the FAQ, please [contact us](#contact) or open a  [discussion thread](https://github.com/CERN/TIGRE/discussions).

## Gallery

To see a gallery of images of different CT modalities reconstructed using TIGRE [click here](Frontispiece/Gallery.md).

<img src="https://raw.githubusercontent.com/AnderBiguri/PhDThesis/master/Applications/randofull.png" height="400">


## Further Reading

If you want more information on TIGRE and its algorithms, [click here](Frontispiece/Further_reading.md).


## Contact

Contact the authors directly at:

[tigre.toolbox@gmail.com](mailto:tigre.toolbox@gmail.com) or [ander.biguri@gmail.com](mailto:ander.biguri@gmail.com)

for any questions/comments or if you want to be added to the mailing list. 

## Licensing

The creation of TIGRE was supported by the University of Bath and CERN. It is released under the BSD License, meaning you can use and modify the software freely.  However, you **must** cite the original authors.
For more information read [the licence file][1] or the [BSD License Definition][2].

If you use TIGRE, please reference the following papers:

**TIGRE: A MATLAB-GPU toolbox for CBCT image reconstruction**
*Ander Biguri, Manjit Dosanjh, Steven Hancock and Manuchehr Soleimani*
**Biomedical Physics & Engineering Express, Volume 2, Number 5**
[Read the article (open access)][3]

And especially if you use images bigger than 512<sup>3</sup> or multiple GPUs

**Arbitrarily large iterative tomographic reconstruction on multiple GPUs using the TIGRE toolbox**
*Ander Biguri, Reuben Lindroos, Robert Bryll, Hossein Towsyfyan, Hans Deyhle, Ibrahim El khalil Harrane, Richard
Boardman, Mark Mavrogordato, Manjit Dosanjh, Steven Hancock, Thomas Blumensath*
**Journal of Parallel and Distributed Computing**
[Read the article][4], 
[Preprint][5]

[1]: LICENSE.txt
[2]: http://www.linfo.org/bsdlicense.html
[3]: http://iopscience.iop.org/article/10.1088/2057-1976/2/5/055010
[4]: https://doi.org/10.1016/j.jpdc.2020.07.004
[5]: https://arxiv.org/abs/1905.03748

kernCreate <- function(x, kernType, kernOptions=NULL) {
  if ( is.list(x) ) {
    dim <- array()
    for ( i in 1:length(x) ) {
      dim[i] <- dim(as.matrix(x[[i]]))[2]
      if ( (dim[i] == 1) & (dim(as.matrix(x[[i]]))[1] == 1) )
        dim[i] <- x[[i]]
    }
  } else {
    dim <- dim(as.matrix(x))[2]
    if ( (dim == 1) & (dim(as.matrix(x))[1] == 1) )
      dim <- x
  }

  if ( is.list(kernType) && kernType$type == "parametric" ) {
    kernOptions <- kernType$options
    kernType <- kernType$realType
  }

  if ( is.list(kernType) && ("options" %in% names(kernType)) ) {
    kernOptions <- kernType$options
  }
  
  if ( is.list(kernType) && ("complete" %in% names(kernType)) ) {
    if ( kernType$complete == 1 ) {
      kern <- kernType
    }
    
  } else if ( is.list(kernType) ) {
    
    kern <- list(inputDimension=dim, type=kernType$type)

    if (!is.null(kernOptions))
      kern$options <- kernOptions
    
    start <- 1    
    
    if ( kern$type == "multi" ) {
      for ( i in start:length(kernType$comp) ) {
        if ( is.list(kernType$comp) ) {
          iType <- kernType$comp[[i]]
        } else {
          iType <- kernType$comp[i]
        }
        
        if ( is.list(x) ) {
          kern$comp[[i-start+1]] <- kernCreate(x[[i-start+1]], iType)
          kern$diagBlockDim[i-start+1] <- dim(as.array(x[[i-start+1]]))[1]
        } else {
          kern$comp[[i-start+1]] <- kernCreate(x, iType)
        }

        kern$comp[[i-start+1]]$index = array()
      }
      
    } else if ( kern$type %in% c("cmpnd", "tensor", "translate") )  {
      for ( i in start:length(kernType$comp) ) {
        if ( is.list(kernType$comp) ) {
          iType <- kernType$comp[[i]]
        } else {
          iType <- kernType$comp[i]
        }
        
        kern$comp[[i-start+1]] <- kernCreate(x, iType)
        kern$comp[[i-start+1]]$index = array()
      }
      
    } else if ( kern$type == "exp" ) {
      ## need double check
      if ( start == length(kernType$comp) ) {
        kern$argument <- kernCreate(x, kernType$comp[start])
      } else {
        kern$argument <- kernCreate(x, kernType$comp[start:length(kernType$comp)])
      }
    }

    kern <- kernParamInit(kern)

  } else {
    kern <- list(type=kernType, inputDimension=dim)

    if (!is.null(kernOptions))
      kern$options <- kernOptions

    kern <- kernParamInit(kern)
  }

  kern$Kstore <- matrix()
  kern$diagK <- matrix()      

  if (!is.null(kernOptions) && "priors" %in% names(kernOptions)) {
    kern$priors <- list()
    for (k in seq_along(kernOptions$prior))
      kern$priors[[k]] <- priorCreate(kernOptions$prior[[k]])
  }
  
  return (kern)
  
}



kernParamInit <- function (kern) {
  
  funcName <- paste(kern$type, "KernParamInit", sep="")
  kern$transforms = list()

  func <- get(funcName, mode="function")
  kern <- func(kern)  

  return (kern)
}



kernExtractParam <- function (kern, only.values=TRUE, untransformed.values=FALSE) {
  funcName <- paste(kern$type, "KernExtractParam", sep="")
  func <- get(funcName, mode="function")

  params <- func(kern, only.values=only.values, untransformed.values=untransformed.values)

  if ( any(is.nan(params)) )
    warning("Parameter has gone to NaN.")

  if ( "transforms" %in% names(kern) && (length(kern$transforms) > 0)
      && !untransformed.values )
    for ( i in seq(along=kern$transforms) ) {
      index <- kern$transforms[[i]]$index
      funcName <- optimiDefaultConstraint(kern$transforms[[i]]$type)
      func <- get(funcName$func, mode="function")
      if (funcName$hasArgs)
        params[index] <- func(params[index], "xtoa", kern$transformArgs[[i]])
      else
        params[index] <- func(params[index], "xtoa")
    }

  return (params)
}



kernExpandParam <- function (kern, params, untransformed.values=FALSE) {
  if ( is.list(params) )
    params <- params$values
  
  if ( "transforms" %in% names(kern) && (length(kern$transforms) > 0)
      && !untransformed.values )
    for ( i in seq(along=kern$transforms) ) {
      index <- kern$transforms[[i]]$index
      funcName <- optimiDefaultConstraint(kern$transforms[[i]]$type)
      func <- get(funcName$func, mode="function")
      if (funcName$hasArgs)
        params[index] <- func(params[index], "atox", kern$transformArgs[[i]])
      else
        params[index] <- func(params[index], "atox")
    }

  funcName <- paste(kern$type, "KernExpandParam", sep="")
  func <- get(funcName, mode="function")
  kern <- func(kern, params)

  return (kern)
  
}

kernDisplay <- function (kern, ...) {

  funcName <- paste(kern$type, "KernDisplay", sep="")
  if(exists(funcName, mode="function")) {
    func <- get(funcName, mode="function")
    return (func(kern, ...))
  }

}

kernCompute <- function (kern, x, x2) {

  funcName <- paste(kern$type, "KernCompute", sep="")
  func <- get(funcName, mode="function")

  if ( nargs() < 3 ) {
    k <- func(kern, x)
  } else {
    k <- func(kern, x, x2)
  }

  return (k)
}



kernGradient <- function (kern, x, ...) {
  funcName <- paste(kern$type, "KernGradient", sep="")
  func <- get(funcName, mode="function")

  g <- func(kern, x, ...)

  factors <- .kernFactors(kern, "gradfact")
  for (i in seq(along=factors))
    g[factors[[i]]$index] <- g[factors[[i]]$index]*factors[[i]]$val

  return (g)
}


kernPriorLogProb <- function (kern) {
  L <- 0
  if (kern$type %in% c('cmpnd', 'multi', 'tensor')) {
    for (i in seq_along(kern$comp)) {
      L <- L + kernPriorLogProb(kern$comp[[i]])
    }
  } else {
    if ("priors" %in% names(kern)) {
      func <- get(paste(kern$type, 'KernExtractParam', sep=''), mode='function')
      params <- func(kern)
      for (i in seq_along(kern$priors)) {
        index <- kern$priors[[i]]$index
        L <- L + priorLogProb(kern$priors[[i]], params[index])
      }
    }
  }
  return (L)
}


kernPriorGradient <- function (kern) {
  g <- array(0, kern$nParams)

  if (kern$type %in% c('cmpnd', 'multi', 'tensor')) {
    startVal <- 1
    endVal <- 0
    for (i in seq_along(kern$comp)) {
      endVal <- endVal + kern$comp[[i]]$nParams
      g[startVal:endVal] <- kernPriorGradient(kern$comp[[i]])
      startVal <- endVal + 1
    }
    g = (g %*% kern$paramGroups)[1,]
  } else {
    if ("priors" %in% names(kern)) {
      func <- get(paste(kern$type, 'KernExtractParam', sep=''), mode='function')
      params <- func(kern)
      for (i in seq_along(kern$priors)) {
        index <- kern$priors[[i]]$index
        g[index] <- g[index] + priorGradient(kern$priors[[i]], params[index])
      }
      # Check if parameters are being optimised in a transformed space.
      if ("transforms" %in% names(kern)) {
        factors <- .kernFactors(kern, "gradfact")
        for (i in seq_along(factors))
          g[factors[[i]]$index] <- g[factors[[i]]$index]*factors[[i]]$val
      }
    }
  }

  return (g)
}


.kernFactors <- function (kern, factorType) {
  factors <- list()

  if ( length(kern$transforms) > 0 ) {
    funcName <- paste(kern$type, "KernExtractParam", sep="")
    func <- get(funcName, mode="function")
    params <- func(kern)

    for (i in seq(along=kern$transforms)) {
      factors[[i]] <- list()
      factors[[i]]$index <- kern$transforms[[i]]$index
      funcName <- optimiDefaultConstraint(kern$transforms[[i]]$type)
      func <- get(funcName$func, mode="function")
      if (funcName$hasArgs)
        factors[[i]]$val <- func(params[factors[[i]]$index], factorType, kern$transformArgs[[i]])
      else
        factors[[i]]$val <- func(params[factors[[i]]$index], factorType)
    }
  }
  return (factors)
}



kernDiagCompute <- function (kern, x) {
  funcName <- paste(kern$type, "KernDiagCompute", sep="")
  func <- get(funcName, mode="function")
  k <- func(kern, x)
  return (k)
}



kernDiagGradX <- function (kern, x) {
  funcName <- paste(kern$type, "KernDiagGradX", sep="")
  func <- get(funcName, mode="function")
  k <- func(kern, x)
  return (k)
}



kernGradX <- function (kern, x, x2) {
  funcName <- paste(kern$type, "KernGradX", sep="")
  func <- get(funcName, mode="function")
  k <- func(kern, x, x2)
  return (k)
}


.kernTestCombinationFunction <- function (kern1, kern2) {
  funcName <- paste(kern1$type, "X", kern2$type, "KernCompute", sep="")

  if ( !exists(funcName, mode="function") ) {
    return (FALSE)
  } else {
    return (TRUE)
  }
}



multiKernParamInit <- function (kern) {

  kern$nParams <- 0
  kern$transforms <- list()

  if ( !("comp" %in% names(kern)) )
    kern$comp <- list()

  kern$numBlocks <- length(kern$comp)
  kern$isStationary <- TRUE

  kern$block <- list()
  for ( i in seq(along=kern$comp) ) {
    if ( !kern$comp[[i]]$isStationary )
      kern$isStationary <- FALSE

    kern$comp[[i]] <- kernParamInit(kern$comp[[i]])
    kern$nParams <- kern$nParams + kern$comp[[i]]$nParams
    kern$comp[[i]]$index <- array()

    kern$block[[i]] <- list(cross=array(), transpose=array())

    for ( j in seq(length.out=i-1) ) {
      if ( .kernTestCombinationFunction(kern$comp[[i]], kern$comp[[j]]) ) {
        kern$block[[i]]$cross[j] <- paste(kern$comp[[i]]$type, "X", kern$comp[[j]]$type, sep="")
        kern$block[[i]]$transpose[j] <- FALSE
      } else {
        if ( .kernTestCombinationFunction(kern$comp[[j]], kern$comp[[i]]) ) {
          kern$block[[i]]$cross[j] <- paste(kern$comp[[j]]$type, "X", kern$comp[[i]]$type, sep="")
          kern$block[[i]]$transpose[j] <- TRUE
        } else {
          warning(paste("No cross covariance found between", kern$comp[[i]]$type, "and", kern$comp[[j]]$type, "assuming independence."))
          kern$block[[i]]$cross[j] <- ""
          kern$block[[i]]$transpose[j] <- 0
        }
      }
    }
  }

  kern$paramGroups <- diag(1, nrow=kern$nParams, ncol=kern$nParams)

  kern$fixBlocks <- rep(FALSE, kern$numBlocks)
  if ("options" %in% names(kern) && "fixedBlocks" %in% names(kern$options)
      && !is.null(kern$options$fixedBlocks)) {
    kern$fixBlocks[kern$options$fixedBlocks] <- TRUE
    kern$cache <- new.env(parent=emptyenv())
    assign("cache", list(list(list())), envir=kern$cache)
  }

  return (kern)
}



multiKernExtractParam <- function (kern, only.values=TRUE,
                                   untransformed.values=FALSE) {
  return (cmpndKernExtractParam(kern, only.values=only.values,
                                untransformed.values=untransformed.values))
}



multiKernExpandParam <- function (kern, params) {
  if ( is.list(params) )
    params <- params$values

  params <- params%*%t(kern$paramGroups)
  startVal <- 1
  endVal <- 0

  for ( i in seq(along=kern$comp) ) {
    endVal <- endVal+kern$comp[[i]]$nParams
    kern$comp[[i]] <- kernExpandParam(kern$comp[[i]], params[startVal:endVal])
    startVal <- endVal+1
  }

  return (kern)
}

multiKernDisplay <- function (kern, spaceNum=0) {
  spacing = matrix("", spaceNum+1)
  cat(spacing);
  cat("Multiple output block kernel:\n")
  for(i in seq(along=kern$comp)) {
    cat(spacing)
    cat("Block ", i, "\n", sep="")
    kernDisplay(kern$comp[[i]], spaceNum)
  }
}

multiKernCompute <- function (kern, x, x2=x) {
  if ( is.list(x) ) {
    if ( length(x) != kern$numBlocks )
      stop ("Time information is not matched among blocks!")

    dim1 <- array(0, dim=length(x))
    dim2 <- array(0, dim=length(x))
    
    for ( i in seq(length=kern$numBlocks) ) {
      dim1[i] <- dim(as.array(x[[i]]))[1]
      if ( nargs()>2 ) {
        if ( length(x) != length(x2) )
          stop ("Time information is not matched within the block!")
        dim2[i] <- dim(as.array(x2[[i]]))[1]
      } else {
        dim2[i] <- dim1[i]
      }
    }

    K <- matrix(0, sum(dim1), sum(dim2))

    for ( i in seq(length=kern$numBlocks) ) {
      startOne <- sum(dim1[seq(length.out=(i-1))])+1
      endOne <- sum(dim1[seq(length.out=i)])
      startThree <- sum(dim2[seq(length.out=(i-1))])+1
      endThree <- sum(dim2[seq(length.out=i)])

      if ( nargs()<3 ) {
        K[startOne:endOne, startThree:endThree] <- .multiKernComputeBlock(kern, i, i, x[[i]])
      } else {
        K[startOne:endOne, startThree:endThree] <- .multiKernComputeBlock(kern, i, i, x[[i]], x2[[i]])
      }

      for ( j in seq(length.out=(i-1)) )
        if ( !is.na(kern$block[[i]]$cross[j]) ) {
          startTwo <- sum(dim2[seq(length.out=(j-1))])+1
          endTwo <- sum(dim2[seq(length.out=j)])

          if ( nargs()<3 ) {
            K[startOne:endOne, startTwo:endTwo] <- .multiKernComputeBlock(kern, i, j, x[[i]], x[[j]])
            K[startTwo:endTwo, startOne:endOne] <- t(K[startOne:endOne, startTwo:endTwo])
          } else {
            K[startOne:endOne, startTwo:endTwo] <- .multiKernComputeBlock(kern, i, j, x[[i]], x2[[j]])
            startFour <- sum(dim1[seq(length.out=(j-1))])+1
            endFour <- sum(dim1[seq(length.out=j)])
            K[startFour:endFour, startThree:endThree] <- t(.multiKernComputeBlock(kern, j, i, x2[[i]], x[[j]]))
          }
        }
    }
  } else {
                                        # non-cell part
    dim1 = dim(as.array(x))[1]
    
    if ( nargs() > 2 ) {
      dim2 = dim(as.array(x2))[1]
    } else {
      dim2 = dim1;
    }
    
    K <- matrix(0, kern$numBlocks*dim1, kern$numBlocks*dim2)
    
    for ( i in seq(length=kern$numBlocks) ) {
      startOne <- (i-1)*dim1 + 1
      endOne <- i*dim1
      startThree <- (i-1)*dim2 + 1
      endThree <- i*dim2
      if ( nargs() < 3 ) {
        K[startOne:endOne, startThree:endThree] <- .multiKernComputeBlock(kern, i, i, x)
      } else {
        K[startOne:endOne, startThree:endThree] <- .multiKernComputeBlock(kern, i, i, x, x2)
      }

      for ( j in seq(length=(i-1)) ) {
        if ( !is.na(kern$block[[i]]$cross[j]) ) {
          startTwo <- (j-1)*dim2 + 1
          endTwo <- j*dim2
          if ( nargs() < 3 ) {
            K[startOne:endOne, startTwo:endTwo] <- .multiKernComputeBlock(kern, i, j, x)
          } else {
            K[startOne:endOne, startTwo:endTwo] <- .multiKernComputeBlock(kern, i, j, x, x2)
          }
          if ( nargs()< 3 ) {
            K[startTwo:endTwo, startOne:endOne] <- t(K[startOne:endOne, startTwo:endTwo])
          } else {
            startFour <- (j-1)*dim1 + 1
            endFour <- j*dim1
            K[startFour:endFour, startThree:endThree] <- t(.multiKernComputeBlock(kern, j, i, x2, x))
          }
        }
      }
    }
  }

  return (K)
}

.multiKernComputeBlock <- function (kern, i, j, x1, x2=NULL) {
  if ( i==j ) {
    funcName <- paste(kern$comp[[i]]$type, "KernCompute", sep="")
    transpose <- 0
    arg1 <- kern$comp[[i]]

    func <- get(funcName, mode="function")
    if (kern$fixBlocks[[i]] && kern$fixBlocks[[j]]) {
      K <- .multiKernCacheBlock(kern, func, i, j, arg1=arg1, x1=x1, x2=x2)
    }
    else {
      if (is.null(x2))
        K <- func(arg1, x1)
      else
        K <- func(arg1, x1, x2)
    }
  } else {

    if ( j<i ) {
      funcName <- paste(kern$block[[i]]$cross[j], "KernCompute", sep="")
      transpose <- kern$block[[i]]$transpose[j]
    } else {
      funcName <- paste(kern$block[[j]]$cross[i], "KernCompute", sep="")
      transpose <- !kern$block[[j]]$transpose[i]
    }

    if ( transpose ) {
      arg1 <- kern$comp[[j]]
      arg2 <- kern$comp[[i]]
    } else {
      arg1 <- kern$comp[[i]]
      arg2 <- kern$comp[[j]]      
    }
    
    func <- get(funcName, mode="function")
    if (kern$fixBlocks[[i]] && kern$fixBlocks[[j]]) {
      K <- .multiKernCacheBlock(kern, func, i, j, arg1=arg1, arg2=arg2, x1=x1, x2=x2)
    }
    else {
      if (is.null(x2))
        K <- func(arg1, arg2, x1)
      else
        K <- func(arg1, arg2, x1, x2)
    }
  }
  return (K)
}



multiKernGradient <- function (kern, x, x2, covGrad) {
  if ( is.list(x) ) {
    if ( (nargs()>3) & !is.list(x2) )
      stop("Time course information is not matched in List format.")

    arg1 <- list()
    arg2 <- list()
    dim1 <- array()
    dim2 <- array()
    for ( i in seq(length=kern$numBlocks) ) {
      dim1[i] <- dim(as.array(x[[i]]))[1]
      arg1[[i]] <- x[[i]]
      if ( nargs()>3 ) {
        dim2[i] <- dim(as.array(x2[[i]]))[1]
        arg2[[i]] <- x2[[i]]
      } else {
        dim2[i] <- dim1[i]
        covGrad <- x2
        arg2[[i]] <- arg1[[i]]
      }
    }

    g <- array(0, dim(kern$paramGroups)[1])
    startVal <- 1
    endVal <- 0

    for ( i in seq(length=kern$numBlocks) ) {
      endVal <- endVal + kern$comp[[i]]$nParams
      startOne <- sum(dim1[seq(length.out=(i-1))])+1
      endOne <- sum(dim1[seq(length.out=i)])
      startThree <- sum(dim2[seq(length.out=(i-1))])+1
      endThree <- sum(dim2[seq(length.out=i)])

      if ( nargs()>3 ) {
        g[startVal:endVal] <- .multiKernGradientBlock(kern, arg1[[i]], arg2[[i]], covGrad[startOne:endOne, startThree:endThree], i, i)
      } else {
        g[startVal:endVal] <- .multiKernGradientBlock(kern, arg1[[i]], covGrad[startOne:endOne, startThree:endThree], i, i)
      }

      startVal2 <- 1
      endVal2 <- 0
      
      for ( j in seq(length.out=(i-1)) ) {
        endVal2 <- endVal2 + kern$comp[[j]]$nParams
        if ( !is.na(kern$block[[i]]$cross[j]) ) {
          startTwo <- sum(dim2[seq(length.out=(j-1))])+1
          endTwo <- sum(dim2[seq(length.out=j)])

          gList <- .multiKernGradientBlock(kern, arg1[[i]], arg2[[j]], covGrad[startOne:endOne, startTwo:endTwo], i, j)

          g[startVal:endVal] <- g[startVal:endVal] + 2*gList$g1
          g[startVal2:endVal2] <- g[startVal2:endVal2] + 2*gList$g2
        }
        startVal2 <- endVal2 + 1
      }
      startVal <- endVal + 1
    }

  } else {   # non-list x
    dim1 <- dim(as.array(x))[1]
    arg1 <- x
    if ( nargs() > 3 ) {
      dim2 <- dim(as.array(x2))[1]
      arg2 <- x2
    } else {
      dim2 <- dim1
      covGrad <- x2
      arg2 <- arg1
    }

    g <- array(0, dim(kern$paramGroups)[1])
    startVal <- 1
    endVal <- 0
    for ( i in seq(length=kern$numBlocks) ) {
      endVal <- endVal + kern$comp[[i]]$nParams
      startOne <- (i-1)*dim1 + 1
      endOne <- i*dim1
      if ( nargs() > 3 ) {
        g[startVal:endVal] <- .multiKernGradientBlock(kern, arg1, arg2, covGrad[startOne:endOne, ((i-1)*dim2+1):(i*dim2)], i, i)
      } else {
        g[startVal:endVal] <- .multiKernGradientBlock(kern, arg1, covGrad[startOne:endOne, ((i-1)*dim2+1):(i*dim2)], i, i)
      }
      
      startVal2 <- 1
      endVal2 <- 0
      
      for ( j in seq(length=(i-1)) ) {
        endVal2 <- endVal2 + kern$comp[[j]]$nParams
        if ( !is.na(kern$block[[i]]$cross[j]) ) {
          startTwo <- (j-1)*dim2 + 1
          endTwo <- j*dim2

          gList <- .multiKernGradientBlock(kern, arg1, arg2, covGrad[startOne:endOne, startTwo:endTwo], i, j)

          g1 <- gList$g1
          g2 <- gList$g2

          if ( nargs() > 3 ) {
            startThree <- (j-1)*dim1 + 1
            endThree <- j*dim1
            gList <- .multiKernGradientBlock(kern, arg2, arg1, t(covGrad[startThree:endThree, startTwo:endTwo]), j, i)

            g3 <- gList$g1
            g4 <- gList$g2
            g[startVal:endVal] <- g[startVal:endVal] + g1 + g4
            g[startVal2:endVal2] <- g[startVal2:endVal2] + g2 + g3
          } else {
            g[startVal:endVal] <- g[startVal:endVal] + 2*g1
            g[startVal2:endVal2] <- g[startVal2:endVal2] + 2*g2           
          }
        }
        startVal2 <- endVal2 + 1
      }
      startVal <- endVal + 1
    }
  }

  g <- (g %*% kern$paramGroups)[1,]
  return (g)
}



.multiKernGradientBlock <- function (kern, x, x2, covGrad, i, j) {
  if ( nargs()<6 ) {
    j <- i
    i <- covGrad
    covGrad <- x2
    x2 <- array()
  }

  if (kern$fixBlocks[[i]] && kern$fixBlocks[[j]]) {
    if (i==j)
      return (0)
    else
      return (list(g1=0, g2=0))
  }

  if ( i==j ) {
    funcName <- paste(kern$comp[[i]]$type, "KernGradient", sep="")
    transpose <- 0
    arg1 <- kern$comp[[i]]
    factors <- .kernFactors(kern$comp[[i]], "gradfact")

    func <- get(funcName, mode="function")

    if ( is.na(x2) ) {
      g <- func(arg1, x, covGrad)
    } else {
      g <- func(arg1, x, x2, covGrad)
    }
    for (i in seq(along=factors))
      g[factors[[i]]$index] <- g[factors[[i]]$index]*factors[[i]]$val
    
  } else {
    if ( j<i ) {
      funcName <- paste(kern$block[[i]]$cross[j], "KernGradient", sep="")
      transpose <- kern$block[[i]]$transpose[j]
    } else {
      funcName <- paste(kern$block[[j]]$cross[i], "KernGradient", sep="")
      transpose <- kern$block[[j]]$transpose[i]
    }

    if ( transpose ) {
      arg1 <- kern$comp[[j]]
      factors1 <- .kernFactors(kern$comp[[j]], "gradfact")
      arg2 <- kern$comp[[i]]
      factors2 <- .kernFactors(kern$comp[[i]], "gradfact")
    } else {
      arg1 <- kern$comp[[i]]
      factors1 <- .kernFactors(kern$comp[[i]], "gradfact")      
      arg2 <- kern$comp[[j]]
      factors2 <- .kernFactors(kern$comp[[j]], "gradfact")
    }

    func <- get(funcName, mode="function")
    if ( any(is.na(x2)) ) {
      gList <- func(arg1, arg2, x, covGrad)
    } else {
      gList <- func(arg1, arg2, x, x2, covGrad)
    }

    g1 <- gList$g1
    g2 <- gList$g2
    
    for (i in seq(along=factors1))
      g1[factors1[[i]]$index] <- g1[factors1[[i]]$index]*factors1[[i]]$val

    for (i in seq(along=factors2))
      g2[factors2[[i]]$index] <- g2[factors2[[i]]$index]*factors2[[i]]$val

    if ( transpose ) {
      g <- g2
      g2 <- g1
      g1 <- g
    }
    g <- list(g1=g1, g2=g2)   
    
  }
  return (g)
}



multiKernDiagCompute <- function (kern, x) {
  if ( is.list(x) ) {
    xdim <- 0
    for ( i in seq_along(x) )
      xdim <- xdim + dim(as.array(x[[i]]))[1]

    k <- matrix(0, xdim, 1)
    startVal <- 1
    endVal <- dim(as.array(x[[1]]))[1]
    for ( i in seq(along=kern$comp) ) {

      k[startVal:endVal] <- kernDiagCompute(kern$comp[[i]], x[[i]])
      startVal <- endVal + 1
      if ( (i+1)<=length(kern$comp) )
        endVal <- endVal + dim(as.array(x[[i+1]]))[1]
    }
  } else {
    xdim <- dim(as.array(x))[1]
    k <- array(0, xdim*kern$numBlocks)
    startVal <- 1
    endVal <- xdim
    for ( i in seq(along=kern$comp) ) {
      k[startVal:endVal] <- kernDiagCompute(kern$comp[[i]], x)
      startVal <- endVal + 1
      endVal <- endVal + xdim
    }
  }

  return (k)
}


.multiKernCacheBlock <- function(kern, fhandle, i, j, x1, x2=NULL, arg1, arg2=NULL) {

  global_cache <- get("cache", envir = kern$cache)
  if ((length(global_cache) >= i) && (length(global_cache[[i]]) >= j))
    cache <- global_cache[[i]][[j]]
  else
    cache <- list()
  key <- c(x1, x2)

  for (k in seq(along=cache)) {
    if (length(key) == length(cache[[k]]$key) && all(key == cache[[k]]$key)) {
      #cat("multiKernCacheBlock: cache hit ", i, j, x1, x2, "\n")
      return (cache[[k]]$value)
    }
  }

  #cat("multiKernCacheBlock: cache miss ", i, j, x1, x2, "\n")
  # No match if we get all the way here
  if (is.null(arg2)) {
    if (is.null(x2))
      K <- fhandle(arg1, x1)
    else
      K <- fhandle(arg1, x1, x2)
  }
  else {
    if (is.null(x2))
      K <- fhandle(arg1, arg2, x1)
    else
      K <- fhandle(arg1, arg2, x1, x2)
  }
  cache <- append(cache, list(list(key=key, value=K)))
  if (length(global_cache) < i)
    global_cache[[i]] <- list()
  global_cache[[i]][[j]] <- cache
  assign("cache", global_cache, envir=kern$cache)
  return(K)
}

GPLearn <- function(preprocData, TF = NULL, targets = NULL,
                    useGpdisim = !is.null(TF), randomize = FALSE,
                    addPriors = FALSE, fixedParams = FALSE,
                    initParams = NULL, initialZero = TRUE,
                    fixComps = NULL, dontOptimise = FALSE,
                    allowNegativeSensitivities = FALSE, quiet = FALSE,
                    gpsimOptions = NULL, allArgs = NULL) {

  if (!is.null(allArgs)) {
    for (i in seq(along=allArgs))
      assign(names(allArgs)[[i]], allArgs[[i]])
  }

  if (class(preprocData) != "ExpressionTimeSeries")
    stop("preprocData should be an instance of ExpressionTimeSeries. Please use processData or processRawData to create one.")

  if (is.null(targets))
    stop("no target genes specified, unable to define a model")

  if (is.list(targets))
    targets <- unlist(targets)
  
  if (useGpdisim)
    genes <- c(TF, targets)
  else
    genes <- targets

  if (class(try(preprocData[genes,], silent=TRUE)) == "try-error") {
    if (! all(TF %in% featureNames(preprocData))) {
      stop("unknown TF")
    } else {
      stop("unknown target gene")
    }
  }

  # The preprocessed data is searched for the data of the specified genes.
  newData <- .getProcessedData(preprocData[genes,])
  y <- newData$y
  yvar <- newData$yvar
  times <- newData$times

  Nrep <- length(y)

  options <- list(includeNoise=0, optimiser="SCG")

  if (any(yvar[[1]] == 0))
    options$includeNoise = 1
  
  if (!is.null(gpsimOptions)) {
    for (i in seq(along=gpsimOptions))
      options[[names(gpsimOptions)[[i]]]] <- gpsimOptions[[i]]
  }
  
  if (addPriors)
    options$addPriors <- TRUE

  if (!initialZero && useGpdisim)
    options$timeSkew <- 1000.0
  #options$gaussianInitial <- TRUE

  if (useGpdisim) {
    Ngenes <- length(genes) - 1
    options$fix$names <- "di_variance"
    options$fix$value <- expTransform(c(1), "xtoa")
  }
  else {
    Ngenes <- length(genes)
    if (allowNegativeSensitivities) {
      options$fix$names <- "sim1_sensitivity"
      options$fix$value <- 1
    }
    else {
      options$fix$names <- "sim1_variance"
      options$fix$value <- expTransform(c(1), "xtoa")
    }
  }
  Ntf <- 1

  if (initialZero && !useGpdisim) {
    options$proteinPrior <- list(values=array(0), times=array(0))

    ## Set the variance of the latent function to 1.
    options$fix$names <- append(options$fix$names, "rbf1_variance")
    options$fix$value <- append(options$fix$value, expTransform(1, "xtoa"))
  }
  
  # fixing first output sensitivity to fix the scaling
  if (fixedParams && !is.null(initParams)) {
    if (is.list(initParams))
      initParams <- unlist(initParams)
    if (!is.null(names(initParams))) {
      options$fix$names <- names(initParams)
      options$fix$value <- initParams
    }
    else {
      I <- which(!is.na(initParams))
      for (k in 1:length(I)) {
        options$fix$index[k+1] <- I[k]
        options$fix$value[k+1] <- initParams[I[k]]
      }
    }      
  }

  if (! is.null(fixComps))
    options$fixedBlocks <- fixComps

  if (allowNegativeSensitivities)
    options$isNegativeS <- TRUE
  
  # initializing the model
  if (useGpdisim)
    model <- list(type="cgpdisim")
  else
    model <- list(type="cgpsim")

  if (length(annotation(preprocData)) > 0)
    dataAnnotation <- annotation(preprocData)
  else
    dataAnnotation <- NULL

  for ( i in seq(length=Nrep) ) {
    #repNames <- names(model$comp)
    if (useGpdisim) {
      model$comp[[i]] <- gpdisimCreate(Ngenes, Ntf, times, t(y[[i]]), t(yvar[[i]]), options, genes = featureNames(preprocData[genes,]), annotation=dataAnnotation)
    }
    else {
      model$comp[[i]] <- gpsimCreate(Ngenes, Ntf, times, t(y[[i]]), t(yvar[[i]]), options, genes = featureNames(preprocData[genes,]), annotation=dataAnnotation)
    }
    #names(model$comp) <- c(repNames, paste("rep", i, sep=""))
    #if (fixedParams) {
    #  model$comp[[i]]$kern <- multiKernFixBlocks(model$comp[[i]]$kern, fixComps)
    #}
  }

  optOptions <- optimiDefaultOptions()

  optOptions$maxit <- 3000
  optOptions$optimiser <- "SCG"
  if (quiet)
    optOptions$display <- FALSE

  if (randomize) {
    a <- modelExtractParam(model)
    #I <- a==0
    n <- length(a)
    a <- array(rnorm(n), dim = c(1, n))
    #a[I] <- 0
    model <- modelExpandParam(model, a)
  }

  if (!is.null(initParams)) {
    if (!is.list(initParams) && all(is.finite(initParams))
        && is.null(names(initParams)))
      model <- modelExpandParam(model, initParams)
    else if (!is.null(names(initParams))) {
      params <- modelExtractParam(model, only.values=FALSE)
      for (i in seq(along=initParams)) {
        j <- grep(names(initParams)[i], names(params))
        if (length(j) > 0)
          params[j] <- initParams[i]
        else
          warning(paste("Ignoring invalid initial parameter specification:", initParams$names[i]))
      }
      model <- modelExpandParam(model, params)
    }
  }

  if (!dontOptimise) {
    if (useGpdisim) {
      message(paste(c("Optimising the model.\nTF: ", TF, "\nTargets: ", paste(targets, collapse=' '), "\n"), sep=" "))
    } else {
      message(paste(c("Optimising the model.\nTargets: ", paste(genes, collapse=' '), "\n"), sep=" "))
    }
    model <- modelOptimise(model, optOptions)
  }

  model <- modelUpdateProcesses(model)

  model$allArgs <- list(TF=TF, targets=targets, useGpdisim=useGpdisim,
                        randomize=randomize, addPriors=addPriors,
                        fixedParams=fixedParams, initParams=initParams,
                        initialZero=initialZero, fixComps=fixComps,
                        dontOptimise=dontOptimise, gpsimOptions=gpsimOptions)

  return (new("GPModel", model))
}



GPRankTargets <- function(preprocData, TF = NULL, knownTargets = NULL,
                          testTargets = NULL, filterLimit = 1.8,
                          returnModels = FALSE, options = NULL,
                          scoreSaveFile = NULL,
                          datasetName = "", experimentSet = "") {

  if (class(preprocData) != "ExpressionTimeSeries")
    stop("preprocData should be an instance of ExpressionTimeSeries. Please use processData or processRawData to create one.")

  if (is.null(testTargets))
    testTargets <- featureNames(preprocData)

  if (is.list(testTargets))
    testTargets <- unlist(testTargets)

  if (is.list(knownTargets))
    knownTargets <- unlist(knownTargets)
  
  if (!is.null(TF) && !all(TF %in% featureNames(preprocData))) {
    stop("unknown TF")
  }
  
  if (!all(knownTargets %in% featureNames(preprocData))) {
    stop("unknown genes in knownTargets")
  }
  
  if (class(try(preprocData[testTargets,], silent=TRUE)) == "try-error") {
    stop("unknown genes in testTargets")
  }
  
  if ('var.exprs' %in% assayDataElementNames(preprocData))
    testTargets <- .filterTargets(preprocData[testTargets,], filterLimit)
  else
    testTargets <- featureNames(preprocData[testTargets,])

  if (length(testTargets) < 1)
    stop("No test targets passed filtering")
  
  # The variable useGpdisim determines whether GPDISIM is used in creating the 
  # models. GPSIM (default) is used if no TF has been specified.
  useGpdisim = !is.null(TF)

  if (!useGpdisim && is.null(knownTargets))
    stop("There are no known targets for GPSIM.")

  if (useGpdisim)
    numberOfKnownGenes <- length(knownTargets) + 1
  else
    numberOfKnownGenes <- length(knownTargets)

  logLikelihoods <- rep(NA, length.out=length(testTargets))
  baselogLikelihoods <- rep(NA, length.out=length(testTargets))
  modelParams <- list()
  modelArgs <- list()
  if (returnModels)
    rankedModels <- list()

  genes <- list()

  if (!is.null(options)) {
    allArgs <- options
    allArgs$useGpdisim <- useGpdisim
  }
  else
    allArgs <- list(useGpdisim=useGpdisim)

  if (!is.null(knownTargets) && length(knownTargets) > 0) {
    baselineModel <- .formModel(preprocData, TF, knownTargets, allArgs=allArgs)
    baselineParameters <- modelExtractParam(baselineModel$model,
                                            only.values=FALSE)
    sharedModel <- list(ll=baselineModel$ll,
                        params=baselineModel$params,
                        args=modelStruct(baselineModel$model)$allArgs)

    allArgs$fixedParams <- TRUE
    allArgs$initParams <- baselineParameters
    J <- grep('Basal', names(allArgs$initParams))
    names(allArgs$initParams)[J] <-
      paste(names(allArgs$initParams)[J], '$', sep='')
    allArgs$fixComps <- 1:numberOfKnownGenes
  }
  else {
    baselineModel <- NULL
  }

  for (i in seq(along=testTargets)) {
    returnData <- .formModel(preprocData, TF, knownTargets,
                            testTargets[i], allArgs = allArgs)

    if (!is.finite(returnData$ll)) {
      logLikelihoods[i] <- NA
      modelParams[[i]] <- NA
      modelArgs[[i]] <- NA
      if (returnModels)
        rankedModels[[i]] <- NA
    }
    else {
      logLikelihoods[i] <- returnData$ll
      modelParams[[i]] <- returnData$params
      modelArgs[[i]] <- modelStruct(returnData$model)$allArgs
      if (returnModels)
        rankedModels[[i]] <- returnData$model
    }
    genes[[i]] <- testTargets[[i]]

    testdata <- preprocData[testTargets[i],]
    testdata$experiments <- rep(1, length(testdata$experiments))
    newData <- .getProcessedData(testdata)
    baselogLikelihoods[i] <- .baselineOptimise(newData$y[[1]], newData$yvar[[1]], list(includeNoise=(any(newData$yvar[[1]]==0))))

    if (!is.null(scoreSaveFile)) {
      scoreList <- new("scoreList", params = modelParams,
                       loglikelihoods = logLikelihoods,
                       baseloglikelihoods = baselogLikelihoods,
                       genes = genes, modelArgs = modelArgs,
                       knownTargets = knownTargets, TF = TF,
                       sharedModel = sharedModel,
                       datasetName = datasetName,
                       experimentSet = experimentSet)
      save(scoreList, file=scoreSaveFile)
    }
  }

  scoreList <- new("scoreList", params = modelParams,
                   loglikelihoods = logLikelihoods,
                   baseloglikelihoods = baselogLikelihoods,
                   genes = genes, modelArgs = modelArgs,
                   knownTargets = knownTargets, TF = TF,
                   sharedModel = sharedModel,
                   datasetName = datasetName,
                   experimentSet = experimentSet)

  if (returnModels)
    return (list(scores=scoreList, models=rankedModels))
  else
    return (scoreList)
}



GPRankTFs <- function(preprocData, TFs, targets,
                      filterLimit = 1.8, 
                      returnModels = FALSE, options = NULL,
                      scoreSaveFile = NULL,
                      datasetName = "", experimentSet = "") {
  if (class(preprocData) != "ExpressionTimeSeries")
    stop("preprocData should be an instance of ExpressionTimeSeries. Please use processData or processRawData to create one.")

  if (is.null(targets)) stop("No targets specified.")

  if (is.list(targets))
    targets <- unlist(targets) 

  numberOfTargets <- length(targets)

  genes = c(TFs, targets)

  if (class(try(preprocData[TFs,], silent=TRUE)) == "try-error") {
    stop("unknown genes in TFs")
  }

  if (!all(targets %in% featureNames(preprocData))) {
    stop("unknown genes in targets")
  }
  
  ## Filtering the genes based on the calculated ratios. If the limit is 0, all genes are accepted.
  if ('var.exprs' %in% assayDataElementNames(preprocData))
    TFs <- .filterTargets(preprocData[TFs,], filterLimit)
  else
    TFs <- featureNames(preprocData[TFs,])

  if (length(TFs) < 1)
    stop("No TFs passed the filtering.")

  logLikelihoods <- rep(NA, length.out=length(TFs))
  modelParams <- list()
  modelArgs <- list()
  if (returnModels)
    rankedModels <- list()

  if (!is.null(options)) {
    allArgs <- options
    allArgs$useGpdisim <- TRUE
  }
  else
    allArgs <- list(useGpdisim=TRUE)

  numberOfTargets <- length(targets)

  genes <- list()

  for (i in 1:length(TFs)) {
    returnData <- .formModel(preprocData, TF = TFs[i], targets, allArgs=allArgs)
    if (!is.finite(returnData$ll)) {
      logLikelihoods[i] <- NA
      modelParams[[i]] <- NA
      modelArgs[[i]] <- NA
      if (returnModels)
        rankedModels[[i]] <- NA
    }
    else {
      logLikelihoods[i] <- returnData$ll
      modelParams[[i]] <- returnData$params
      modelArgs[[i]] <- modelStruct(returnData$model)$allArgs
      if (returnModels)
        rankedModels[[i]] <- returnData$model
    }
    genes[[i]] <- TFs[[i]]

    if (!is.null(scoreSaveFile)) {
      scoreList <- new("scoreList", params = modelParams,
                       loglikelihoods = logLikelihoods,
                       genes = genes, modelArgs = modelArgs,
                       knownTargets = targets, TF = '(see genes)',
                       datasetName = datasetName,
                       experimentSet = experimentSet)
      save(scoreList, file=scoreSaveFile)
    }
  }

  scoreList <- new("scoreList", params = modelParams,
                   loglikelihoods = logLikelihoods,
                   genes = genes, modelArgs = modelArgs,
                   knownTargets = targets, TF = '(see genes)',
                   datasetName = datasetName,
                   experimentSet = experimentSet)

  if (returnModels)
    return (list(scores=scoreList, models=rankedModels))
  else
    return (scoreList)
}



.formModel <- function(preprocData, TF = NULL, knownTargets = NULL,
                       testTarget = NULL, allArgs = NULL) {

  if (!is.null(testTarget))
    targets <- append(knownTargets, testTarget)
  else
    targets <- knownTargets

  error1 <- TRUE
  error2 <- TRUE

  tryCatch({
    model <- GPLearn(preprocData, TF, targets, allArgs = allArgs)
    error1 <- FALSE
  }, error = function(ex) {
    warning("Stopped due to an error.\n")
  })

  if (error1) {
    success <- FALSE
    i <- 0
    allArgs$randomize <- TRUE
    while (!success && i < 10) {
      tryCatch({
        message("Trying again with different parameters.\n")
        model <- GPLearn(preprocData, TF, targets, allArgs = allArgs)
        success <- TRUE
        error2 <- FALSE
      }, error = function(ex) {
        warning("Stopped due to an error.\n")
      })
      i <- i + 1
    }
  }
  else {
    error2 <- FALSE
  }

  if (error2) {
    logLikelihood <- -Inf
    params <- NA
    rankedModel <- NA
  }
  else {
    logLikelihood <- modelLogLikelihood(model)
    params <- modelExtractParam(model)
    rankedModel <- model
  }

  return (list(ll=logLikelihood, model=rankedModel, params=params))
}


generateModels <- function(preprocData, scores) {
  models <- list()

  # recreate the models for each gene in the scoreList
  for (i in seq(along=params(scores))) {
    args <- modelArgs(scores)[[i]]
    args$initParams <- params(scores)[[i]]
    args$dontOptimise <- TRUE
    models[[i]] <- GPLearn(preprocData, allArgs=args)
  }

  return (models)
}


.getProcessedData <- function(data) {
  times <- data$modeltime
  experiments <- data$experiments

  y <- assayDataElement(data, 'exprs')
  if ('var.exprs' %in% assayDataElementNames(data))
    yvar <- assayDataElement(data, 'var.exprs')
  else
    yvar <- 0 * y

  scale <- sqrt(rowMeans(y^2))
  scale[scale==0] <- 1
  scaleMat <- scale %*% array(1, dim = c(1, ncol(data)))
  y <- y / scaleMat
  yvar <- yvar / scaleMat^2

  ylist <- list()
  yvarlist <- list()

  expids <- unique(experiments)
  for (i in seq(along=expids)) {
    ylist[[i]] <- y[,experiments==expids[i], drop=FALSE]
    yvarlist[[i]] <- yvar[,experiments==expids[i], drop=FALSE]
  }
  times <- times[experiments==expids[1]]

  genes <- featureNames(data)

  newData <- list(y = ylist, yvar = yvarlist, genes = genes, times = times)
  return (newData)
}



.filterTargets <- function(data, filterLimit) {
  y <- assayDataElement(data, 'exprs')
  yvar <- assayDataElement(data, 'var.exprs')

  zScores <- rowMeans(y / sqrt(yvar))
  testTargets <- names(which(zScores > filterLimit))

  return (testTargets)
}

processData <- function(data, times = NULL, experiments = NULL, do.normalisation=TRUE) {
  if (class(data) == "exprReslt") {
    if (!requireNamespace("puma", quietly = TRUE)) {
      stop("tigre:processData: puma package required to process exprReslt objects")
    }

    yFull <- exprs(data)
    genes <- featureNames(data)

    if (is.null(times)) {
      times <- pData(data)[,grep('time', colnames(pData(data)))]
    }

    numberOfRows <- length(genes)
    numberOfColumns <- length(colnames(exprs(data)))

    if (numberOfRows < 100) {
      warning('processData: < 100 genes in data set, turning off normalisation')
      do.normalisation <- FALSE
    }
  
    if (is.null(experiments))
      experiments <- rep(1, numberOfColumns)
  
    normalisation <- array(0, dim = c(1, numberOfColumns))

    if (do.normalisation) {
      normalisation <- colMeans(yFull)
      normalisation <- normalisation - mean(normalisation)

      ## The default operation of sweep is "-".
      yFull <- sweep(yFull, 2, normalisation)
    }

    pcts <- array(dim = c(numberOfRows, numberOfColumns, 5))

    ## Loading the percentiles 5, 25, 50, 75 and 95.
    pcts[,,1] <- puma::prcfive(data)
    pcts[,,2] <- puma::prctwfive(data)
    pcts[,,3] <- puma::prcfifty(data)
    pcts[,,4] <- puma::prcsevfive(data)
    pcts[,,5] <- puma::prcninfive(data)

    ## normalising the percentiles
    for (i in 1:5) {
      pcts[,,i] <- sweep(pcts[,,i], 2, normalisation)
    }

    yFullVar <- array(dim = c(numberOfRows, numberOfColumns))

    for (i in 1:numberOfRows) {
      cat("Processing gene ", i, "/", numberOfRows, "\r", sep="")
      prof <- pcts[i,,]
      for (j in 1:numberOfColumns) {
        t <- .distfit(exp(prof[j, ]), 'normal')
        yFull[i, j] <- t$par[1]
        yFullVar[i, j] <- t$par[2] ^ 2
      }
    }
    cat("\n")
  
    rownames(yFullVar) <- rownames(yFull)
    colnames(yFullVar) <- colnames(yFull)
  }
  else if (class(data) == 'LumiBatch') {
    if (!requireNamespace("lumi", quietly = TRUE)) {
      stop("tigre:processData: lumi package required to process LumiBatch objects")
    }

    yFull <- exprs(data)
    genes <- featureNames(data)

    if (is.null(times)) {
      times <- pData(data)[,grep('time', colnames(pData(data)))]
    }

    numberOfRows <- length(genes)
    numberOfColumns <- length(colnames(exprs(data)))

    if (numberOfRows < 100) {
      warning('processData: < 100 genes in data set, turning off normalisation')
      do.normalisation <- FALSE
    }
  
    if (is.null(experiments))
      experiments <- rep(1, numberOfColumns)
  
    normalisation <- array(0, dim = c(1, numberOfColumns))

    if (do.normalisation) {
      normalisation <- colMeans(log(yFull))
      normalisation <- normalisation - mean(normalisation)

      yFull <- sweep(yFull, 2, exp(normalisation), '/')
      yFullVar <- sweep(lumi::se.exprs(data), 2, exp(normalisation), '/')
    } else {
      yFullVar <- lumi::se.exprs(data)
    }
     yFullVar <- yFullVar^2
  }
  else {
    stop("tigre:processData: Unknown data format")
  }
  
  pData <- phenoData(data)
  pData[['experiments', labelDescription='experiment ID']] <- experiments
  pData[['modeltime', labelDescription='modeltimes']] <- times
  
  return (new("ExpressionTimeSeries", exprs = yFull, var.exprs = yFullVar, 
              annotation=annotation(data), phenoData=pData,
              featureData=featureData(data),
              experimentData=experimentData(data)))
}


processRawData <- function(rawData, times, experiments=NULL, is.logged=TRUE,
                           do.normalisation=ifelse(is.logged, TRUE, FALSE)) {
  data <- rawData
  yFull <- as.matrix(data)
  genes <- rownames(data)

  numberOfRows <- length(genes)
  numberOfColumns <- length(colnames(data))

  if (is.null(experiments))
    experiments <- rep(1, numberOfColumns)
  
  # No normalisation for non-logged values for now
  if (is.logged) {
    if (do.normalisation) {
      normalisation <- colMeans(yFull)
      normalisation <- normalisation - mean(normalisation)

      # The default operation of sweep is "-".
      yFull <- sweep(yFull, 2, normalisation)
    }

    yFull <- exp(yFull)
  }
  else {
    if (do.normalisation) {
      normalisation <- colMeans(log(yFull))
      normalisation <- normalisation - mean(normalisation)

      yFull <- sweep(yFull, 2, exp(normalisation), '/')
    }
  }

  pData <- data.frame(experiments=experiments, modeltime=times)
  rownames(pData) <- colnames(data)
  metadata <- data.frame(labelDescription = c("experiment ID", "modeltimes"),
                         row.names = c("experiments", "modeltime"))
  phenoData <- new("AnnotatedDataFrame", data=pData, varMetadata=metadata)
  return (new("ExpressionTimeSeries", assayData=assayDataNew(exprs = yFull),
              phenoData=phenoData))
}

mlpKernParamInit <- function (kern) {
  kern$weightVariance <- 10
  kern$biasVariance <- 10
  kern$variance <- 1
  kern$nParams <- 3

  kern$transforms <- list(list(index=c(1,2,3), type="positive"))

  kern$isStationary <- FALSE

  return (kern)
}



# untransformed.values is ignored
mlpKernExtractParam <- function (kern, only.values=TRUE,
                                 untransformed.values=TRUE) {
  params <- c(kern$weightVariance, kern$biasVariance, kern$variance)

  if ( !only.values )
    names(params) <- c("weightVariance", "biasVariance", "variance")

  if ( any(is.na(params)) )
    warning("params are infinite")

  return (params)
}



mlpKernExpandParam <- function (kern, params) {
  if ( is.list(params) )
    params <- params$values

  if ( any(is.na(params)) )
    warning("params are infinite")

  kern$weightVariance <- params[1]
  kern$biasVariance <- params[2]
  kern$variance <- params[3]

  return (kern)
}



mlpKernCompute <- function (kern, x, x2=NULL, option=1) {
 
  if ( (nargs()<3) | (nargs()==4 & is.null(x2)) ) {
    innerProd <- x %*% t(x)
    numer <- innerProd*kern$weightVariance + kern$biasVariance
    vec <- diag(numer) + 1
    denom <- sqrt(vec %*% t(vec))
    arg <- numer/denom
    k <- kern$variance*asin(arg)
  } else {
    innerProd <- x %*% t(x2)
    numer <- innerProd*kern$weightVariance + kern$biasVariance
    vec1 <- apply(as.matrix(x)*as.matrix(x), 1, sum) * kern$weightVariance + kern$biasVariance + 1
    vec2 <- apply(as.matrix(x2)*as.matrix(x2), 1, sum) * kern$weightVariance + kern$biasVariance + 1
    denom <- sqrt(vec1 %*% t(vec2))
    arg <- numer/denom
    k <- kern$variance*asin(arg)
  }

  if ( option == 2 )
    k <- list(k=k, innerProd=innerProd, arg=arg, denom=denom, numer=numer)

  return (k)
}



mlpKernGradient <- function (kern, x, x2, covGrad) {

  if ( nargs()==3 ) {
    mlpK <- mlpKernCompute(kern, x, NULL, 2)
    k <- mlpK$k
    innerProd <- mlpK$innerProd
    arg <- mlpK$arg
    denom <- mlpK$denom
    numer <- mlpK$numer
    covGrad <- x2
  } else if ( nargs()==4 ) {
    mlpK <- mlpKernCompute(kern, x, x2, 2)
    k <- mlpK$k
    innerProd <- mlpK$innerProd
    arg <- mlpK$arg
    denom <- mlpK$denom
    numer <- mlpK$numer
  }

  denom3 <- denom*denom*denom
  base <- kern$variance/sqrt(1-arg*arg)
  baseCovGrad <- base*covGrad

  g <- array(0,3)
  if ( nargs()==3 ) {
    vec <- diag(innerProd)
    g[1] <- sum((innerProd/denom-0.5*numer/denom3*((kern$weightVariance*vec+kern$biasVariance+1)%*%t(vec)+vec%*%t(kern$weightVariance*vec+kern$biasVariance+1)))*baseCovGrad)
    g[2] <- sum((1/denom-0.5*numer/denom3*(matrix(rep(vec, times=length(vec)), length(vec), length(vec))*kern$weightVariance+2*kern$biasVariance+2+matrix(rep(vec, each=length(vec)), length(vec), length(vec))*kern$weightVariance))*baseCovGrad)
  } else {
    vec1 <- apply(x*x, 1, sum)
    vec2 <- apply(x2*x2, 1, sum)
    g[1] <- sum((innerProd/denom-0.5*numer/denom3*((kern$weightVariance*vec1+kern$biasVariance+1)*t(vec2)+vec1*t(kern$weightVariance*vec2+kern$biasVariance+1)))*baseCovGrad)
    g[2] <- sum((1/denom-0.5*numer/denom3*(t(matrix(rep(vec1, each=length(vec2)), length(vec2), length(vec1)))*kern$weightVariance+2*kern$biasVariance+2+matrix(rep(vec2, each=length(vec1)), length(vec1), length(vec2))*kern$weightVariance))*baseCovGrad)
  }

  g[3] <- sum(k/kern$variance*covGrad)

  if ( any(is.na(g)) )
    warning("g is NA.")

  return (g)
}



mlpKernDiagGradX <- function (kern, X) {
  gX <- array(0, dim=dim(as.matrix(X)))
  for ( i in seq(length=dim(X)[1]) ) {
    gX[i,] <- .mlpKernDiagGradXpoint(kern, as.matrix(X)[i,])
  }

  return (gX)
}



.mlpKernDiagGradXpoint <- function (kern, x) {
  x <- as.matrix(x)
  innerProd <- x %*% t(x)
  numer <- innerProd*kern$weightVariance + kern$biasVariance
  demon <- numer + 1
  arg <- numer / demon
  gX <- array(0, dim = dim(x))
  for ( j in seq(length=dim(x)[2]) ) {
    gX[,j] <- 1/demon - numer/demon^2
    gX[,j] <- ((2*x[,j]*kern$weightVariance*kern$variance) %*% gX[,j] )/sqrt(1-arg*arg)
  }

  return (gX)
}



mlpKernGradX <- function (kern, X, X2) {
  gX <- array(0, dim=c(dim(as.matrix(X2)), dim(X)[1]))
  for ( i in seq(length=dim(X)[1]) ) {
    gX[,,i] <- .mlpKernGradXpoint(kern, as.matrix(X)[i,], X2)
  }

  return (gX)
}



.mlpKernGradXpoint <- function (kern, x, X2) {
  x <- as.matrix(x)
  X2 <- as.matrix(X2)
  innerProd <- X2 %*% t(x)
  numer <- innerProd*kern$weightVariance + kern$biasVariance
  vec1 <- apply(x*x, 1, sum)*kern$weightVariance + kern$biasVariance + 1
  vec2 <- apply(X2*X2, 1, sum)*kern$weightVariance + kern$biasVariance + 1
  demon <- sqrt(vec2 %*% t(vec1))
  arg <- numer / demon
  gX <- array(0, dim = dim(X2))
  for ( j in seq(length=dim(X2)[2]) ) {
    gX[,j] <- X2[,j]/demon - vec2*x[,j]*numer/demon^3
    gX[,j] <- kern$weightVariance*kern$variance*gX[,j]/sqrt(1-arg*arg)
  }

  return (gX)
}

expTransform <- function (x, transform="atox") {

  eps <- 2.2204e-16
  maxVal <- 4.3112e+15

  thre <- 36	## threshold
  y <- array(0, dim(as.array(x)))

  if ( "atox" == transform ) {
    for ( ind in seq_along(as.array(x)) ) {
      if ( x[ind] > thre ) y[ind] <- maxVal else
      if ( x[ind] < -thre ) y[ind]<- eps else
      y[ind] <- exp(x[ind])
    }
  } else if ( "xtoa" == transform ) {
    for ( ind in seq_along(as.array(x)) ) {
      y[ind] <- .complexLog(x[ind])
    }
  } else if ( "gradfact" == transform )
    y <- x

  return (y)
}


sigmoidTransform <- function (x, transform="atox") {

  eps <- 2.2204e-16

  thre <- 36	## threshold
  y <- array(0, dim(as.array(x)))

  if ( "atox" == transform ) {
    for ( ind in seq_along(as.array(x)) ) {
      if ( x[ind] > thre )
        y[ind] <- 1-eps
      else if ( x[ind] < -thre )
        y[ind]<- eps
      else
        y[ind] <- 1/(1+exp(-x[ind]))
    }
  } else if ( "xtoa" == transform ) {
    for ( ind in seq_along(as.array(x)) ) {
      y[ind] <- .complexLog(x[ind]/(1-x[ind]))
    }
  } else if ( "gradfact" == transform )
    y <- x*(1-x)

  return (y)
}


boundedTransform <- function (x, transform="atox", bounds) {

  eps <- 2.2204e-16

  thre <- 36	## threshold
  y <- array(0, dim(as.array(x)))

  if ( "atox" == transform ) {
    for ( ind in seq_along(as.array(x)) ) {
      if ( x[ind] > thre )
        y[ind] <- 1-eps
      else if ( x[ind] < -thre )
        y[ind] <- eps
      else
        y[ind] <- 1/(1+exp(-x[ind]))
    }
    y <- (bounds[2] - bounds[1])*y + bounds[1]
  } else if ( "xtoa" == transform ) {
    x <- (x - bounds[1]) / (bounds[2] - bounds[1])
    for ( ind in seq_along(as.array(x)) ) {
      y[ind] <- .complexLog(x[ind]/(1-x[ind]))
    }
  } else if ( "gradfact" == transform ) {
    y <- (x-bounds[1])*(1-(x-bounds[1])/(bounds[2] - bounds[1]))
  }

  return (y)
}


modelTieParam <- function (model, paramsList) {
  columnToDel <- c()

  if ( !is.list(paramsList) ) {
    paramsList <- list(paramsList)
  }

  params <- try(modelExtractParam(model, only.values=FALSE), TRUE)
  if (! is.list(params) )
    params <- kernExtractParam(model, only.values=FALSE)
  
  for ( i in seq(along=paramsList) ) {
    if ( is.character(paramsList[[i]]) ) {
      paramInd <- grep(paramsList[[i]], names(params))
      if ( length(paramInd) == 0 )
        warning(paste("No matches for parameter tie spec:", paramsList[[i]]))
    }
    else {
      paramInd <- sort(paramsList[[i]])

      if ( any(paramInd[1]==columnToDel) )
        stop("Parameters have already been tied.")
    }

    if ( length(paramInd) > 1 )
      for ( j in seq(2,length.out=(length(paramInd)-1)) ) {
        model$paramGroups[paramInd[j], paramInd[1]] <- 1
        if ( any(paramInd[j]==columnToDel) )
          stop("Parameters have already been tied.")
        columnToDel <- c(columnToDel, paramInd[j])
      }
  }

  if (length(columnToDel) > 0)
    model$paramGroups <- model$paramGroups[,-columnToDel]

  if ( "nParams" %in% names(model) ) {
    model$nParams <- dim(model$paramGroups)[2]
  } else if ( "numParams" %in% names(model) ) {
    model$numParams <- dim(model$paramGroups)[2]
  }

  return (model)
}

.jitChol <- function ( M, Num=10, silent=FALSE ) {
  jitter <- 0
  jitter1 <- abs(mean(diag(M)))*1e-6
  eyeM <- diag( 1, nrow=length(M[,1]), ncol=length(M[1,]) )

  for ( i in 1:Num ) {
    ## clear the last error message
    try(stop(""),TRUE)
    ow <- options("warn")
    options(warn=2)

    Ch <- try( chol( M + jitter*eyeM ), silent=TRUE )

    options(ow)
    nPos <- grep("not positive definite",  geterrmessage())

    if ( length(nPos) != 0 ) {
      jitter1 <- jitter1*10
      jitter <- jitter1

      if (! silent) {
        warnmsg <- paste("Matrix is not positive definite, adding",
                         signif(jitter,digits=4), "jitter!")
        warning(warnmsg)
      }
    }
    else break
  }

  return (list(chol=Ch, jitter=jitter))
}


.jitCholInv <- function ( M, Num=10, silent=FALSE ) {
  jitter <- 0
  jitter1 <- abs(mean(diag(M)))*1e-6
  eyeM <- diag( 1, nrow=length(M[,1]), ncol=length(M[1,]) )

  for ( i in 1:Num ) {

    ## clear the last error message
    try(stop(""),TRUE)
    ow <- options("warn")
    options(warn=2)

    Ch <- try( chol( M + jitter*eyeM ), silent=TRUE )

    options(ow)
    nPos <- grep("not positive definite",  geterrmessage())

    if ( length(nPos) != 0 ) {
      jitter1 <- jitter1*10
      jitter <- jitter1

      if (! silent) {
        warnmsg <- paste("Matrix is not positive definite, adding",
                         signif(jitter,digits=4), "jitter!")
        warning(warnmsg)
      }
    }
    else break
  }

  ow <- options("warn")
  options(warn=2)
  invM <- try (chol2inv(Ch), silent=TRUE)
  options(ow)

  if ( "try-error" %in% class(invM) ) {
    return (list(invM=NaN))
  }
  else {
    if ( jitter == 0 ) {
      ans <- list(invM=invM, jitter=jitter, chol=Ch)
    }
    else ans <- list(invM=invM, jitM=M+jitter*eyeM , jitter=jitter, chol=Ch)

    return (ans)
  }
}



.dist2 <- function (x, x2) {
  x <- as.matrix(x)
  x2 <- as.matrix(x2)
  xdim <- dim(x)
  x2dim <- dim(x2)

  if ( xdim[2] != x2dim[2] )
    stop("Data dimensions are not matched.")

  n2 <- tcrossprod(rowSums(x^2), rep(1, x2dim[1])) +
    tcrossprod(rep(1, xdim[1]), rowSums(x2^2)) -2*tcrossprod(x, x2)

  return (n2)
}


#erff <- function(x) 2 * pnorm(x * sqrt(2)) - 1
#erfcf <- function(x) 2 * pnorm(x * sqrt(2), lower = FALSE)
#logerfc <- function(x) log(2) + pnorm(x * sqrt(2), lower = FALSE, log=TRUE)
#erfcx <- function(x) exp(x^2 + logerfc(x))


#miscCDLL <- dyn.load(paste("miscCFunctions", .Platform$dynlib.ext, sep=""))
#ClnDiffErfs <- getNativeSymbolInfo("ClnDiffErfs", miscCDLL)

lnDiffErfs <- function(x1, x2) {
  x1 <- as.matrix(x1)
  x2 <- as.matrix(x2)
  outdim <- pmax(dim(x1), dim(x2))
  outlen <- max(length(x1), length(x2))
  if (outlen > 0) {
    v <- .C("_ClnDiffErfs", as.double(x1), as.double(x2), as.integer(length(x1)), as.integer(length(x2)), v=double(outlen), s=integer(outlen))
    return (list(matrix(data=v$v, outdim), matrix(data=v$s, outdim)));
  } else {
    return (list(matrix(nrow=0, ncol=0), matrix(nrow=0, ncol=0)));
  }
}


.gradLnDiffErfs <- function(x1, x2, fact1, fact2) {
  m <- pmin(as.matrix(x1)^2, as.matrix(x2)^2)
  dlnPart <- 2/sqrt(pi) * (exp(-x1^2 + m) * fact1 - exp(-x2^2 + m) * fact2)

  g <- list(dlnPart=dlnPart, m=m)
  return (g)

}



modelExtractParam <- function (model, only.values=TRUE,
                               untransformed.values=FALSE) {
  if (is.GPModel(model))
    model <- modelStruct(model)
  
  funcName <- paste(model$type, "ExtractParam", sep="")
  func <- get(funcName, mode="function")
  params <- func(model, only.values=only.values,
                 untransformed.values=untransformed.values)

  if ( !only.values ) {
    origNames <- names(params)
    if ( "paramGroups" %in% names(model) ) {
      paramGroups <- model$paramGroups
      for ( i in seq(length.out=dim(paramGroups)[2]) ) {
        ind <- grep(1, paramGroups[,i])
        if ( is.list(params) ) {
          names(params)[i] <- origNames[ind[1]]
          for ( j in seq(2, length.out=length(ind)-1) )
            names(params)[i] <- paste(names(params)[i], origNames[ind[j]],sep="/")
        }

        paramGroups[ind[seq(2,length(ind),length=length(ind)-1)], i] <- 0
      }

      params <- params%*%paramGroups
    }
  }
  return (params)
}



modelExpandParam <- function (model, params) {
  if (is.GPModel(model))
    return (modelExpandParam(modelStruct(model), params))

  if ( is.list(params) )
    params <- params$values

  if ( "paramGroups" %in% names(model) )
    params <- params %*% t(model$paramGroups)

  funcName <- paste(model$type, "ExpandParam", sep="")
  func <- get(funcName, mode="function")
  model <- func(model, params)

  return (model)
}


modelDisplay <- function(model, ...) {
  if (is.GPModel(model))
    model <- modelStruct(model)

  funcName <- paste(model$type, "Display", sep="")
  if(exists(funcName, mode="function")) {
    func <- get(funcName, mode="function")
    func(model, ...)
  }
}

modelObjective <- function (params, model, ...) {
  if (is.GPModel(model))
    model <- modelStruct(model)

  funcName <- paste(model$type, "Objective", sep="")
  if ( exists(funcName, mode="function") ) {
    func <- get(funcName, mode="function")
    err <- func(params, model, ...)
  } else {
    funcName <- paste(model$type, "ExpandParam", sep="")
    func <- get(funcName, mode="function")
    model <- func(model, params)

    funcName <- paste(model$type, "LogLikelihood", sep="")
    func <- get(funcName, mode="function")
    err <- - func(model, ...)
  }

  return (err)
}



modelGradient <- function (params, model, ...) {
  if (is.GPModel(model))
    model <- modelStruct(model)

  funcName <- paste(model$type, "Gradient", sep="")

  if ( exists(funcName, mode="function") ) {
    func <- get(funcName, mode="function")
    g <- func(params, model, ...)
  } else {
    funcName <- paste(model$type, "ExpandParam", sep="")
    func <- get(funcName, mode="function")
    model <- func(model, params)

    funcName <- paste(model$type, "LogLikeGradients", sep="")
    func <- get(funcName, mode="function")
    g <- - func(model, ...)
  }

  return (g)
}



modelUpdateProcesses <- function (model, predt=NULL) {
  if (is.GPModel(model))
    return (modelUpdateProcesses(modelStruct(model), predt=predt))

  funcName <- paste(model$type, "UpdateProcesses", sep="")
  func <- get(funcName, mode="function")
  return (func(model, predt=predt))
}



modelLogLikelihood <- function (model) {
  if (is.GPModel(model))
    model <- modelStruct(model)

  funcName <- paste(model$type, "LogLikelihood", sep="")
  func <- get(funcName, mode="function")
  return (func(model))
}



##matrixTrace <- function (x) {
##  return ( sum(diag(as.matrix(x))) )
##}



.complexLog <- function (x) {
  if ( is.double(x) & x>0 ) {
      y <- log(x)
  } else {
      if ( is.double(x) & x<0 )
          warning("Log of negative real number, using complex log!")
      y <- log(x+0i)
  }
  return ( y )
}


.distfit <- function(data, dist = "normal") {
  if (dist == "gamma") {
    cdf <- qgamma 
  }

  else if (dist == "normal") {
    cdf <- qnorm
  }

  else {
    stop("Unknown distribution.")
  }

  t <- optim(c(1, 1), fn=.distfit_obj, gr=NULL, data, cdf)

  return (t)
}



.distfit_obj <- function(theta, y, cdf) {
  p <- c(.05, .25, .50, .75, .95)
  x <- cdf(p, theta[1], theta[2])
  r <- .5 * sum((x - y)^2)

  return (r)
}


.gpsimKernelSpec <- function(comps, options, exps=NULL) {
  kernType <- list(type="multi", comp=list())

  for (i in seq_along(comps)) {
    kernType$comp[[i]] <- list(type="parametric", realType=comps[i],
                               options=options)
  }

  return (kernType);
}


# Adapted from selectSomeIndex for AnnotatedDataFrame in Biobase
# Original (c) R. Gentleman, V. Carey, M. Morgan, S. Falcon
.listSelectSomeIndex <- function(object, maxToShow=5) {
  len <- length(object)
  if (maxToShow < 3) maxToShow <- 3
  if (len > maxToShow) {
    maxToShow <- maxToShow - 1
    bot <- ceiling(maxToShow/2)
    top <- len-(maxToShow-bot-1)
    list(1:bot, "...", top:len)
  } else if (len >= 1) list(1:len, NULL, NULL)
  else list(NULL, NULL, NULL)
}

disimKernParamInit <- function (kern) {

  if ( kern$inputDimension > 1 )
    stop("SIM kernel is only valid for one-D input.")

  kern$di_decay <- 0.1
  kern$inverseWidth <- 1
  kern$di_variance <- 1
  kern$decay <- 1
  kern$variance <- 1
  kern$rbf_variance <- 1

  if ("options" %in% names(kern) && "gaussianInitial" %in% names(kern$options) && kern$options$gaussianInitial) {
    kern$gaussianInitial <- TRUE
    kern$initialVariance <- 1
    kern$nParams <- 7
    kern$paramNames <- c("di_decay", "inverseWidth", "di_variance", "decay", "variance", "rbf_variance", "initialVariance")
  }
  else {
    kern$gaussianInitial <- FALSE
    kern$nParams <- 6
    kern$paramNames <- c("di_decay", "inverseWidth", "di_variance", "decay", "variance", "rbf_variance")
  }

  if ("options" %in% names(kern) && "isNormalised" %in% names(kern$options) && kern$options$isNormalised) {
    kern$isNormalised <- TRUE
  }
  else
    kern$isNormalised <- FALSE

  if ("options" %in% names(kern) && "inverseWidthBounds" %in% names(kern$options)) {
    kern$transforms <- list(list(index=setdiff(1:kern$nParams, 2), type="positive"),
                            list(index=2, type="bounded"))
    kern$transformArgs <- list()
    kern$transformArgs[[2]] <- kern$options$inverseWidthBounds
    kern$inverseWidth <- mean(kern$options$inverseWidthBounds)
  }
  else
    kern$transforms <- list(list(index=1:kern$nParams, type="positive"))

  kern$isStationary <- FALSE

  return (kern)
}



disimKernCompute <- function (kern, t1, t2=t1) {

  if ( ( dim(as.matrix(t1))[2] > 1 ) | ( dim(as.matrix(t2))[2] > 1 ) )
    stop("Input can only have one column.")

  l <- sqrt(2/kern$inverseWidth)

  h <- .disimComputeH(t1, t2, kern$di_decay, kern$decay, kern$decay, l)
  hp <- .disimComputeHPrime(t1, t2, kern$di_decay, kern$decay, kern$decay, l)
  if ( nargs()<3 ) {
    k <- h + t(h) + hp + t(hp)
  } else {
    h2 <- .disimComputeH(t2, t1, kern$di_decay, kern$decay, kern$decay, l)
    hp2 <- .disimComputeHPrime(t2, t1, kern$di_decay, kern$decay, kern$decay, l)
    k <- h + t(h2) + hp + t(hp2)
  }
  k <- 0.5*kern$rbf_variance*kern$di_variance*kern$variance*k
  if (!kern$isNormalised)
    k <- k*sqrt(pi)*l
  k <- Re(k)

  if ( "gaussianInitial" %in% names(kern) && kern$gaussianInitial ) {
    dim1 <- dim(as.matrix(t1))[1]
    dim2 <- dim(as.matrix(t2))[1]
    t1Mat <- matrix(t1, dim1, dim2)
    t2Mat <- t(matrix(t2, dim2, dim1))

    k = k + kern$initialVariance * kern$variance * 
      (exp(- kern$di_decay * t1Mat) - exp(- kern$decay * t1Mat)) /
        (kern$decay - kern$di_decay) * 
          (exp(- kern$di_decay * t2Mat) - exp(- kern$decay * t2Mat)) /
            (kern$decay - kern$di_decay);
  }

  return (k)
}



.disimComputeH <-  function (t1, t2, delta, Dj, Dk, l, option=1) {

  if ( ( dim(as.matrix(t1))[2] > 1 ) | ( dim(as.matrix(t2))[2] > 1 ) )
    stop("Input can only have one column.")

  dim1 <- dim(as.matrix(t1))[1]
  dim2 <- dim(as.matrix(t2))[1]
  t1Mat <- matrix(t1, dim1, dim2)
  t2Mat <- t(matrix(t2, dim2, dim1))
  diffT <- t1Mat-t2Mat

  invLDiffT <- 1/l*diffT
  halfLDelta <- 0.5*l*delta
  h <- matrix(0, dim1, dim2)

  lnPart1_f <- lnDiffErfs(halfLDelta - t1Mat/l, halfLDelta)
  lnPart2_f <- lnDiffErfs(halfLDelta + t2Mat/l, halfLDelta-invLDiffT)

  lnPart1 <- lnPart1_f[[1]]
  signs1 <- lnPart1_f[[2]]
  lnPart2 <- lnPart2_f[[1]]
  signs2 <- lnPart2_f[[2]]

  lnCommon <- halfLDelta^2-log(2*delta)-Dk*t2Mat-delta*t1Mat-log(0i + Dj-delta)

  lnFact1a1 <- log(Dk + delta) + (Dk-delta)*t2Mat
  lnFact1a2 <- log(2*delta)
  lnFact1b <- log(0i + Dk^2 - delta^2)

  lnFact2a <- (Dk + delta)*t2Mat
  lnFact2b <- log(Dk + delta)

  if (abs(Dk - delta) < .1)
    h <- signs1 * exp(lnCommon + lnPart1) * ((exp((Dk-delta)*t2Mat) - 1) / (Dk - delta) + 1/(Dk+delta)) + signs2 * exp(lnCommon + lnFact2a - lnFact2b + lnPart2)
  else
    h <- signs1 * exp(lnCommon + lnFact1a1 - lnFact1b + lnPart1) - signs1 * exp(lnCommon + lnFact1a2 - lnFact1b + lnPart1) + signs2 * exp(lnCommon + lnFact2a - lnFact2b + lnPart2)

  h <- Re(h)

  l2 <- l*l

  if ( option == 1 ) {
    return (h)
  } else {
    m1 <- pmin((halfLDelta - t1Mat/l)^2, halfLDelta^2)
    m2 <- pmin((halfLDelta + t2Mat/l)^2, (halfLDelta - invLDiffT)^2)

    dlnPart1 <- l/sqrt(pi)*(exp(-(halfLDelta - t1Mat/l)^2 + m1) - exp(-halfLDelta^2 + m1))
    dlnPart2 <- l/sqrt(pi)*(exp(-(halfLDelta + t2Mat/l)^2 + m2) - exp(-(halfLDelta - invLDiffT)^2 + m2))
    dh_ddelta <- (l*halfLDelta - t1Mat + 1/(Dj-delta)-1/delta)*h + exp(lnCommon + lnFact1a1 - lnFact1b - m1)*dlnPart1 - exp(lnCommon + lnFact1a2 - lnFact1b - m1)*dlnPart1 + exp(lnCommon + lnFact2a - lnFact2b - m2)*dlnPart2 + signs1 * exp(lnCommon + lnPart1 + lnFact1a1 - lnFact1b)*(1/(Dk-delta) - t2Mat) - signs1 * exp(lnCommon + lnPart1 + log(2*(Dk^2 + delta^2)) -2*lnFact1b) + (t2Mat - 1/(Dk + delta))*signs2*exp((Dk + delta)*t2Mat + lnCommon + lnPart2 - log(Dk + delta))
    dh_ddelta <- Re(dh_ddelta)

    disimH <- list(h=h, dh_ddelta=dh_ddelta)

    if ( option > 2 ) {
      dh_dD_j = Re(- 1/(Dj - delta)*h)

      disimH <- list(h=h, dh_ddelta=dh_ddelta, dh_dD_j=dh_dD_j)

      if ( option > 3 ) {
        dh_dD_k <- -t2Mat*h + signs1 * exp(lnCommon + lnPart1 + lnFact1a1 - lnFact1b) * (t2Mat - 1/(Dk - delta)) - signs1 * exp(lnCommon + lnPart1) * (-4*delta*Dk / (Dk^2 - delta^2)^2) + (t2Mat - 1/(Dk + delta)) * signs2 * exp(lnFact2a - lnFact2b + lnCommon + lnPart2)
        dh_dD_k <- Re(dh_dD_k)

        disimH <- list(h=h, dh_ddelta=dh_ddelta, dh_dD_j=dh_dD_j, dh_dD_k=dh_dD_k)

        if ( option > 4 ) {
          dh_dl <- exp(lnCommon + lnFact1a1 - lnFact1b - m1) * ((delta/sqrt(pi) + 2*t1Mat/(l2*sqrt(pi))) * exp(-(halfLDelta - t1Mat/l)^2 + m1) - (delta/sqrt(pi) * exp(-halfLDelta^2 + m1))) - exp(lnCommon + lnFact1a2 - lnFact1b - m1) * ((delta/sqrt(pi) + 2*t1Mat/(l2*sqrt(pi))) * exp(-(halfLDelta - t1Mat/l)^2 + m1) - (delta/sqrt(pi) * exp(-halfLDelta^2 + m1))) +exp(lnCommon + lnFact2a - lnFact2b - m2) * ((delta/sqrt(pi) - 2*t2Mat/(l2*sqrt(pi))) * exp(-(halfLDelta + t2Mat/l)^2 + m2) - ((delta/sqrt(pi) + 2*invLDiffT/(l*sqrt(pi))) * exp(-(halfLDelta - invLDiffT)^2 + m2))) + delta*halfLDelta*h
          dh_dl <- Re(dh_dl)
          disimH <- list(h=h, dh_ddelta=dh_ddelta, dh_dD_j=dh_dD_j, dh_dD_k=dh_dD_k, dh_dl=dh_dl)
        }
      }
    }
    return (disimH)
  }
}



.disimComputeHPrime <-  function (t1, t2, delta, Dj, Dk, l, option=1) {

  if ( ( dim(as.matrix(t1))[2] > 1 ) | ( dim(as.matrix(t2))[2] > 1 ) )
    stop("Input can only have one column.")

  dim1 <- dim(as.matrix(t1))[1]
  dim2 <- dim(as.matrix(t2))[1]
  t1Mat <- matrix(t1, dim1, dim2)
  t2Mat <- t(matrix(t2, dim2, dim1))
  diffT <- t1Mat-t2Mat

  invLDiffT <- 1/l*diffT
  halfLD_k <- 0.5*l*Dk
  h <- matrix(0, dim1, dim2)

  lnPart1_f <- lnDiffErfs(halfLD_k - t2Mat/l, halfLD_k)
  lnPart2_f <- lnDiffErfs(halfLD_k + t1Mat/l, halfLD_k+invLDiffT)

  lnPart1 <- lnPart1_f[[1]]
  signs1 <- lnPart1_f[[2]]
  lnPart2 <- lnPart2_f[[1]]
  signs2 <- lnPart2_f[[2]]

  lnCommon <- halfLD_k^2 - Dj*t1Mat - Dk*t2Mat - log(0i + delta^2-Dk^2) - log(Dj+Dk)

  lnFact1a1 <- log(Dk + delta)
  lnFact1a2 <- log(Dj + Dk) + (Dj-delta)*t1Mat
  lnFact1b <- log(0i + delta-Dj)

  lnFact2a <- (Dj + Dk) * t1Mat

  if (abs(Dj - delta) < .1)
    h <- signs1 * exp(lnCommon + lnPart1) * (1 + (Dj+Dk)*(1-exp((Dj-delta)*t1Mat))/(delta-Dj)) + signs2 * exp(lnCommon + lnFact2a + lnPart2)
  else
    h <- signs1 * exp(lnCommon + lnFact1a1 - lnFact1b + lnPart1) - signs1 * exp(lnCommon + lnFact1a2 - lnFact1b + lnPart1) + signs2 * exp(lnCommon + lnFact2a + lnPart2)

  h <- Re(h)

  l2 <- l*l

  if ( option == 1 ) {
    return (h)
  } else {
    dh_ddelta <- -2*delta/(delta^2-Dk^2)*h - signs1 * exp(lnCommon + lnPart1 + log(Dk + Dj) - 2*lnFact1b) - signs1 * exp(lnCommon + lnPart1 + lnFact1a2 - lnFact1b)*(-t1Mat - 1/(delta - Dj))
    dh_ddelta <- Re(dh_ddelta)
    disimH <- list(h=h, dh_ddelta=dh_ddelta)

    if ( option > 2 ) {
      dh_dD_j <- (-t1Mat - 1 /(Dj + Dk))*h + signs1 * exp(lnCommon + lnFact1a1 - lnFact1b + lnPart1)*(1/(delta - Dj)) - signs1 * exp(lnCommon + lnFact1a2 - lnFact1b + lnPart1)*(1/(Dj + Dk) + t1Mat + 1/(delta - Dj)) + t1Mat*signs2*exp(lnCommon + lnPart2 + lnFact2a)
      dh_dD_j <- Re(dh_dD_j)

      disimH <- list(h=h, dh_ddelta=dh_ddelta, dh_dD_j=dh_dD_j)
      if ( option > 3 ) {
        m1 <- pmin((halfLD_k - t2Mat/l)^2, halfLD_k^2)
        m2 <- pmin((halfLD_k + t1Mat/l)^2, (halfLD_k + invLDiffT)^2)

        dlnPart1 <- l/sqrt(pi) * (exp(-(halfLD_k - t2Mat/l)^2 + m1) - exp(-halfLD_k^2 + m1))
        dlnPart2 <- l/sqrt(pi) * (exp(-(halfLD_k + t1Mat/l)^2 + m2) - exp(-(halfLD_k + invLDiffT)^2 + m2))
        dh_dD_k <- (l*halfLD_k + 2*Dk / (delta^2 - Dk^2) + (-t2Mat - 1/(Dj + Dk)))*h + exp(lnCommon + lnFact1a1 - lnFact1b - m1) * dlnPart1 - exp(lnCommon + lnFact1a2 - lnFact1b - m1) * dlnPart1 + exp(lnCommon + lnFact2a - m2) * dlnPart2 + signs1 * exp(lnCommon + lnFact1a1 - lnFact1b + lnPart1) * (1/(Dk + delta)) - signs1 * exp(lnCommon + lnFact1a2 - lnFact1b + lnPart1) *(1/(Dj + Dk)) + signs2 * exp(lnCommon + lnPart2 + log(0i + t1Mat) + lnFact2a)
        dh_dD_k <- Re(dh_dD_k)

        disimH <- list(h=h, dh_ddelta=dh_ddelta, dh_dD_j=dh_dD_j, dh_dD_k=dh_dD_k)

        if ( option > 4 ) {
          dh_dl <- exp(lnCommon + lnFact1a1 - lnFact1b - m1) * ((Dk/sqrt(pi) + 2*t2Mat/(l2*sqrt(pi))) * exp(-(halfLD_k - t2Mat/l)^2 + m1) - (Dk/sqrt(pi) * exp(-halfLD_k^2 + m1))) -exp(lnCommon + lnFact1a2 - lnFact1b - m1) * ((Dk/sqrt(pi) + 2*t2Mat/(l2*sqrt(pi))) * exp(-(halfLD_k - t2Mat/l)^2 + m1) - (Dk/sqrt(pi) * exp(-halfLD_k^2 + m1))) +exp(lnCommon + lnFact2a - m2) * ((Dk/sqrt(pi) - 2*t1Mat/(l2*sqrt(pi))) * exp(-(halfLD_k + t1Mat/l)^2 + m2) - ((Dk/sqrt(pi) - 2*invLDiffT/(l*sqrt(pi))) * exp(-(halfLD_k + invLDiffT)^2 + m2)))+ Dk*halfLD_k*h

          dh_dl <- Re(dh_dl)
          disimH <- list(h=h, dh_ddelta=dh_ddelta, dh_dD_j=dh_dD_j, dh_dD_k=dh_dD_k, dh_dl=dh_dl)
        }
      }
    }
    return (disimH)
  }
}


# untransformed.values is ignored
disimKernExtractParam <- function (kern, only.values=TRUE,
                                   untransformed.values=TRUE) {
  if ( "gaussianInitial" %in% names(kern) && kern$gaussianInitial )
    params <- c(kern$di_decay, kern$inverseWidth, kern$di_variance, kern$decay, kern$variance, kern$rbf_variance, kern$initialVariance)
  else
    params <- c(kern$di_decay, kern$inverseWidth, kern$di_variance, kern$decay, kern$variance, kern$rbf_variance)

  if ( !only.values )
    names(params) <- kern$paramNames
  
  return (params)
}



disimKernExpandParam <- function (kern, params) {
  if ( is.list(params) )
    params <- params$values

  kern$di_decay <- params[1]
  kern$inverseWidth <- params[2]
  kern$di_variance <- params[3]
  kern$decay <- params[4]
  kern$variance <- params[5]
  kern$rbf_variance <- params[6]
  if ( "gaussianInitial" %in% names(kern) && kern$gaussianInitial )
    kern$initialVariance <- params[7]

  return (kern)
}


disimKernDisplay <- function (kern, spaceNum=0) {

  spacing = matrix("", spaceNum+1)
##   cat(spacing)
##   if(kern$isStationary)
##     cat("Stationary version of the kernel\n")
##   else
##     cat("Non-stationary version of the kernel\n")

  cat(spacing)
  if(kern$isNormalised)
    cat("Normalised version of the kernel\n")
  else
    cat("Unnormalised version of the kernel\n")

##   cat(spacing)
##   if(kern$isNegativeS)
##     cat("Sensitivities allowed to be negative.\n")
##   else
##     cat("Sensitivities constrained positive.\n")
  cat(spacing)
  cat("DISIM decay: ", kern$di_decay, "\n", sep="")
  cat(spacing)
  cat("DISIM inverse width: ", kern$inverseWidth, " (length scale ", 1/sqrt(kern$inverseWidth), ")\n", sep="")
  cat(spacing)
  cat("DISIM Variance: ", kern$di_variance, "\n", sep="")
  cat(spacing)
  cat("SIM decay: ", kern$decay, "\n", sep="")
  cat(spacing)
  cat("SIM Variance: ", kern$variance, "\n", sep="")
  cat(spacing)
  cat("RBF Variance: ", kern$rbf_variance, "\n", sep="")
  if(kern$gaussianInitial) {
    cat(spacing)
    cat("DISIM Initial Variance: ", kern$initialVariance, "\n", sep="")
  }
  ## cat(spacing)
  ## cat("SIM delay: %2.4f\n", kern$delay)
}


disimXdisimKernCompute <- function (disimKern1, disimKern2, t1, t2=t1) {
  if ( ( dim(as.matrix(t1))[2] > 1 ) | ( dim(as.matrix(t2))[2] > 1 ) )
    stop("Input can only have one column.")

  if ( disimKern1$inverseWidth != disimKern2$inverseWidth )
    stop("Kernels cannot be cross combined if they have different inverse widths.")

  if ( disimKern1$di_decay != disimKern2$di_decay)
    stop("Kernels cannot be cross combined if they have different driving input decays.")

  if ( disimKern1$di_variance != disimKern2$di_variance)
    stop("Kernels cannot be cross combined if they have different driving input variances.")

  if ( disimKern1$rbf_variance != disimKern2$rbf_variance)
    stop("Kernels cannot be cross combined if they have different RBF variances.")

  if ( disimKern1$isNormalised != disimKern2$isNormalised )
    stop("Both the DISIM kernels have to be either normalised or not.")

  l <- sqrt(2/disimKern1$inverseWidth)
  h1 <- .disimComputeH(t1, t2, disimKern1$di_decay, disimKern1$decay, disimKern2$decay, l)
  h2 <- .disimComputeH(t2, t1, disimKern1$di_decay, disimKern2$decay, disimKern1$decay, l)
  hp1 <- .disimComputeHPrime(t1, t2, disimKern1$di_decay, disimKern1$decay, disimKern2$decay, l)
  hp2 <- .disimComputeHPrime(t2, t1, disimKern1$di_decay, disimKern2$decay, disimKern1$decay, l)
  K <- h1 + t(h2) + hp1 + t(hp2)
  K <- 0.5*disimKern1$rbf_variance*disimKern1$di_variance*sqrt(disimKern1$variance)*sqrt(disimKern2$variance)*K

  if (!disimKern1$isNormalised)
    K <- K*l*sqrt(pi)

  if ("gaussianInitial" %in% names(disimKern1) && disimKern1$gaussianInitial && 
      "gaussianInitial" %in% names(disimKern2) && disimKern2$gaussianInitial) {
    if (disimKern1$initialVariance != disimKern2$initialVariance)
      stop("Kernels cannot be cross combined if they have different initial variances.");
    
    dim1 <- dim(as.matrix(t1))[1]
    dim2 <- dim(as.matrix(t2))[1]
    t1Mat <- matrix(t1, dim1, dim2)
    t2Mat <- t(matrix(t2, dim2, dim1))

    delta = disimKern1$di_decay;
    D1 = disimKern1$decay;
    D2 = disimKern2$decay;
  
    K = K + disimKern1$initialVariance * 
      sqrt(disimKern1$variance) * sqrt(disimKern2$variance) * 
        (exp(-delta * t1Mat) - exp(-D1 * t1Mat)) / (D1 - delta) *
          (exp(-delta * t2Mat) - exp(-D2 * t2Mat)) / (D2 - delta)
  }
  
  return (K)
}



disimXrbfKernCompute <- function (disimKern, rbfKern, t1, t2=t1) {

  if ( ( dim(as.matrix(t1))[2] > 1 ) | ( dim(as.matrix(t2))[2] > 1 ) )
    stop("Input can only have one column.")

  if ( disimKern$inverseWidth != rbfKern$inverseWidth )
    stop("Kernels cannot be cross combined if they have different inverse widths.")

  if ( disimKern$rbf_variance != rbfKern$variance )
    stop("Kernels cannot be cross combined if they have different RBF variances.")

  if ( disimKern$isNormalised != rbfKern$isNormalised )
    stop("Both kernels have to be either normalised or not.")

  dim1 <- dim(as.matrix(t1))[1]
  dim2 <- dim(as.matrix(t2))[1]

  t1Mat <- matrix(t1, dim1, dim2)
  t2Mat <- t(matrix(t2, dim2, dim1))
  diffT <- t1Mat-t2Mat

  l <- sqrt(2/disimKern$inverseWidth)

  Di <- disimKern$decay
  delta <- disimKern$di_decay

  invLDiffT <- 1/l*diffT
  halfLD_i <- 0.5*l*Di
  halfLDelta <- 0.5*l*delta

  lnCommon <- - log(0i + delta - Di)
  lnPart1_f <- lnDiffErfs(halfLDelta - invLDiffT, halfLDelta + t2Mat/l)
  lnPart2_f <- lnDiffErfs(halfLD_i + t2Mat/l, halfLD_i - invLDiffT)

  lnPart1 <- lnPart1_f[[1]]
  signs1 <- lnPart1_f[[2]]
  lnPart2 <- lnPart2_f[[1]]
  signs2 <- lnPart2_f[[2]]

  K <- signs1 * exp(lnCommon + halfLDelta^2 - delta * diffT + lnPart1) + signs2 * exp(lnCommon + halfLD_i^2 - Di * diffT + lnPart2)

  K <- 0.5*sqrt(disimKern$variance)*sqrt(disimKern$di_variance)*rbfKern$variance*K
  if (!disimKern$isNormalised)
    K <- K*l*sqrt(pi)
  K <- Re(K)

  return (K)
}




disimXsimKernCompute <- function (disimKern, simKern, t1, t2=t1) {
  if ( ( dim(as.matrix(t1))[2] > 1 ) | ( dim(as.matrix(t2))[2] > 1 ) )
    stop("Input can only have one column.")

  if ( disimKern$inverseWidth != simKern$inverseWidth )
    stop("Kernels cannot be cross combined if they have different inverse widths.")

  if ( disimKern$di_decay != simKern$decay)
    stop("Kernels cannot be cross combined if they have different driving input decays.")

  if ( disimKern$di_variance != simKern$variance)
    stop("Kernels cannot be cross combined if they have different driving input variances.")

  if ( disimKern$isNormalised != simKern$isNormalised )
    stop("Both kernels have to be either normalised or not.")

#  if ( disimKern$rbf_variance != simKern$rbf_variance)
#    stop("Kernels cannot be cross combined if they have different RBF variances.")

  dim1 <- dim(as.matrix(t1))[1]
  dim2 <- dim(as.matrix(t2))[1]

  t1Mat <- matrix(t1, dim1, dim2)
  t2Mat <- t(matrix(t2, dim2, dim1))
  diffT <- t1Mat-t2Mat

  l <- sqrt(2/disimKern$inverseWidth)

  Di <- disimKern$decay
  delta <- disimKern$di_decay

  invLDiffT <- 1/l*diffT
  halfLD_i <- 0.5*l*Di
  halfLDelta <- 0.5*l*delta

  lnCommon1 <- - log(2*delta) -delta * t2Mat - Di * t1Mat + halfLDelta^2

  lnFact1 <- log(2 * delta) - log(0i + delta^2 - Di^2)
  lnPart1_f <- lnDiffErfs(halfLDelta - t2Mat/l, halfLDelta)

  lnPart1 <- lnPart1_f[[1]]
  signs1 <- lnPart1_f[[2]]

  lnFact2 <- (Di - delta) * t1Mat - log(0i + delta - Di)
  lnPart2a_f <- lnDiffErfs(halfLDelta, halfLDelta - t1Mat/l)
  lnPart2b_f <- lnDiffErfs(halfLDelta, halfLDelta - t2Mat/l)

  lnPart2a <- lnPart2a_f[[1]]
  signs2a <- lnPart2a_f[[2]]
  lnPart2b <- lnPart2b_f[[1]]
  signs2b <- lnPart2b_f[[2]]

  lnFact3 <- (Di + delta) * t1Mat - log(delta + Di)
  lnPart3_f <- lnDiffErfs(halfLDelta + t1Mat/l, halfLDelta + invLDiffT)
  lnPart3 <- lnPart3_f[[1]]
  signs3 <- lnPart3_f[[2]]

  lnFact4 <- 2*delta*t2Mat + (Di - delta) * t1Mat - log(0i + delta - Di)
  lnPart4_f <- lnDiffErfs(halfLDelta - invLDiffT, halfLDelta + t2Mat/l)
  lnPart4 <- lnPart4_f[[1]]
  signs4 <- lnPart4_f[[2]]

  lnCommon2 <- - log(0i + delta^2 - Di^2) - delta * t2Mat - Di * t1Mat + halfLD_i^2
  lnPart5_f <- lnDiffErfs(halfLD_i - t1Mat/l, halfLD_i)
  lnPart5 <- lnPart5_f[[1]]
  signs5 <- lnPart5_f[[2]]

  lnFact6 <- (Di + delta) * t2Mat
  lnPart6_f <- lnDiffErfs(halfLD_i + t2Mat/l, halfLD_i - invLDiffT)
  lnPart6 <- lnPart6_f[[1]]
  signs6 <- lnPart6_f[[2]]

  K <- signs1 * exp(lnCommon1 + lnFact1 + lnPart1) +signs2a*exp(lnCommon1 + lnFact2 + lnPart2a) +signs2b*exp(lnCommon1 + lnFact2 + lnPart2b) +signs3*exp(lnCommon1 + lnFact3 + lnPart3) +signs4*exp(lnCommon1 + lnFact4 + lnPart4) +signs5*exp(lnCommon2 + lnPart5) +signs6*exp(lnCommon2 + lnFact6 + lnPart6)
  K <- 0.5*disimKern$rbf_variance*disimKern$di_variance*sqrt(disimKern$variance)*K
  if (!disimKern$isNormalised)
    K <- K*l*sqrt(pi)
  K <- Re(K)

  if ("gaussianInitial" %in% names(disimKern) && disimKern$gaussianInitial && 
      "gaussianInitial" %in% names(simKern) && simKern$gaussianInitial) {
    if (disimKern$initialVariance != simKern$initialVariance)
      stop("Kernels cannot be cross combined if they have different initial variances.")
    
    dim1 <- dim(as.matrix(t1))[1]
    dim2 <- dim(as.matrix(t2))[1]
    t1Mat <- matrix(t1, dim1, dim2)
    t2Mat <- t(matrix(t2, dim2, dim1))

    delta = disimKern$di_decay
    D = disimKern$decay
  
    K = K + disimKern$initialVariance * 
      sqrt(disimKern$variance) *
        (exp(-delta * t1Mat) - exp(-D * t1Mat)) / (D - delta) *
          exp(-delta * t2Mat)
  }

  return (K)
}



disimKernDiagCompute <- function (kern, t1) {
  if ( dim(as.matrix(t1))[2]>1 )
    stop("Input can only have one column.")

  l <- sqrt(2/kern$inverseWidth)
  delta <- kern$di_decay
  D <- kern$decay
  halfLD <- 0.5*l*D
  halfLDelta <- 0.5*l*delta

  lnPart1_f <- lnDiffErfs(halfLDelta - t1/l, halfLDelta)
  lnPart2_f <- lnDiffErfs(halfLDelta + t1/l, halfLDelta)

  lnPart1 <- lnPart1_f[[1]]
  signs1 <- lnPart1_f[[2]]
  lnPart2 <- lnPart2_f[[1]]
  signs2 <- lnPart2_f[[2]]

  lnCommon <- halfLDelta ^ 2 -(D+delta)*t1 - log(2*delta) - log(0i + D-delta)
  lnFact2 <- (D+delta)*t1 - log(D + delta)

  if (abs(D - delta) < .1)
    h <- signs1 * exp(lnCommon + lnPart1) * ((exp((D-delta)*t1) - 1) / (D - delta) + 1/(D+delta)) + signs2 * exp(lnCommon + lnFact2 + lnPart2)
  else {
    lnFact1a <- (D - delta) * t1 + log(D + delta) - log(0i + D^2 - delta^2)
    lnFact1b <- log(2*delta) - log(0i + D^2 - delta^2)
    h <- signs1 * exp(lnCommon + lnFact1a + lnPart1) - signs1 * exp(lnCommon + lnFact1b + lnPart1) + signs2 * exp(lnCommon + lnFact2 + lnPart2)
  }

  lnPart1p_f <- lnDiffErfs(halfLD - t1/l, halfLD)
  lnPart2p_f <- lnDiffErfs(halfLD + t1/l, halfLD)
  lnPart1p <- lnPart1p_f[[1]]
  signs1p <- lnPart1p_f[[2]]
  lnPart2p <- lnPart2p_f[[1]]
  signs2p <- lnPart2p_f[[2]]

  lnCommonp <- halfLD^2 - 2*D*t1 - log(0i + delta^2 - D^2)
  lnFact2p <- 2*D*t1 - log(2*D)

  if (abs(D - delta) < .1) {
    hp <- signs1p * exp(lnCommonp + lnPart1p) * ((exp((D-delta)*t1) - 1) / (D - delta) + 1/(2*D)) + signs2p * exp(lnCommonp + lnFact2p + lnPart2p)
  }
  else {
    lnFact1ap <- log(D + delta) - log(0i + delta - D) - log(2*D)
    lnFact1bp <- (D-delta)*t1 - log(0i + delta - D)

    hp <- signs1p * exp(lnCommonp + lnFact1ap + lnPart1p) - signs1p * exp(lnCommonp + lnFact1bp + lnPart1p) + signs2p * exp(lnCommonp + lnFact2p + lnPart2p)
  }

  k <- kern$rbf_variance*kern$di_variance*kern$variance*Re(h+hp)
  if (!kern$isNormalised)
    k <- k*l*sqrt(pi)

  if ( "gaussianInitial" %in% names(kern) && kern$gaussianInitial )
    k = k + kern$initialVariance*kern$variance * 
      ((exp(-kern$di_decay*t1) - exp(-kern$decay*t1)) /
       (kern$decay-kern$di_decay))^2;

  return (k)
}



disimKernGradient <- function (kern, t1, t2, covGrad) {
  if ( nargs() == 3 ) {
    covGrad <- t2
    t2 <- t1
  }

  gFull <- disimXdisimKernGradient(kern, kern, t1, t2, covGrad)

  g <- gFull$g1 + gFull$g2

  return (g)
}



disimXdisimKernGradient <- function (disimKern1, disimKern2, t1, t2, covGrad) {
  if ( nargs() < 5 ) {
    covGrad <- t2
    t2 <- t1
  }

  if ( dim(as.matrix(t1))[2]>1 | dim(as.matrix(t2))[2]>1 )
    stop("Input can only have one column for SIM kernel.")

  if ( disimKern1$inverseWidth != disimKern2$inverseWidth )
    stop("Kernels cannot be cross combined if they have different inverse widths.")

  if ( disimKern1$di_decay != disimKern2$di_decay)
    stop("Kernels cannot be cross combined if they have different driving input decays.")

  if ( disimKern1$di_variance != disimKern2$di_variance )
    stop("Kernels cannot be cross combined if they have different driving input variances.")

  if ( disimKern1$rbf_variance != disimKern2$rbf_variance )
    stop("Kernels cannot be cross combined if they have different RBF variances.")

  if ( disimKern1$isNormalised != disimKern2$isNormalised )
    stop("Both the DISIM kernels have to be either normalised or not.")

  option <- 5
  l <- sqrt(2/disimKern1$inverseWidth)
  disimH1 <- .disimComputeH(t1, t2, disimKern1$di_decay, disimKern1$decay, disimKern2$decay, l, option)
  h1 <- disimH1$h
  dh1_ddelta <- disimH1$dh_ddelta
  dh1_dD1 <- disimH1$dh_dD_j
  dh1_dD2 <- disimH1$dh_dD_k
  dh1_dl <- disimH1$dh_dl

  disimH2 <- .disimComputeH(t2, t1, disimKern1$di_decay, disimKern2$decay, disimKern1$decay, l, option)
  h2 <- disimH2$h
  dh2_ddelta <- disimH2$dh_ddelta
  dh2_dD2 <- disimH2$dh_dD_j
  dh2_dD1 <- disimH2$dh_dD_k
  dh2_dl <- disimH2$dh_dl

  disimHp1 <- .disimComputeHPrime(t1, t2, disimKern1$di_decay, disimKern1$decay, disimKern2$decay, l, option)

  hp1 <- disimHp1$h
  dhp1_ddelta <- disimHp1$dh_ddelta
  dhp1_dD1 <- disimHp1$dh_dD_j
  dhp1_dD2 <- disimHp1$dh_dD_k
  dhp1_dl <- disimHp1$dh_dl

  disimHp2 <- .disimComputeHPrime(t2, t1, disimKern1$di_decay, disimKern2$decay, disimKern1$decay, l, option)
  hp2 <- disimHp2$h
  dhp2_ddelta <- disimHp2$dh_ddelta
  dhp2_dD2 <- disimHp2$dh_dD_j
  dhp2_dD1 <- disimHp2$dh_dD_k
  dhp2_dl <- disimHp2$dh_dl

  dK_ddelta <- dh1_ddelta + t(dh2_ddelta) + dhp1_ddelta + t(dhp2_ddelta)
  dK_dD1 <- dh1_dD1 + t(dh2_dD1) + dhp1_dD1 + t(dhp2_dD1)
  dK_dD2 <- dh1_dD2 + t(dh2_dD2) + dhp1_dD2 + t(dhp2_dD2)
  dK_dl <- dh1_dl + t(dh2_dl) + dhp1_dl + t(dhp2_dl)

  C0 <- disimKern1$di_variance
  C1 <- sqrt(disimKern1$variance)
  C2 <- sqrt(disimKern2$variance)
  C3 <- disimKern1$rbf_variance
  K <- 0.5 * (h1 + t(h2) + hp1 + t(hp2))
  var2 <- C0*C1*C2*C3

  if (disimKern1$isNormalised) {
    dk_ddelta <- sum(covGrad*dK_ddelta)*0.5*var2
    dk_dD1 <- sum(covGrad*dK_dD1)*0.5*var2
    dk_dD2 <- sum(covGrad*dK_dD2)*0.5*var2
    dk_dl <- sum(covGrad*dK_dl)*0.5*var2
  }
  else {
    K <- K*sqrt(pi)
    dk_ddelta <- sum(covGrad*dK_ddelta)*0.5*sqrt(pi)*l*var2
    dk_dD1 <- sum(covGrad*dK_dD1)*0.5*sqrt(pi)*l*var2
    dk_dD2 <- sum(covGrad*dK_dD2)*0.5*sqrt(pi)*l*var2
    dk_dl <- sum(covGrad*(dK_dl*0.5*sqrt(pi)*l + K))*var2
    K <- l*K
  }
  dk_dC0 <- C1*C2*C3*sum(covGrad*K)
  dk_dC1 <- C0*C2*C3*sum(covGrad*K)
  dk_dC2 <- C0*C1*C3*sum(covGrad*K)
  dk_dC3 <- C0*C1*C2*sum(covGrad*K)

  dk_dDIVariance <- dk_dC0
  dk_dDisim1Variance <- dk_dC1*0.5/C1
  dk_dDisim2Variance <- dk_dC2*0.5/C2
  dk_dRBFVariance <- dk_dC3

  dk_dinvWidth <- -0.5*sqrt(2)/(disimKern1$inverseWidth*sqrt(disimKern1$inverseWidth))*dk_dl

  K <- var2*K

  if ("gaussianInitial" %in% names(disimKern1) && disimKern1$gaussianInitial && 
      "gaussianInitial" %in% names(disimKern2) && disimKern2$gaussianInitial) {
    if (disimKern1$initialVariance != disimKern2$initialVariance)
      stop("Kernels cannot be cross combined if they have different initial variances.");
    
    dim1 <- dim(as.matrix(t1))[1]
    dim2 <- dim(as.matrix(t2))[1]
    t1Mat <- matrix(t1, dim1, dim2)
    t2Mat <- t(matrix(t2, dim2, dim1))

    delta <- disimKern1$di_decay
    D1 <- disimKern1$decay
    D2 <- disimKern2$decay

    the_rest <- (exp(- delta * t1Mat) - exp(- D1 * t1Mat)) / (D1 - delta) *
      (exp(- delta * t2Mat) - exp(- D2 * t2Mat)) / (D2 - delta)
  
    dk_dinitVariance <- sum((sqrt(disimKern1$variance) *
      sqrt(disimKern2$variance) * the_rest) * covGrad)

    dk_dDisim1Variance <- dk_dDisim1Variance + 
      sum((.5 / sqrt(disimKern1$variance) *
           disimKern1$initialVariance * sqrt(disimKern2$variance) * the_rest)
          * covGrad)

    dk_dDisim2Variance <- dk_dDisim2Variance +
      sum((.5 / sqrt(disimKern2$variance) *
           disimKern1$initialVariance * sqrt(disimKern1$variance) * the_rest)
          * covGrad)

    dk_dD1 <- dk_dD1 +
      sum((disimKern1$initialVariance *
           sqrt(disimKern1$variance) * sqrt(disimKern2$variance) *
           (t1Mat * (D1 - delta)*exp(-D1*t1Mat) - exp(-delta*t1Mat) + 
            exp(-D1*t1Mat)) / (D1-delta)^2 *
           (exp(- delta * t2Mat) - exp(- D2 * t2Mat)) / (D2 - delta))
          *covGrad)
  
    dk_dD2 <- dk_dD2 +
      sum((disimKern1$initialVariance *
           sqrt(disimKern1$variance) * sqrt(disimKern2$variance) *
           (t2Mat * (D2 - delta)*exp(-D2*t2Mat) - exp(-delta*t2Mat) + 
            exp(-D2*t2Mat)) / (D2-delta)^2 *
           (exp(- delta * t1Mat) - exp(-D1 * t1Mat)) / (D1 - delta))
          *covGrad)

    dk_ddelta <- dk_ddelta +
      sum((disimKern1$initialVariance *
           sqrt(disimKern1$variance) * sqrt(disimKern2$variance) *
           ((-t2Mat * (D2 - delta)*exp(-delta*t2Mat) + exp(-delta*t2Mat) - 
             exp(-D2*t2Mat)) / (D2-delta)^2 *
            (exp(- delta * t1Mat) - exp(-D1 * t1Mat)) / (D1 - delta) +
            (-t1Mat * (D1 - delta)*exp(-delta*t1Mat) + exp(-delta*t1Mat) - 
             exp(-D1*t1Mat)) / (D1-delta)^2 *
            (exp(- delta * t2Mat) - exp(-D2 * t2Mat)) / (D2 - delta)))
          *covGrad)
    
    g1 <- c(dk_ddelta, dk_dinvWidth, dk_dDIVariance, dk_dD1, dk_dDisim1Variance, dk_dRBFVariance, dk <- dk_dinitVariance)
    g2 <- c(0, 0, 0, dk_dD2, dk_dDisim2Variance, 0, 0)

  }
  else {
    g1 <- c(dk_ddelta, dk_dinvWidth, dk_dDIVariance, dk_dD1, dk_dDisim1Variance, dk_dRBFVariance)
    g2 <- c(0, 0, 0, dk_dD2, dk_dDisim2Variance, 0)
  }

  g <- list(g1=g1, g2=g2)
  return (g)
}



disimXrbfKernGradient <- function (disimKern, rbfKern, t1, t2, covGrad) {
  if ( nargs() < 5 ) {
    covGrad <- t2
    t2 <- t1
  }

  if ( dim(as.matrix(t1))[2]>1 | dim(as.matrix(t2))[2]>1 )
    stop("Input can only have one column for SIM kernel.")

  if ( disimKern$inverseWidth != rbfKern$inverseWidth )
    stop("Kernels cannot be cross combined if they have different inverse widths.")

  if ( disimKern$rbf_variance != rbfKern$variance )
    stop("Kernels cannot be cross combined if they have different RBF variances.")

  if ( disimKern$isNormalised != rbfKern$isNormalised )
    stop("Both kernels have to be either normalised or not.")

  if ( nargs()<5 ) {
    k <- disimXrbfKernCompute(disimKern, rbfKern, t1)
  } else {
    k <- disimXrbfKernCompute(disimKern, rbfKern, t1, t2)
  }

  dim1 <- dim(as.matrix(t1))[1]
  dim2 <- dim(as.matrix(t2))[1]
  t1Mat <- matrix(t1, dim1, dim2)
  t2Mat <- t(matrix(t2, dim2, dim1))
  diffT <- t1Mat-t2Mat

  l <- sqrt(2/disimKern$inverseWidth)
  l2 <- l*l
  C_0 <- sqrt(disimKern$di_variance)
  C_i <- sqrt(disimKern$variance)
  C_j <- rbfKern$variance
  D_i <- disimKern$decay
  delta <-  disimKern$di_decay

  invLDiffT <- 1/l*diffT
  halfLD_i <- 0.5*l*D_i
  halfLDelta <- 0.5*l*delta

  if (disimKern$isNormalised)
    prefact <- 0.5 * C_0 * C_i * C_j
  else
    prefact <- C_0 * C_i * C_j * sqrt(pi)/2 * l

  lnCommon <- - log(0i + delta - D_i)
  lnPart1_f <- lnDiffErfs(halfLDelta - invLDiffT, halfLDelta + t2Mat/l)
  lnPart2_f <- lnDiffErfs(halfLD_i + t2Mat/l, halfLD_i - invLDiffT)
  lnPart1 <- lnPart1_f[[1]]
  signs1 <- lnPart1_f[[2]]
  lnPart2 <- lnPart2_f[[1]]
  signs2 <- lnPart2_f[[2]]

  lnFact1 <- halfLDelta^2 - delta * diffT
  lnFact2 <- halfLD_i^2 - D_i * diffT

  gradln1 <- .gradLnDiffErfs(halfLDelta - invLDiffT, halfLDelta + t2Mat/l, l/2, l/2)
  dlnPart1 <- gradln1$dlnPart
  m1 <- gradln1$m

  gradln2 <-.gradLnDiffErfs(halfLD_i + t2Mat/l, halfLD_i - invLDiffT, l/2, l/2)
  dlnPart2 <- gradln2$dlnPart
  m2 <- gradln2$m

  dK_dD <- k * (1/(delta-D_i)) + prefact * ((l*halfLD_i - diffT) * signs2 * exp(lnCommon + lnFact2 + lnPart2) + dlnPart2 * exp(lnCommon + lnFact2 - m2))
  dk_dD <- sum(dK_dD*covGrad)

  dK_ddelta <- k * (-1/(delta-D_i)) + prefact * ((l*halfLDelta - diffT) * signs1 * exp(lnCommon + lnFact1 + lnPart1) + dlnPart1 * exp(lnCommon + lnFact1 - m1))
  dk_ddelta <- sum(dK_ddelta*covGrad)

  gradln1 <- .gradLnDiffErfs(halfLDelta - invLDiffT, halfLDelta + t2Mat/l, delta/2 + invLDiffT/l, delta/2 - t2Mat/l2)
  dlnPart1 <- gradln1$dlnPart
  m1 <- gradln1$m

  gradln2 <-.gradLnDiffErfs(halfLD_i + t2Mat/l, halfLD_i - invLDiffT, D_i/2 - t2Mat/l2, D_i/2 + invLDiffT/l)
  dlnPart2 <- gradln2$dlnPart
  m2 <- gradln2$m

  dK_dl <- prefact * (delta*halfLDelta * signs1 * exp(lnCommon + lnFact1 + lnPart1) + D_i*halfLD_i * signs2 * exp(lnCommon + lnFact2 + lnPart2) + dlnPart1 * exp(lnCommon + lnFact1 - m1) + dlnPart2 * exp(lnCommon + lnFact2 - m2))
  if (!disimKern$isNormalised)
    dK_dl <- dK_dl + k/l
  
  dk_dl <- sum(dK_dl*covGrad)

  dk_dC_i <- sum(k*covGrad)/C_i
  dk_dC_0 <- sum(k*covGrad)/C_0
  dk_dRbfVariance <- sum(k*covGrad)/rbfKern$variance

  dk_dinvWidth <- -0.5*sqrt(2)/(disimKern$inverseWidth*sqrt(disimKern$inverseWidth))*dk_dl
  dk_dDisimVariance <- dk_dC_i*0.5/C_i
  dk_dDIVariance <- dk_dC_0*0.5/C_0

  if ("gaussianInitial" %in% names(disimKern) && disimKern$gaussianInitial)
    g1 <- Re(c(dk_ddelta, dk_dinvWidth, dk_dDIVariance, dk_dD, dk_dDisimVariance, 0, 0))
  else
    g1 <- Re(c(dk_ddelta, dk_dinvWidth, dk_dDIVariance, dk_dD, dk_dDisimVariance, 0))
  g2 <- Re(c(0, dk_dRbfVariance))

  g <- list(g1=g1, g2=g2)
  return (g)
}




disimXsimKernGradient <- function (disimKern, simKern, t1, t2, covGrad) {
  if ( nargs() < 5 ) {
    covGrad <- t2
    t2 <- t1
  }

  if ( dim(as.matrix(t1))[2]>1 | dim(as.matrix(t2))[2]>1 )
    stop("Input can only have one column for SIM kernel.")

  if ( disimKern$inverseWidth != simKern$inverseWidth )
    stop("Kernels cannot be cross combined if they have different inverse widths.")

  if ( disimKern$di_decay != simKern$decay)
    stop("Kernels cannot be cross combined if they have different driving input decays.")

  if ( disimKern$di_variance != simKern$variance)
    stop("Kernels cannot be cross combined if they have different driving input variances.")

  if ( disimKern$isNormalised != simKern$isNormalised )
    stop("Both kernels have to be either normalised or not.")

#  if ( disimKern$rbf_variance != simKern$rbf_variance)
#    stop("Kernels cannot be cross combined if they have different RBF variances.")

  dim1 <- dim(as.matrix(t1))[1]
  dim2 <- dim(as.matrix(t2))[1]
  t1Mat <- matrix(t1, dim1, dim2)
  t2Mat <- t(matrix(t2, dim2, dim1))
  diffT <- t1Mat-t2Mat

  l <- sqrt(2/disimKern$inverseWidth)
  l2 <- l*l
  C_0 <- sqrt(disimKern$di_variance)
  C_i <- sqrt(disimKern$variance)

  D_i <- disimKern$decay
  delta <-  disimKern$di_decay
  halfLD_i <- 0.5*l*D_i
  halfLDelta <- 0.5*l*delta
  invLDiffT <- 1/l*diffT

  lnCommon1 <- - log(2*delta) -delta * t2Mat - D_i * t1Mat + halfLDelta^2

  lnFact1 <- log(2 * delta) - log(0i + delta^2 - D_i^2)
  lnPart1_f <- lnDiffErfs(halfLDelta - t2Mat/l, halfLDelta)

  lnPart1 <- lnPart1_f[[1]]
  signs1 <- lnPart1_f[[2]]

  lnFact2 <- (D_i - delta) * t1Mat - log(0i + delta - D_i)
  lnPart2a_f <- lnDiffErfs(halfLDelta, halfLDelta - t1Mat/l)
  lnPart2b_f <- lnDiffErfs(halfLDelta, halfLDelta - t2Mat/l)

  lnPart2a <- lnPart2a_f[[1]]
  signs2a <- lnPart2a_f[[2]]
  lnPart2b <- lnPart2b_f[[1]]
  signs2b <- lnPart2b_f[[2]]

  lnFact3 <- (D_i + delta) * t1Mat - log(delta + D_i)
  lnPart3_f <- lnDiffErfs(halfLDelta + t1Mat/l, halfLDelta + invLDiffT)
  lnPart3 <- lnPart3_f[[1]]
  signs3 <- lnPart3_f[[2]]

  lnFact4 <- 2*delta*t2Mat + (D_i - delta) * t1Mat - log(0i + delta - D_i)
  lnPart4_f <- lnDiffErfs(halfLDelta - invLDiffT, halfLDelta + t2Mat/l)
  lnPart4 <- lnPart4_f[[1]]
  signs4 <- lnPart4_f[[2]]

  lnCommon2 <- - log(0i + delta^2 - D_i^2) - delta * t2Mat - D_i * t1Mat + halfLD_i^2
  lnPart5_f <- lnDiffErfs(halfLD_i - t1Mat/l, halfLD_i)
  lnPart5 <- lnPart5_f[[1]]
  signs5 <- lnPart5_f[[2]]

  lnFact6 <- (D_i + delta) * t2Mat
  lnPart6_f <- lnDiffErfs(halfLD_i + t2Mat/l, halfLD_i - invLDiffT)
  lnPart6 <- lnPart6_f[[1]]
  signs6 <- lnPart6_f[[2]]

  K1 <- signs1 * exp( lnCommon1 + lnFact1 + lnPart1) +signs2a*exp(lnCommon1 + lnFact2 + lnPart2a) +signs2b*exp(lnCommon1 + lnFact2 + lnPart2b) +signs3*exp(lnCommon1 + lnFact3 + lnPart3) +signs4*exp(lnCommon1 + lnFact4 + lnPart4)

  K2 <- signs5*exp( lnCommon2 + lnPart5) +signs6*exp(lnCommon2 + lnFact6 + lnPart6)

  if (disimKern$isNormalised)
    prefact <- 0.5*disimKern$rbf_variance*disimKern$di_variance*sqrt(disimKern$variance)
  else
    prefact <- 0.5*sqrt(pi)*l*disimKern$rbf_variance*disimKern$di_variance*sqrt(disimKern$variance)
  K <- prefact*Re(K1+K2)

  dcommon1 <- - 1/delta - t2Mat + l*halfLDelta
  dfact1 <- 1/delta - 2*delta/(delta^2 - D_i^2)
  dfact2 <- -t1Mat - 1/(delta - D_i)
  dfact3 <- t1Mat - 1/(delta + D_i)
  dfact4 <- 2*t2Mat - t1Mat - 1/(delta - D_i)
  dcommon2 <- - 2*delta/(delta^2 - D_i^2) - t2Mat
  dfact6 <- t2Mat

  gradln1 <- .gradLnDiffErfs(halfLDelta - t2Mat/l, halfLDelta, l/2, l/2)
  dpart1 <- gradln1$dlnPart
  m1 <- gradln1$m

  gradln2a <-.gradLnDiffErfs(halfLDelta, halfLDelta - t1Mat/l, l/2, l/2)
  dpart2a <- gradln2a$dlnPart
  m2a <- gradln2a$m

  gradln2b <-.gradLnDiffErfs(halfLDelta, halfLDelta - t2Mat/l, l/2, l/2)
  dpart2b <- gradln2b$dlnPart
  m2b <- gradln2b$m

  gradln3 <- .gradLnDiffErfs(halfLDelta + t1Mat/l, halfLDelta + invLDiffT, l/2, l/2)
  dpart3 <- gradln3$dlnPart
  m3 <- gradln3$m

  gradln4 <- .gradLnDiffErfs(halfLDelta - invLDiffT, halfLDelta + t2Mat/l, l/2, l/2)
  dpart4 <- gradln4$dlnPart
  m4 <- gradln4$m

  dK_ddelta <- prefact * (dcommon1 * K1 + dcommon2 * K2 + dfact1 * signs1*exp(lnCommon1 + lnFact1 + lnPart1) + dfact2 * signs2a*exp(lnCommon1 + lnFact2 + lnPart2a) + dfact2 * signs2b*exp(lnCommon1 + lnFact2 + lnPart2b) + dfact3 * signs3*exp(lnCommon1 + lnFact3 + lnPart3) + dfact4 * signs4*exp(lnCommon1 + lnFact4 + lnPart4) + dfact6 * signs6*exp(lnCommon2 + lnFact6 + lnPart6) + dpart1 * exp(lnCommon1 + lnFact1 - m1) + dpart2a * exp(lnCommon1 + lnFact2 - m2a) + dpart2b * exp(lnCommon1 + lnFact2 - m2b) + dpart3 * exp(lnCommon1 + lnFact3 - m3) + dpart4 * exp(lnCommon1 + lnFact4 - m4))

  dcommon1 <- delta * halfLDelta
  dcommon2 <- D_i * halfLD_i

  gradln1 <- .gradLnDiffErfs(halfLDelta - t2Mat/l, halfLDelta, delta/2 + t2Mat/l2, delta/2)
  dpart1 <- gradln1$dlnPart
  m1 <- gradln1$m

  gradln2a <-.gradLnDiffErfs(halfLDelta, halfLDelta - t1Mat/l, delta/2, delta/2 + t1Mat/l2)
  dpart2a <- gradln2a$dlnPart
  m2a <- gradln2a$m

  gradln2b <-.gradLnDiffErfs(halfLDelta, halfLDelta - t2Mat/l, delta/2, delta/2 + t2Mat/l2)
  dpart2b <- gradln2b$dlnPart
  m2b <- gradln2b$m

  gradln3 <- .gradLnDiffErfs(halfLDelta + t1Mat/l, halfLDelta + invLDiffT, delta/2 - t1Mat/l2, delta/2 - invLDiffT/l)
  dpart3 <- gradln3$dlnPart
  m3 <- gradln3$m

  gradln4 <- .gradLnDiffErfs(halfLDelta - invLDiffT, halfLDelta + t2Mat/l, delta/2 + invLDiffT/l, delta/2 - t2Mat/l2)
  dpart4 <- gradln4$dlnPart
  m4 <- gradln4$m

  gradln5 <- .gradLnDiffErfs(halfLD_i - t1Mat/l, halfLD_i, D_i/2 + t1Mat/l2, D_i/2)
  dpart5 <- gradln5$dlnPart
  m5 <- gradln5$m

  gradln6 <- .gradLnDiffErfs(halfLD_i + t2Mat/l, halfLD_i - invLDiffT, D_i/2 - t2Mat/l2, D_i/2 + invLDiffT/l)
  dpart6 <- gradln6$dlnPart
  m6 <- gradln6$m

  dK_dl <- Re(prefact * (dcommon1 * K1 + dcommon2 * K2 +dpart1 * exp(lnCommon1 + lnFact1 - m1) +dpart2a * exp(lnCommon1 + lnFact2 - m2a) +dpart2b * exp(lnCommon1 + lnFact2 - m2b) +dpart3 * exp(lnCommon1 + lnFact3 - m3) +dpart4 * exp(lnCommon1 + lnFact4 - m4) +dpart5 * exp(lnCommon2 - m5) +dpart6 * exp(lnCommon2 + lnFact6 - m6)))
  if (!disimKern$isNormalised)
    dK_dl <- dK_dl + K / l

  dcommon1 <- - t1Mat
  dfact1 <- 2 * D_i / (delta^2 - D_i^2)
  dfact2 <- t1Mat + 1/(delta - D_i)
  dfact3 <- t1Mat - 1/(delta + D_i)
  dfact4 <- t1Mat + 1/(delta - D_i)
  dcommon2 <- 2 * D_i / (delta^2 - D_i^2) - t1Mat + l*halfLD_i
  dfact6 <- t2Mat

  gradln5 <- .gradLnDiffErfs(halfLD_i - t1Mat/l, halfLD_i, l/2, l/2)
  dpart5 <- gradln5$dlnPart
  m5 <- gradln5$m

  gradln6 <- .gradLnDiffErfs(halfLD_i + t2Mat/l, halfLD_i - invLDiffT, l/2, l/2)
  dpart6 <- gradln6$dlnPart
  m6 <- gradln6$m

  dK_dD = prefact * (dcommon1 * K1 + dcommon2 * K2 + dfact1 * signs1*exp(lnCommon1 + lnFact1 + lnPart1) + dfact2 * signs2a*exp(lnCommon1 + lnFact2 + lnPart2a) + dfact2 * signs2b*exp(lnCommon1 + lnFact2 + lnPart2b) + dfact3 * signs3*exp(lnCommon1 + lnFact3 + lnPart3) + dfact4 * signs4*exp(lnCommon1 + lnFact4 + lnPart4) + dfact6 * signs6*exp(lnCommon2 + lnFact6 + lnPart6) + dpart5 * exp(lnCommon2 - m5) + dpart6 * exp(lnCommon2 + lnFact6 - m6))

  dk_ddelta <- sum(dK_ddelta*covGrad)
  dk_dl <- sum(dK_dl*covGrad)
  dk_dD <- sum(dK_dD*covGrad)

  dk_dRBFVariance <- sum(K*covGrad)/disimKern$rbf_variance
  dk_dDIVariance <- sum(K*covGrad)/disimKern$di_variance
  dk_dSimVariance <- .5 * sum(K*covGrad)/disimKern$variance

  dk_dinvWidth <- -0.5*sqrt(2)/(disimKern$inverseWidth* sqrt(disimKern$inverseWidth))*dk_dl

  if ("gaussianInitial" %in% names(disimKern) && disimKern$gaussianInitial && 
      "gaussianInitial" %in% names(simKern) && simKern$gaussianInitial) {
    if (disimKern$initialVariance != simKern$initialVariance)
      stop("Kernels cannot be cross combined if they have different initial variances.")
    
    dim1 <- dim(as.matrix(t1))[1]
    dim2 <- dim(as.matrix(t2))[1]
    t1Mat <- matrix(t1, dim1, dim2)
    t2Mat <- t(matrix(t2, dim2, dim1))

    delta = disimKern$di_decay
    D = disimKern$decay

    the_rest = (exp(-delta*t1Mat) - exp(-D*t1Mat)) / (D-delta) *
      exp(-delta*t2Mat)
  
    dk_dinitVariance = sum((sqrt(disimKern$variance) * the_rest) * covGrad)

    dk_dSimVariance = dk_dSimVariance +
      sum((.5 / sqrt(disimKern$variance) *
           disimKern$initialVariance * the_rest) * covGrad)

    dk_dD = dk_dD +
      sum((disimKern$initialVariance * sqrt(disimKern$variance) *
           (t1Mat*(D-delta)*exp(-D*t1Mat) - exp(-delta*t1Mat)
            + exp(-D*t1Mat)) / (D-delta)^2 *
           exp(-delta*t2Mat))*covGrad)
  
    dk_ddelta = dk_ddelta +
      sum((disimKern$initialVariance * sqrt(disimKern$variance) *
           (-t2Mat*exp(-delta*t2Mat) *
            (exp(-delta*t1Mat) - exp(-D*t1Mat)) / (D-delta) +
            (-t1Mat*(D-delta)*exp(-delta*t1Mat) + exp(-delta*t1Mat)
             - exp(-D*t1Mat)) / (D-delta)^2 *
            exp(-delta*t2Mat)))*covGrad)
    
    g1 <- Re(c(dk_ddelta, dk_dinvWidth, dk_dDIVariance, dk_dD, dk_dSimVariance, dk_dRBFVariance, dk_dinitVariance))
    g2 <- c(0, 0, 0, 0)
  }
  else {
    g1 <- Re(c(dk_ddelta, dk_dinvWidth, dk_dDIVariance, dk_dD, dk_dSimVariance, dk_dRBFVariance))
    g2 <- c(0, 0, 0)
  }

  g <- list(g1=g1, g2=g2)
  return (g)
}

.openConnection <- function(dbPath) {
  drv <- SQLite()
  db <- dbConnect(drv, dbPath)
  return(db)
}

.createTables <- function(db) {
  tables <- cbind('CREATE TABLE genes (gene_id INTEGER PRIMARY KEY, probe_name VARCHAR,
CONSTRAINT genes_u UNIQUE (probe_name) ON CONFLICT IGNORE)',
   'CREATE TABLE gene_aliases (gene_id INTEGER, alias_id INTEGER, alias VARCHAR,
CONSTRAINT gene_aliases_u UNIQUE (gene_id, alias_id, alias) ON CONFLICT IGNORE,
CONSTRAINT gene_aliases_g_f FOREIGN KEY (gene_id) REFERENCES genes(gene_id),
CONSTRAINT gene_aliases_a_f FOREIGN KEY (alias_id) REFERENCES alias_annotation(alias_id))',
   'CREATE TABLE z_scores (gene_id INTEGER, dataset_id INTEGER, mean_z_score DOUBLE,
CONSTRAINT z_scores_u UNIQUE (gene_id, dataset_id) ON CONFLICT IGNORE,
CONSTRAINT z_scores_g_f FOREIGN KEY (gene_id) REFERENCES genes(gene_id),
CONSTRAINT z_scores_g_d FOREIGN KEY (dataset_id) REFERENCES expression_dataset_annotation(dataset_id))',
   'CREATE TABLE results (gene_id INTEGER, experiment_id INTEGER, log_likelihood DOUBLE, baseline_log_likelihood DOUBLE, params BLOB,
CONSTRAINT results_u UNIQUE (gene_id, experiment_id) ON CONFLICT REPLACE,
CONSTRAINT results_g_f FOREIGN KEY (gene_id) REFERENCES genes(gene_id),
CONSTRAINT results_e_f FOREIGN KEY (experiment_id) REFERENCES experiment_annotation(experiment_id))',
   'CREATE TABLE supplementary_data (gene_id INTEGER, supp_dataset_id INTEGER, value DOUBLE,
CONSTRAINT supplementary_data_u UNIQUE (gene_id, supp_dataset_id) ON CONFLICT IGNORE,
CONSTRAINT supplementary_data_g_f FOREIGN KEY (gene_id) REFERENCES genes(gene_id),
CONSTRAINT supplementary_data_s_f FOREIGN KEY (supp_dataset_id) REFERENCES supplementary_dataset_annotation(supp_dataset_id))',
   'CREATE TABLE target_sets (experiment_id INTEGER, gene_id INTEGER,
CONSTRAINT target_sets_u UNIQUE (experiment_id, gene_id) ON CONFLICT IGNORE,
CONSTRAINT target_sets_e_f FOREIGN KEY (experiment_id) REFERENCES experiment_annotation(experiment_id),
CONSTRAINT target_sets_g_f FOREIGN KEY (gene_id) REFERENCES genes(gene_id))',
   'CREATE TABLE figures (experiment_id INTEGER, figure_id INTEGER,
CONSTRAINT figures_u UNIQUE (experiment_id, figure_id) ON CONFLICT IGNORE,
CONSTRAINT figures_e_f FOREIGN KEY (experiment_id) REFERENCES experiment_annotation(experiment_id),
CONSTRAINT figures_f_f FOREIGN KEY (figure_id) REFERENCES figure_annotation(figure_id))',
   'CREATE TABLE figuredata (figure_id INTEGER, gene_id INTEGER, data BLOB,
CONSTRAINT figuredata_u UNIQUE (figure_id, gene_id) ON CONFLICT REPLACE,
CONSTRAINT figuredata_f_f FOREIGN KEY (figure_id) REFERENCES figure_annotation(figure_id),
CONSTRAINT figures_g_f FOREIGN KEY (gene_id) REFERENCES genes(gene_id))',
   'CREATE TABLE regulators (regulator_id INTEGER PRIMARY KEY, gene_id INTEGER, dataset_id INTEGER, regulator_name VARCHAR,
CONSTRAINT regulators_u UNIQUE (dataset_id, regulator_name) ON CONFLICT IGNORE,
CONSTRAINT regulators_g_f FOREIGN KEY (gene_id) REFERENCES genes(gene_id),
CONSTRAINT regulators_d_f FOREIGN KEY (dataset_id) REFERENCES expression_dataset_annotation(dataset_id))',
   'CREATE TABLE figure_annotation (figure_id INTEGER PRIMARY KEY, filename, name VARCHAR, description VARCHAR, priority INTEGER,
CONSTRAINT figure_annotation_u UNIQUE (filename, name) ON CONFLICT IGNORE)',
   'CREATE TABLE experiment_annotation (experiment_id INTEGER PRIMARY KEY, dataset_id INTEGER, regulator_id INTEGER, loop_variable INTEGER, model_translation BOOLEAN, number_of_parameters INTEGER, parameter_names VARCHAR, producer VARCHAR, timestamp VARCHAR, description VARCHAR, name VARCHAR,
CONSTRAINT experiment_annotation_u UNIQUE (dataset_id, regulator_id, loop_variable, model_translation, name) ON CONFLICT IGNORE,
CONSTRAINT experiment_annotation_d_f FOREIGN KEY (dataset_id) REFERENCES expression_dataset_annotation(dataset_id),
CONSTRAINT experiment_annotation_r_f FOREIGN KEY (regulator_id) REFERENCES regulators(regulator_id))',
   'CREATE TABLE experiment_set (experiment_set_id INTEGER PRIMARY KEY, parent_id INTEGER, name VARCHAR,
CONSTRAINT experiment_set_u UNIQUE (name) ON CONFLICT IGNORE,
CONSTRAINT experiment_set_p_f FOREIGN KEY (parent_id) REFERENCES experiment_set(experiment_set_id))',
   'CREATE TABLE experiment_set_experiments (experiment_set_id INTEGER, experiment_id INTEGER,
CONSTRAINT experiment_set_experiments_u UNIQUE (experiment_set_id, experiment_id) ON CONFLICT IGNORE,
CONSTRAINT experiment_set_experiments_s_f FOREIGN KEY (experiment_set_id) REFERENCES experiment_set(experiment_set_id),
CONSTRAINT experiment_set_experiments_e_f FOREIGN KEY (experiment_id) REFERENCES experiment_annotation(experiment_id))',
   'CREATE TABLE expression_dataset_annotation (dataset_id INTEGER PRIMARY KEY, dataset_name VARCHAR, species VARCHAR, source VARCHAR, platform VARCHAR, description VARCHAR, save_location VARCHAR, figure_filename VARCHAR,
CONSTRAINT expression_dataset_annotation_u UNIQUE (dataset_name) ON CONFLICT IGNORE)',
   'CREATE TABLE alias_annotation (alias_id INTEGER PRIMARY KEY, dataset_id INTEGER, alias_class VARCHAR, source VARCHAR, description VARCHAR,
CONSTRAINT alias_annotation_u UNIQUE (dataset_id, alias_class) ON CONFLICT IGNORE,
CONSTRAINT alias_annotation_d_f FOREIGN KEY (dataset_id) REFERENCES expression_dataset_annotation(dataset_id))',
   'CREATE TABLE supplementary_dataset_annotation (supp_dataset_id INTEGER PRIMARY KEY, supp_dataset_type INTEGER, supp_dataset_name VARCHAR, regulator_id INTEGER, source VARCHAR, platform VARCHAR, description VARCHAR,
CONSTRAINT supplementary_dataset_annotation_u UNIQUE (supp_dataset_name, regulator_id) ON CONFLICT IGNORE,
CONSTRAINT supplementary_dataset_annotation_r_f FOREIGN KEY (regulator_id) REFERENCES regulators(regulator_id))')

  VERSION <- 1

  tableCount <- length(dbListTables(db))
  if (tableCount > 0) {
    return(FALSE)
  }

  for (i in seq_along(tables)) {
    table <- tables[i]
    dbExecute(db, table)
  }

  dbGetQuery(db, paste("PRAGMA user_version = ", VERSION))
  return(TRUE)
}

.getVersion <- function(db) {
  return(dbGetQuery(db, "PRAGMA user_version")[1,1])
}

.addAndGetAliasId <- function(db, datasetId, aliasClass, source='', description='') {
  query <- paste("INSERT INTO alias_annotation",
                 "VALUES (null, :did, :class, :source, :desc)")
  dbExecute(db, query, params = list(did = datasetId, class = aliasClass, source = source, desc = description))

  alias_query <- paste("SELECT aa.alias_id",
                       "FROM alias_annotation AS aa",
                       "WHERE aa.alias_class = :ac AND aa.dataset_id = :did")
  alias_id <- dbGetQuery(db, alias_query, params = list(ac = aliasClass, did = datasetId))
  return(alias_id[1,1])
}

.addAndGetProbeGeneIds <- function(db, probeNames) {
  insert_query <- paste("INSERT INTO genes",
                        "VALUES (null, :probe)")
  dbExecute(db, insert_query, params = list(probe=probeNames))

  query <- paste("SELECT g.probe_name, g.gene_id",
                 "FROM genes AS g",
                 "WHERE g.probe_name IN (:probe_names)")
  result <- dbGetQuery(db, query, params = list(probe_names = probeNames))
  return(result)
}

.getProbeGeneId <- function(db, probe) {
  query <- paste("SELECT g.gene_id",
                 "FROM genes AS g",
                 "WHERE g.probe_name = :probe")
  return(dbGetQuery(db, query, params = list(probe = probe)))
}

.addAndGetRegulatorId <- function(db, regulatorName, datasetId) {
  insert_query <- paste("INSERT INTO regulators",
                        "VALUES (null, :gene_id, :dataset_id, :regulator_name)")

  gene_id <- .getProbeGeneId(db, regulatorName)
  if (nrow(gene_id) == 0) {
    gene_id <- NA
  } else {
    gene_id <- gene_id[1,1]
  }

  dbExecute(db, insert_query, params = list(gene_id = gene_id, dataset_id = datasetId, regulator_name = regulatorName))

  query <- paste("SELECT r.regulator_id",
                 "FROM regulators AS r",
                 "WHERE r.regulator_name = :regulator_name")
  regulator_id <- dbGetQuery(db, query, params = list(regulator_name = regulatorName))
  return(regulator_id[1,1])
}

.addAndGetDatasetId <- function(db, name, species='', source='', platform='', description='', saveLocation='', figureFilename='') {
  query <- paste("INSERT INTO expression_dataset_annotation",
                 "VALUES (null, :name, :species, :source, :platform, :desc, :save_location, :figure_filename)")
  dbExecute(db, query, params=list(name = name, species = species, source = source, platform = platform, desc = description, save_location = saveLocation, figure_filename = figureFilename))

  dataset_query <- paste("SELECT d.dataset_id",
                         "FROM expression_dataset_annotation AS d",
                         "WHERE d.dataset_name = :dname")
  dataset_id <- dbGetQuery(db, dataset_query, params = list(dname = name))
  return(dataset_id[1,1])
}

.addAndGetExperimentId <- function(db, name, description, datasetId, regulatorId=NA, loopVariable=2, modelTranslation=FALSE, numberOfParameters=NA, parameterNames=NA, producer='', timestamp='') {
  insert_query <- paste("INSERT INTO experiment_annotation",
                        "VALUES (null, :dataset_id, :regulator_id, :loop_variable, :model_translation, :number_of_parameters, :parameter_names, :producer, :timestamp, :description, :name)")
  dbExecute(db, insert_query, params = list(dataset_id = datasetId, regulator_id = regulatorId, loop_variable = loopVariable, model_translation = modelTranslation, number_of_parameters = numberOfParameters, parameter_names = parameterNames, producer = producer, timestamp = timestamp, description = description, name = name))

  query <- paste("SELECT e.experiment_id",
                 "FROM experiment_annotation AS e",
                 "WHERE e.name = :name AND e.dataset_id = :dataset_id AND e.regulator_id = :regulator_id AND e.loop_variable = :loop_variable AND e.model_translation = :model_translation")
  experiment_id <- dbGetQuery(db, query, params = list(name = name, dataset_id = datasetId, regulator_id = regulatorId, loop_variable = loopVariable, model_translation = modelTranslation))
  return(experiment_id[1,1])
}

.addAndGetFigureId <- function(db, filename, name='', description='', priority=0) {
  insert_query <- paste("INSERT INTO figure_annotation",
                        "VALUES (null, :filename, :name, :description, :priority)")
  dbExecute(db, insert_query, params = list(filename = filename, name = name, description = description, priority = priority))

  query <- paste("SELECT f.figure_id",
                 "FROM figure_annotation AS f",
                 "WHERE f.filename = :filename AND f.name = :name")
  figure_id <- dbGetQuery(db, query, params = list(filename = filename, name = name))
  return(figure_id[1,1])
}

.addAndGetSupplementaryDataId <- function(db, name, regulatorId=NA, type=0, source='', platform='', description='') {
  insert_query <- paste("INSERT INTO supplementary_dataset_annotation",
                        "VALUES (null, :type, :name, :regulator_id, :source, :platform, :description)")
  dbExecute(db, insert_query, params = list(type = type, name = name, regulator_id = regulatorId, source = source, platform = platform, description = description))

  if (is.na(regulatorId)) {
      query <- paste("SELECT s.supp_dataset_id",
                     "FROM supplementary_dataset_annotation AS s",
                     "WHERE s.supp_dataset_name = :name")
      supp_id <- dbGetQuery(db, query, params = list(name = name))
  } else {
      query <- paste("SELECT s.supp_dataset_id",
                     "FROM supplementary_dataset_annotation AS s",
                     "WHERE s.supp_dataset_name = :name AND s.regulator_id = :regulator_id")
      supp_id <- dbGetQuery(db, query, params = list(name = name, regulator_id = regulatorId))
  }
  return(supp_id[1,1])
}

.addAndGetExperimentSetId <- function(db, name, parentId) {
  insert_query <- paste("INSERT INTO experiment_set",
                        "VALUES (null, :parent_id, :name)")
  dbExecute(db, insert_query, params = list(parent_id = parentId, name = name))

  query <- paste("SELECT s.experiment_set_id",
                 "FROM experiment_set AS s",
                 "WHERE s.name = :name")
  set_id <- dbGetQuery(db, query, params = list(name = name))
  return(set_id[1,1])
}

.addExperimentSetExperiments <- function(db, setId, experimentIds) {
  insert_query <- paste("INSERT INTO experiment_set_experiments",
                        "VALUES (:set_id, :experiment_id)")
  dbExecute(db, insert_query, params = list(set_id = setId, experiment_id = experimentIds))
}

.addSupplementaryData <- function(db, suppDatasetId, suppData) {
  insert_query <- paste("INSERT INTO supplementary_data",
                        "VALUES (:gene_id, :supp_id, :value)")

  probes <- names(suppData)
  probe_gene_ids <- .addAndGetProbeGeneIds(db, probes)
  data <- as.data.frame(cbind(probe_gene_ids, suppDatasetId, suppData))
  data <- data[2:4] # remove probe_name column
  names(data) <- cbind("gene_id", "supp_id", "value")
  dbExecute(db, insert_query, params = as.list(data))
}

.addFigures <- function(db, experimentId, filename, name='', description='', priority=0, figureData=NULL) {
  insert_query <- paste("INSERT INTO figures",
                        "VALUES (:experiment_id, :figure_id)")

  figure_id <- .addAndGetFigureId(db, filename, name, description, priority)
  dbExecute(db, insert_query, params = list(experiment_id = experimentId, figure_id = figure_id))

  if (length(figureData) > 0) {
    insert_query <- paste("INSERT INTO figuredata",
                          "VALUES (:figure_id, :gene_id, :data)")

    probes <- names(figureData)
    probe_gene_ids <- .addAndGetProbeGeneIds(db, probes)
    data <- as.data.frame(cbind(figure_id, probe_gene_ids, I(figureData)))
    data <- data[c(1,3,4)] # remove probe_name column

    # replace filename column by raw file contents
    for (k in seq_along(data[[3]])) {
      name <- data[[3]][[k]]
      to.read <- file(name, "rb")
      fileSize <- file.info(name)$size
      data[[3]][[k]] <- I(readBin(to.read, "raw", n=fileSize))
      close(to.read)
    }

    names(data) <- cbind("figure_id", "gene_id", "data")
    dbExecute(db, insert_query, params = as.list(data))
  }
}

.addResults <- function(db, experimentId, logLikelihoods, baselineLogLikelihoods=NA, params=NA) {
  insert_query <- paste("INSERT INTO results",
                        "VALUES (:gene_id, :experiment_id, :log_likelihood, :baseline_log_likelihood, :params)")
  probes <- names(logLikelihoods)
  probe_gene_ids <- .addAndGetProbeGeneIds(db, probes)
  data <- as.data.frame(cbind(probe_gene_ids, experimentId, logLikelihoods, baselineLogLikelihoods, I(lapply(params, function(x) serialize(x, NULL, ascii = FALSE)))))
  data <- data[2:6] # remove probe_name column
  names(data) <- cbind("gene_id", "experiment_id", "log_likelihood", "baseline_log_likelihood", "params")
  dbExecute(db, insert_query, params = as.list(data))
}

.addGeneAliases <- function(db, aliasId, geneId, aliasList) {
  insert_query <- paste("INSERT INTO gene_aliases",
                        "VALUES (:gene_id, :alias_id, :alias)")
  for (alias in aliasList) {
    dbExecute(db, insert_query, params = list(gene_id = geneId, alias_id = aliasId, alias = alias))
  }
}

.addZscores <- function(db, datasetId, zscores) {
  insert_query <- paste("INSERT INTO z_scores",
                        "VALUES (:gene_id, :dataset_id, :zscore)")
  probes <- names(zscores)
  probe_gene_ids <- .addAndGetProbeGeneIds(db, probes)
  data <- as.data.frame(cbind(probe_gene_ids, datasetId, zscores))
  data <- data[2:4] # remove probe_name column
  names(data) <- cbind("gene_id", "dataset_id", "zscore")
  dbExecute(db, insert_query, params = as.list(data))
}

.addTargetSet <- function(db, experimentId, probes) {
  insert_query <- paste("INSERT INTO target_sets",
                        "VALUES (:experiment_id, :gene_id)")
  probe_gene_ids <- .addAndGetProbeGeneIds(db, probes)
  data <- as.data.frame(cbind(experimentId, probe_gene_ids))
  data <- data[c(1,3)] # remove probe_name column
  names(data) <- cbind("experiment_id", "gene_id")
  dbExecute(db, insert_query, as.list(data))
}

.addAliases <- function(db, probes, preprocData, datasetId, aliasType) {
  aliasSource <- annotation(preprocData)
  aliasDescription <- aliasType
  aliasClass <- sub("2PROBE", "", aliasType, ignore.case = TRUE)
  alias_id <- .addAndGetAliasId(db, datasetId, aliasClass, aliasSource, aliasDescription)
  aliasMapping <- getAnnMap(aliasType, annotation(preprocData))

  if (length(grep("2PROBE", aliasType, ignore.case = TRUE)) > 0) { # reversed mapping
    aliases <- revmap(aliasMapping)
  } else {
    aliases <- aliasMapping
  }

  aliases <- as.list(aliases)
  probe_gene_ids <- .addAndGetProbeGeneIds(db, probes)

  dbBeginTransaction(db)
  for (i in seq_along(probe_gene_ids[[1]])) {
    probe <- probe_gene_ids[i, 1]
    gene_id <- probe_gene_ids[i, 2]
    if (probe %in% names(aliases)) {
      alias_list <- aliases[probe]
      .addGeneAliases(db, alias_id, gene_id, alias_list)
    }
  }
  dbCommit(db)
}

.getLoopVariables <- function(db) {
  query <- paste("SELECT e.loop_variable",
                 "FROM experiment_annotation AS e")

  loopVariables <- dbGetQuery(db, query)$loop_variable
  return(loopVariables)
}

export.scores <- function(scores, datasetName='', experimentSet='',
    databaseFile='database.sqlite', preprocData=NULL, models=NULL,
    figpath=NULL, aliasTypes=c("SYMBOL", "GENENAME", "ENTREZID"),
    datasetSource='', datasetDescription='',
    datasetSaveLocation='', datasetFigureFilename='',
    experimentTimestamp=as.character(Sys.Date()),
    figureDesc='', figurePrio=0, regulator=NULL) {

  if (datasetName == '') {
    tryCatch(datasetName <- datasetName(scores), error=function(e) message('old version of scoreList object detected'))
  }

  if (experimentSet == '') {
    tryCatch(experimentSet <- experimentSet(scores), error=function(e) message('old version of scoreList object detected'))
  }

  if (datasetName == '') {
    stop('datasetName not defined')
  }

  if (experimentSet == '') {
    stop('experimentSet not defined')
  }

  experimentProducer <- paste('tigre', sessionInfo('tigre')[["otherPkgs"]][['tigre']]$Version)

  if (TF(scores) == "(see genes)") { # TODO
    loopTarget <- modelArgs(scores)[[1]]$targets
    loopVariable <- 1 # loop TFs, target set constant
    TF <- NULL
    targetSet <- modelArgs(scores)[[1]]$targets
  } else {
    loopTarget <- TF(scores)
    loopVariable <- 2 # loop targets, TF constant
    if (! is.null(regulator)) {
      TF <- regulator
    } else {
      TF <- modelArgs(scores)[[1]]$TF
      if (is.null(TF))
        TF <- "N/A"
    }
    targetSet <- NULL
  }

  db <- .openConnection(databaseFile)
  .createTables(db)

  loopVariables <- .getLoopVariables(db)
  if (length(loopVariables) > 0 && loopVariables[[1]] != loopVariable) {
    stop('Error: Same database cannot contain results from looping over TFs and looping over targets.')
  }

  # Generate models if necessary and possible
  #if (is.null(models) && !is.null(preprocData)) {
  #  message("Generating models...")
  #  models <- generateModels(preprocData, scores)
  #}

  figureData <- list()
  if (!is.null(figpath) && (!is.null(models) || !is.null(preprocData))) {
    message("Generating figures...")
    figureFilename <- file.path(figpath, paste('model_', loopTarget, '_${probe_name}.png', sep=""))
    len <- length(scores)
    for (k in seq(along=scores)) {
      message(paste("figure", k, "/", len))
      if (is.null(models))
        m <- generateModels(preprocData, scores[k])[[1]]
      else
        m <- models[[k]]
      png(file.path(figpath, paste('model_', loopTarget, '_', genes(scores)[k], '.png', sep="")))
      GPPlot(m)
      dev.off()
    }
  } else if (!is.null(models) || !is.null(preprocData)) {
    message("Generating figures...")
    figureFilename <- ''
    len <- length(scores)
    for (k in seq(along=scores)) {
      message(paste("figure", k, "/", len))
      if (is.null(models))
        m <- generateModels(preprocData, scores[k])[[1]]
      else
        m <- models[[k]]
      filename <- tempfile()
      png(filename)
      GPPlot(m)
      dev.off()
      figureData[[genes(scores)[[k]]]] <- filename
    }
  }

  if (modelArgs(scores)[[1]]$useGpdisim) {
    modelTranslation <- TRUE
    experimentName <- "GPDISIM"
  } else {
    modelTranslation <- FALSE
    experimentName <- "GPSIM"
  }

  experimentDesc <- experimentName
  if (length(knownTargets(scores)) > 1 || nchar(knownTargets(scores)) > 0) {
    experimentName <- paste(paste(experimentName, ',', sep=''), length(knownTargets(scores)), "known target(s)")
  }

  has.annotation <- FALSE
  if (!is.null(preprocData)) {
    has.annotation <- length(annotation(preprocData)) > 0
  }
  if (!has.annotation) {
    message('Warning: annotation(preprocData) is not defined, cannot add aliases')
  }

  datasetSpecies <- ''
  datasetPlatform <- ''
  if (!is.null(preprocData) && has.annotation) {
    datasetSpecies <- getAnnMap('ORGANISM', annotation(preprocData))
    datasetPlatform <- annotation(preprocData)
  }

  datasetId <- .addAndGetDatasetId(db, datasetName, datasetSpecies, datasetSource, datasetPlatform, datasetDescription, datasetSaveLocation, datasetFigureFilename)

  # Add aliases
  if (!is.null(preprocData) && has.annotation) {
    message("Adding aliases...")
    if (TF %in% featureNames(preprocData))
      probes <- c(names(loglikelihoods(scores)), TF, targetSet)
    else
      probes <- c(names(loglikelihoods(scores)), targetSet)
    len <- length(aliasTypes)
    for (i in seq_along(aliasTypes)) {
      message(paste("alias type", i, "/", len, paste("(", aliasTypes[[i]],")", sep="")))
      .addAliases(db, probes, preprocData, datasetId, aliasTypes[[i]])
    }
  }

  # Add z-scores
  if (!is.null(preprocData) && 'var.exprs' %in% assayDataElementNames(preprocData)) {
    message("Adding z-scores...")
    if (TF %in% featureNames(preprocData))
      probes <- c(names(loglikelihoods(scores)), TF, targetSet)
    else
      probes <- c(names(loglikelihoods(scores)), targetSet)
    
    data <- preprocData[probes,]
    y <- assayDataElement(data, 'exprs')
    yvar <- assayDataElement(data, 'var.exprs')

    zScores <- rowMeans(y / sqrt(yvar))
    .addZscores(db, datasetId, zScores)
  }

  if (!is.null(TF)) {
    regId <- .addAndGetRegulatorId(db, TF, datasetId)
  } else {
    regId <- NA
  }

  parameters <- params(scores)
  numberOfParameters <- length(parameters[[1]])
  parameterNames <- NA

  if (!is.null(models)) {
    parameterNames <- paste(names(modelExtractParam(models[[1]], only.values=FALSE)), collapse=',')
  } else if (!is.null(preprocData)) {
    m <- generateModels(preprocData, scores[1])
    parameterNames <- paste(names(modelExtractParam(m[[1]], only.values=FALSE)), collapse=',')
  }

  message("Adding results...")
  experimentId <- .addAndGetExperimentId(db, experimentName, experimentDesc, datasetId, regulatorId=regId, loopVariable=loopVariable, modelTranslation=modelTranslation, numberOfParameters=numberOfParameters, parameterNames=parameterNames, producer=experimentProducer, timestamp=experimentTimestamp)
  .addResults(db, experimentId, loglikelihoods(scores), baseloglikelihoods(scores), parameters)

  if (!is.null(figpath) || length(figureData) > 0) {
    message("Adding figures...")
    .addFigures(db, experimentId, figureFilename, name=paste(experimentName, loopTarget), description=figureDesc, priority=figurePrio, figureData=figureData)
  }

  if (!is.null(targetSet)) {
    .addTargetSet(db, experimentId, targetSet)
  }

  rootId <- .addAndGetExperimentSetId(db, 'All experiments', NA)
  setId <- .addAndGetExperimentSetId(db, paste(experimentSet, ' (', datasetName, ')', sep=''), rootId)
  .addExperimentSetExperiments(db, setId, experimentId)

  dbDisconnect(db)
  message("All done.")
}

rbfKernParamInit <- function (kern) {
  kern$inverseWidth <- 1
  kern$variance <- 1
  kern$nParams <- 2
  kern$paramNames <- c("inverseWidth", "variance")
  
  kern$isStationary <- TRUE

  if ("options" %in% names(kern) && "isNormalised" %in% names(kern$options) && kern$options$isNormalised)
    kern$isNormalised <- TRUE
  else
    kern$isNormalised <- FALSE

  if ("options" %in% names(kern) && "inverseWidthBounds" %in% names(kern$options)) {
    kern$transforms <- list(list(index=1, type="bounded"),
                            list(index=2, type="positive"))
    kern$transformArgs <- list()
    kern$transformArgs[[1]] <- kern$options$inverseWidthBounds
    kern$inverseWidth <- mean(kern$options$inverseWidthBounds)
  }
  else {
    kern$transforms <- list(list(index=c(1,2), type="positive"))
  }

  return (kern)
}



# untransformed.values is ignored
rbfKernExtractParam <- function (kern, only.values=TRUE,
                                 untransformed.values=TRUE) {
  params <- c(kern$inverseWidth, kern$variance)

  if ( !only.values )
    names(params) <- c("inverseWidth", "variance")

  return (params)
}



rbfKernExpandParam <- function (kern, params) {
  if ( is.list(params) )
    params <- params$values

  kern$inverseWidth <- params[1]
  kern$variance <- params[2]

  return (kern)
}


rbfKernDisplay <- function (kern, spaceNum=0) {
  spacing <- matrix("", spaceNum+1)
  cat(spacing)
  if ("isNormalised" %in% names(kern) && kern$isNormalised)
    cat("Normalised version of the kernel.\n")
  else
    cat("Unnormalised version of the kernel.\n")
  cat(spacing)
  cat("RBF inverse width: ", kern$inverseWidth, " (length scale ", 1/sqrt(kern$inverseWidth), ")\n", sep="")
  cat(spacing)
  cat("RBF variance: ", kern$variance, "\n", sep="")
}

rbfKernCompute <- function (kern, x, x2=NULL) {
  if ( nargs() < 3 ) {
    n2 <- .dist2(x,x)
  } else {
    n2 <- .dist2(x,x2)
  }

  wi2 <- 0.5*kern$inverseWidth
  k <- kern$variance*exp(-n2*wi2)

  if ("isNormalised" %in% names(kern) && kern$isNormalised)
    k <- k * sqrt(kern$inverseWidth/(2*pi))
  
  return (k)
}



rbfKernGradient <- function (kern, x, x2, covGrad) {
  if ( nargs()==3 ) {
    dist2xx <- .dist2(x, x)
    covGrad <- x2
  } else if ( nargs()==4 ) {
    dist2xx <- .dist2(x, x2)
  }
  wi2 <- 0.5*kern$inverseWidth
  k <- kern$variance*exp(-dist2xx*wi2)
  g <- array(0, 2)

  if ("isNormalised" %in% names(kern) && kern$isNormalised) {
    k <- k * sqrt(kern$inverseWidth/(2*pi))

    g[1] <- -0.5*sum(covGrad*k*dist2xx) +
      0.5 * sum(covGrad*k)/kern$inverseWidth
  }
  else {
    g[1] <- -0.5*sum(covGrad*k*dist2xx)
  }
  g[2] <- sum(covGrad*k)/kern$variance

  if ( any(is.nan(g)) )
    warning("g is NaN.")

  return (g)
}



rbfKernDiagCompute <- function (kern, x) {
  k <- matrix(kern$variance, dim(as.array(x))[1], 1)

  if ("isNormalised" %in% names(kern) && kern$isNormalised)
    k <- k * sqrt(kern$inverseWidth/(2*pi))

  return (k)
}

cmpndKernParamInit <- function (kern) {
  
  kern$nParams <- 0
  kern$transforms <- list()

  if ( ! ("comp" %in% names(kern)) )
    kern$comp <- list()

  for ( i in seq(along=kern$comp) ) {

    kern$comp[[i]] <- kernParamInit(kern$comp[[i]])
    kern$nParams <- kern$nParams + kern$comp[[i]]$nParams
    kern$comp[[i]]$index <- array()

    if ( "numBlocks" %in% names(kern$comp[[i]]) ) {
      if ( i==1 ) {
        kern$numBlocks <- kern$comp[[i]]$numBlocks
      } else {
        if ( (!("numBlocks" %in% names(kern))) | (kern$numBlocks!=kern$comp[[i]]$numBlocks) ) {
          stop("Compound of multi kernels with different numbers of blocks.")
        }
      }
    } else {
      if ( "numBlocks" %in% names(kern) )
        stop("Attempt to combine multi-kernel with non multi-kernel.")
    }
  }

  kern$paramGroups <- diag(1, nrow=kern$nParams, ncol=kern$nParams)

  kern$whiteVariance <- 0
  kern$isStationary <- TRUE

  for ( i in seq(along=kern$comp) ) {
    if ( !kern$comp[[i]]$isStationary )
      kern$isStationary <- FALSE

    if ( kern$comp[[i]]$type == "white" ) {
      kern$whiteVariance <- kern$whiteVariance + kern$comp[[i]]$variance
    } else {
      if ( "whiteVariance" %in% names(kern$comp[[i]]) ) {
        kern$whiteVariance <- kern$whiteVariance + kern$comp[[i]]$whiteVariance
      }
    }
  }

  return (kern)
  
}



cmpndKernExtractParam <- function (kern, only.values=TRUE,
                                   untransformed.values=FALSE) {

  startVal <- 1
  endVal <- 0
  
  if ( only.values ) {
    params <- c()

    for ( i in seq(along=kern$comp) ) 
      params <- c(params, kernExtractParam(kern$comp[[i]],
                                           untransformed.values=untransformed.values))

  } else {
    storedTypes <- c()
    params <- c()
    paramNames <- c()
    origNames <- c()
    for ( i in seq(along=kern$comp) ) {
      paramsList <- kernExtractParam(kern$comp[[i]], only.values=only.values,
                                     untransformed.values=untransformed.values)
      params <- c(params, paramsList)
      kernName <- paste(kern$comp[[i]]$type, length(grep(kern$comp[[i]]$type, storedTypes))+1, sep="")
      paramName <- paste(kernName, names(paramsList), sep="_")
      origNames <- c(origNames, paramName)
      storedTypes <- c(storedTypes, kern$comp[[i]]$type)
    }
  }

  paramNames <- array()
  if ( "paramGroups" %in% names(kern) ) {
    paramGroups <- kern$paramGroups
    for ( i in seq(length.out=dim(paramGroups)[2]) ) {
      ind <- grep(1, paramGroups[,i])
      if ( !only.values ) {
        paramNames[i] <- origNames[ind[1]]
        for ( j in seq(2, length.out=length(ind)-1) )
          paramNames[i] <- paste(paramNames[i], origNames[ind[j]],sep="/")
      }
   
      paramGroups[ind[seq(2,length(ind),length=length(ind)-1)], i] <- 0
    }
  }

  params <- params%*%paramGroups
  if ( !only.values )
    names(params) <- paramNames

  return (params)
}



cmpndKernExpandParam <- function (kern, params) {
  if ( is.list(params) )
    params <- params$values
  params <- params %*% t(kern$paramGroups)
  startVal <- 1
  endVal <- 0
  kern$whiteVariance <- 0
  for ( i in seq(along=kern$comp) ) {
    endVal <- endVal+kern$comp[[i]]$nParams
    kern$comp[[i]] <- kernExpandParam(kern$comp[[i]], params[startVal:endVal])
    startVal <- endVal+1
    if ( "white" %in% kern$comp[[i]]$type ) {
      kern$whiteVariance <- kern$whiteVariance+kern$comp[[i]]$variance
    } else if ( "whiteVariance" %in% names(kern$comp[[i]]) ) {
      kern$whiteVariance <- kern$whiteVariance+kern$comp[[i]]$whiteVariance
    }
  }      

  return (kern)
}



cmpndKernCompute <- function (kern, x, x2) {
  if ( nargs()>2 ) {
    i <- 1
    if ( !is.na(kern$comp[[i]]$index) ) {
      k <- kernCompute(kern$comp[[i]], x[,kern$comp[[i]]$index], x2[,kern$comp[[i]]$index])
    } else {
      k <- kernCompute(kern$comp[[i]], x, x2)
    }
    for ( i in seq(2, length.out=(length(kern$comp)-1)) )
      if ( !is.na(kern$comp[[i]]$index) ) {
        k <- k+kernCompute(kern$comp[[i]], x[,kern$comp[[i]]$index], x2[,kern$comp[[i]]$index])
      } else {
        k <- k+kernCompute(kern$comp[[i]], x, x2)
      }
  } else {
    i <- 1
    if ( !is.na(kern$comp[[i]]$index) ) {
      k <- kernCompute(kern$comp[[i]], x[,kern$comp[[i]]$index])
    } else {
      k <- kernCompute(kern$comp[[i]], x)
    }
    for ( i in seq(2, length.out=(length(kern$comp)-1)) )
      if ( !is.na(kern$comp[[i]]$index) ) {
        k <- k+kernCompute(kern$comp[[i]], x[,kern$comp[[i]]$index])
      } else {
        k <- k+kernCompute(kern$comp[[i]], x)
      }
  }
  return (k)  
}



cmpndKernGradient <- function (kern, x, x2, covGrad) {

  if ( nargs()<4 ) 
    covGrad <- x2
  
  g <- array(0, dim(kern$paramGroups)[1])
  startVal <- 1
  endVal <- 0

  for ( i in seq(along=kern$comp) ) {
    endVal <- endVal + kern$comp[[i]]$nParams
    if ( !is.na(kern$comp[[i]]$index) ) {
      if ( nargs() < 4 ) {
        g[startVal:endVal] <- kernGradient(kern$comp[[i]], x[,kern$comp[[i]]$index], covGrad)
      } else {
        g[startVal:endVal] <- kernGradient(kern$comp[[i]], x[,kern$comp[[i]]$index], x2[,kern$comp[[i]]$index], covGrad)
      }
    } else {
      if ( nargs() < 4 ) {
        g[startVal:endVal] <- kernGradient(kern$comp[[i]], x, covGrad)
      } else {
        g[startVal:endVal] <- kernGradient(kern$comp[[i]], x, x2, covGrad)
      }
    }
    startVal <- endVal + 1       
  }

  g <- g %*% kern$paramGroups    

  return (g)
}



cmpndKernDiagCompute <- function (kern, x) {
  i <- 1
  if ( !is.na(kern$comp[[i]]$index) ) {
    k <- kernDiagCompute(kern$comp[[i]], x[,kern$comp[[i]]$index])
  } else {
    k <- kernDiagCompute(kern$comp[[i]], x)
  }

  for ( i in seq(2, length=(length(kern$comp)-1)) )
    if ( !is.na(kern$comp[[i]]$index) ) {
      k <- k + kernDiagCompute(kern$comp[[i]], x[,kern$comp[[i]]$index])
    } else {
      k <- k + kernDiagCompute(kern$comp[[i]], x)
    }
       
  return (k)
}

cmpndKernDisplay <- function (kern, spaceNum=0) {
  spacing = matrix("", spaceNum+1)
  cat(spacing)
  cat("Compound kernel:\n")
  for(i in seq(along=kern$comp)) 
    kernDisplay(kern$comp[[i]], spaceNum+2)
}

cmpndKernGradX <- function (kern, X, X2) {
  i <- 1
  funcName <- paste(kern$comp[[i]]$type, "KernGradX", sep="")
  func <- get(funcName, mode="function")

  if ( !is.na(kern$comp[[i]]$index) ) {
    gX <- array(0, dim=c(dim(as.array(X2))[1], dim(as.array(X2))[1],
                     dim(as.array(X))[1]))
    gX[,kern$comp[[i]]$index,] <- func(kern$comp[[i]], X[,kern$comp[[i]]$index], X2[,kern$comp[[i]]$index])
  } else {
    gX <- func(kern$comp[[i]], X, X2)
  }

  for ( i in seq(2, length=(length(kern$comp)-1)) ) {
    funcName <- paste(kern$comp[[i]]$type, "KernGradX", sep="")
    func <- get(funcName, mode="function")
    if ( !is.na(kern$comp[[i]]$index) ) {
      gX[,kern$comp[[i]]$index,] <- gX[,kern$comp[[i]]$index,] +  func(kern$comp[[i]], X[,kern$comp[[i]]$index], X2[,kern$comp[[i]]$index])
    } else {
      gX <- gX + func(kern$comp[[i]], X, X2)
    }
  }
 
  return (gX)
}



cmpndKernDiagGradX <- function (kern, X) {
  X <- as.matrix(X)
  i <- 1
  funcName <- paste(kern$comp[[i]]$type, "KernDiagGradX", sep="")
  func <- get(funcName, mode="function")

  if ( !is.na(kern$comp[[i]]$index) ) {
    gX <- array(0, dim=dim(X))
    gX[,kern$comp[[i]]$index,] <- func(kern$comp[[i]], X[,kern$comp[[i]]$index])
  } else {
    gX <- func(kern$comp[[i]], X)
  }

  for ( i in seq(2, length=(length(kern$comp)-1)) ) {
    if ( !is.na(kern$comp[[i]]$index) ) {
      gX[,kern$comp[[i]]$index] <- gX[,kern$comp[[i]]$index] +  func(kern$comp[[i]], X[,kern$comp[[i]]$index])
    } else {
      gX <- gX + func(kern$comp[[i]], X)
    }
  }
 
  return (gX)
}

translateKernDiagCompute <- function (kern, x) {
  x <- x - array(kern$centre, dim(as.array(x))[1])
  k <- cmpndKernDiagCompute(kern, x)
       
  return (k)
}



translateKernExtractParam <- function (kern, only.values=TRUE,
                                       untransformed.values=FALSE) {
  kern$nParams <- kern$nParams - kern$inputDimension
  
  params <- cmpndKernExtractParam(kern, only.values=only.values,
                                  untransformed.values=untransformed.values)
  centre <- c(kern$centre)
  if ( !only.values ) {
    for ( i in seq(length=kern$inputDimension) ) {
      names(centre)[i] <- paste("Centre", i, sep="")
    }
  }
  params <- c(params, centre)

  return (params)
}



translateKernExpandParam <- function (kern, params) {
  if ( is.list(params) )
    params <- params$values

  endVal <- length(params) - kern$inputDimension
  kern <- cmpndKernExpandParam(kern, params[1:endVal])
  startVal <- endVal+1
  endVal <- length(params)
  kern$centre <- params[startVal:endVal]

  return (kern)
}



translateKernCompute <- function (kern, x, x2) {
  if ( nargs()>2 ) {
    x <- x - array(kern$centre, dim(as.array(x))[1])
    x2 <- x2 - array(kern$centre, dim(as.array(x2))[1])
    k <- cmpndKernCompute(kern, x, x2)
  } else {
    x <- x - array(kern$centre, dim(as.array(x))[1])
    k <- cmpndKernCompute(kern, x)
  }
  return (k)  
}



translateKernParamInit <- function (kern) {
  kern <- cmpndKernParamInit(kern)

  kern$nParams <- kern$nParams + kern$inputDimension
  kern$centre <- array(0, kern$inputDimension)

  return (kern)
}



translateKernGradient <- function (kern, x, x2, covGrad) {

  if ( nargs()<4 ) {
    covGrad <- x2
    x <- x - array(kern$centre, dim(as.array(x))[1])
    g <- cmpndKernGradient(kern, x, covGrad)

    gKX <- cmpndKernGradX(kern, x, x)
    gKX <- gKX*2
    dgKX <- cmpndKernDiagGradX(kern, x)
    for ( i in seq(length=dim(gKX)[1]) )
      gKX[i,,i] <- dgKX[i,]
   
  } else {
    x <- x - array(kern$centre, dim(as.array(x))[1])
    x2 <- x2 - array(kern$centre, dim(as.array(x2))[1])
    g <- cmpndKernGradient(kern, x, x2, covGrad)

    gKX12 <- cmpndKernGradX(kern, x, x2)
    gKX21 <- cmpndKernGradX(kern, x2, x)
  }

  gcentre <- array(0, kern$inputDimension)
  if ( nargs()<4 ) {
    for ( i in seq(length=dim(as.array(x))[1]) ) {
      for ( j in seq(length=kern$inputDimension) ) 
        gcentre[j] <- gcentre[j] - t(gKX[,j,i]) %*% covGrad[,i]
    }
  } else {
    for ( i in seq(length=dim(as.array(x))[1]) ) {
      for ( j in seq(length=kern$inputDimension) ) 
        gcentre[j] <- gcentre[j] - sum(gKX12[,j,i]*t(covGrad[i,]))
    }
    for ( i in seq(length=dim(as.array(x2))[1]) ) {
      for ( j in seq(length=kern$inputDimension) ) 
        gcentre[j] <- gcentre[j] - sum(gKX21[,j,i]*t(covGrad[,i]))
    }
  }

  g <- c(g, gcentre)

  return (g)
}

GPPlot <- function(data, savepath = '', nameMapping = NULL,
                   predt = NULL, fileOutput=FALSE, plotTime=NULL) {
  FONTSIZE <- 10;
  LINEWIDTH <- 1;
  MARKERSIZE <- 10;

  if (is.list(data))
    data <- data[[1]]
  
  if (is.GPModel(data))
    model <- modelStruct(data)
  else {
    if ("model" %in% names(data))
      model <- data$model
    else
      model <- data
  }

  if ("annotation" %in% names(model$comp[[1]])) {
    mapping <- try(getAnnMap("SYMBOL", model$comp[[1]]$annotation), silent=TRUE)
    if (class(mapping) != "try-error")
      nameMapping <- mapping
  }

  is_gpdisim_model <- (model$type == 'cgpdisim')
  
  if (is_gpdisim_model) {
    numGenes <- model$comp[[1]]$numGenes + 1
  }
  else {
    numGenes <- model$comp[[1]]$numGenes
  }

  genes <- model$comp[[1]]$genes
  tf <- genes[1]
  targetGenes <- genes[2:length(genes)]

  if (numGenes <= 2) {
    v <- matrix(seq(1, (numGenes+1)*length(model$comp)), nrow=(numGenes+1))
    if (is_gpdisim_model)
      v[1:2,] <- v[seq(2, 1, by=-1),]
    layout(v)
    singlePlot <- TRUE
  }
  else {
    singlePlot <- FALSE
  }
  model <- modelUpdateProcesses(model, predt=predt)
  for ( i in seq(along=model$comp) ) {
    while (any(model$comp[[i]]$varF < 0) || any(model$comp[[i]]$ypredVar < 0)) {
      warning('Negative variances in GPPlot, adding jitter to fix')
      if (any(model$comp[[i]]$varF < 0))
        model$comp[[i]]$varF <- model$comp[[i]]$varF - 2*min(model$comp[[i]]$varF)
      if (any(model$comp[[i]]$ypredVar < 0))
        model$comp[[i]]$ypredVar <- model$comp[[i]]$ypredVar - 2*min(model$comp[[i]]$ypredVar)
    }

    if (!singlePlot)
      par(mfrow = c(3, ceiling((numGenes+1) / 3)))

    #par(mfrow = c(2, trunc(numPlots / 2 + 0.5)))
    #if (!fileOutput)
    #  dev.new()

    #par(mfrow=c(2, 2))
    plot(model$comp[[i]]$predt, model$comp[[i]]$predF,
         ylim=c(min(model$comp[[i]]$predF-2*sqrt(model$comp[[i]]$varF)),
           max(model$comp[[i]]$predF+2*sqrt(model$comp[[i]]$varF))),
         type="l", lwd=3, xlab="Time",ylab="")
    polygon(c(model$comp[[i]]$predt, rev(model$comp[[i]]$predt)),
            c(model$comp[[i]]$predF+2*sqrt(model$comp[[i]]$varF),
              rev(model$comp[[i]]$predF-2*sqrt(model$comp[[i]]$varF))),
            col='grey', border=NA)
    lines(model$comp[[i]]$predt, model$comp[[i]]$predF,
          ylim=c(min(model$comp[[i]]$predF-2*sqrt(model$comp[[i]]$varF)),
            max(model$comp[[i]]$predF+2*sqrt(model$comp[[i]]$varF))),
          type="l", lwd=3, col='blue', xlab="Time",ylab="")
    title("Inferred TF Protein Concentration")

    for ( j in seq(length=numGenes) ) {
      plot(model$comp[[i]]$predt, model$comp[[i]]$ypred[,j],
           ylim=c(min(c(model$comp[[i]]$ypred[,j]-2*sqrt(model$comp[[i]]$ypredVar[,j]),
             model$comp[[i]]$y[,j]-2*sqrt(model$comp[[i]]$yvar[,j]))),
             max(c(model$comp[[i]]$ypred[,j]+2*sqrt(model$comp[[i]]$ypredVar[,j]),
                   model$comp[[i]]$y[,j]+2*sqrt(model$comp[[i]]$yvar[,j])))),
           type="l", lwd=3, xlab="Time",ylab="")
      polygon(c(model$comp[[i]]$predt, rev(model$comp[[i]]$predt)),
              c(model$comp[[i]]$ypred[,j]+2*sqrt(model$comp[[i]]$ypredVar[,j]),
                rev(model$comp[[i]]$ypred[,j]-2*sqrt(model$comp[[i]]$ypredVar[,j]))),
              col='grey', border=NA)

      lines(model$comp[[i]]$predt, model$comp[[i]]$ypred[,j],
            ylim=c(min(c(model$comp[[i]]$ypred[,j]-2*sqrt(model$comp[[i]]$ypredVar[,j]),
              model$comp[[i]]$y[,j]-2*sqrt(model$comp[[i]]$yvar[,j]))),
              max(c(model$comp[[i]]$ypred[,j]+2*sqrt(model$comp[[i]]$ypredVar[,j]),
                    model$comp[[i]]$y[,j]+2*sqrt(model$comp[[i]]$yvar[,j])))),
            type="l", lwd=3, col='blue', xlab="Time",ylab="")
      if ( is.null(nameMapping) ) {
        genename <- genes[j]
      } else {
        genename <- paste(get(genes[j], nameMapping), " (", genes[j], ")", sep='')
      }
      
      if ( j==1 && is_gpdisim_model ) {
        title(paste(genename, "mRNA (input)"))
      } else {
        title(paste(genename, "mRNA"))
      }

      if (is.null(plotTime)) {
        if ("realt" %in% names(model$comp[[i]]))
          plotTime <- model$comp[[i]]$realt
        else if ("timesCell" %in% names(model$comp[[i]]))
          plotTime <- model$comp[[i]]$timesCell$mRNA
        else
          plotTime <- model$comp[[i]]$t
      }

      # plotCI seems to generate a lot of spurious warnings
      warnOption <- getOption('warn')
      options(warn=-1)
      plotCI(plotTime, model$comp[[i]]$y[,j],
             uiw=2*sqrt(model$comp[[i]]$yvar[,j]), lwd=3, col='red', add=TRUE)
      options(warn=warnOption)
      #points(model$comp[[i]]$t, model$comp[[i]]$y[,j], lwd=3, col=3)
    }
  }
 
}


plotTimeseries <- function(data, nameMapping=NULL) {
  mapping <- try(getAnnMap("SYMBOL", annotation(data)), silent=TRUE)
  if (class(mapping) != "try-error")
    nameMapping <- mapping

  exps <- unique(data$experiments)
  tshifts <- seq(-0.2, 0.2, length.out=length(exps))

  ngenes <- dim(data)[1]

  nrows = floor(sqrt(ngenes))
  par(mfrow = c(nrows, ceiling(ngenes / nrows)))

  for (j in seq(ngenes)) {
    for (i in exps) {
      t <- data$modeltime[data$experiments==i] + tshifts[i]
      m <- exprs(data)[j,data$experiments==i]
      if (! is.null(var.exprs(data))) {
        sd <- sqrt(var.exprs(data)[j,data$experiments==i])
        maxsd <- sqrt(var.exprs(data)[j,])
      } else {
        sd <- 0*m
        maxsd <- 0*exprs(data)[j,]
      }
      probe <- featureNames(data)[j]
      if (i==1) {
        plot(t, m, type='l',
             ylim=c(0, max(exprs(data)[j,] + 2*maxsd)))
      } else {
        lines(t, m)
      }
      warnOption <- getOption('warn')
      options(warn=-1)
      plotCI(t, m,
             uiw=2*sd, lwd=1, col=3, add=TRUE)
      options(warn=warnOption)
      if (!is.null(nameMapping)) {
        title(paste(get(probe, nameMapping), " (", probe, ")", sep=''))
      } else {
        title(probe)
      }
    }
  }
}

whiteKernParamInit <- function (kern) {
  
  kern$variance <- exp(-2)
  kern$nParams <- 1
  kern$paramNames <- c("variance")
  
  kern$transforms <- list(list(index=c(1), type="positive"))

  kern$isStationary <- TRUE

  return (kern)
}


whiteXwhiteKernCompute <- function (whiteKern1, whiteKern2, x1, x2) {
  if ( nargs()<4 )
    x2=x1

  k <- matrix(0, nrow=dim(as.array(x1))[1], ncol=dim(as.array(x2))[1])
  return (k)  
}


whiteKernDisplay <- function (kern, spaceNum=0) {
  spacing <- matrix("", spaceNum+1)
  cat(spacing)
  cat("White Noise Variance: ", kern$variance, "\n", sep="")
}


whiteKernCompute <- function (kern, x, x2) {
  if ( nargs()<3 ) {
    xdim <- dim(as.array(x))[1]
    k <- kern$variance*diag(1, nrow=xdim, ncol=xdim)
  } else {
    x1dim <- dim(as.array(x))[1]
    x2dim <- dim(as.array(x2))[1]
    k <- matrix(0, nrow=x1dim, ncol=x2dim)
  }
  return (k)
}



# untransformed.values is ignored
whiteKernExtractParam <- function (kern, only.values=TRUE,
                                   untransformed.values=TRUE) {
  params <- c(kern$variance)

  if ( !only.values ) {
    names(params) <- c("variance")
  }

  return (params)
}



whiteKernExpandParam <- function (kern, params) {
  if ( is.list(params) )
    params <- params$values

  kern$variance <- params[1]

  return (kern)
}



whiteKernGradient <- function (kern, x, x2, covGrad) {
  if ( nargs()==3 ) {
    covGrad <- x2
    g <- sum(diag(as.matrix(covGrad)))
  } else {
    g <- 0
  }  

  return (g)
}



whiteXwhiteKernGradient <- function (whiteKern1, whiteKern2, x1, x2, covGrad) {
  if ( nargs()<5 ) {
    covGrad <- x2
    x2 <- x1
  }
  
  if ( dim(as.matrix(x1))[2]>1 | dim(as.matrix(x2))[2]>1 )
    stop("Input can only have one column.")

  g <- list(g1=0, g2=0)
  return (g)
}



whiteKernDiagCompute <- function (kern, x) {
  k <- matrix(kern$variance, dim(as.array(x))[1], 1)
  return (k)
}

setClass("scoreList", 
	representation(params = "list", loglikelihoods = "numeric",
                       baseloglikelihoods = "numeric",
                       genes = "list", modelArgs = "list",
                       knownTargets = "character", TF = "character",
                       sharedModel = "list", datasetName = "character",
                       experimentSet = "character"),
         prototype(params=list(), loglikelihoods = numeric(),
                   baseloglikelihoods = numeric(),
                   genes=list(), modelArgs=list(), knownTargets="",
                   TF="", sharedModel=list(), datasetName="",
                   experimentSet=""))


setMethod("initialize", "scoreList",
          function(.Object, params, loglikelihoods,
                   baseloglikelihoods=numeric(), genes, modelArgs,
                   knownTargets="", TF="", sharedModel=list(),
                   datasetName="", experimentSet="") {
            if (!is.list(sharedModel))
              sharedModel <- list(sharedModel)

            if (is.null(knownTargets))
              knownTargets <- ""

            if (is.null(TF))
              TF <- ""

            names(params) <- genes
            names(modelArgs) <- genes
            names(loglikelihoods) <- genes
            if (length(baseloglikelihoods) > 0)
              names(baseloglikelihoods) <- genes
  
            .Object@params <- params
            .Object@loglikelihoods <- loglikelihoods
            .Object@baseloglikelihoods <- baseloglikelihoods
            .Object@genes <- genes
            .Object@modelArgs <- modelArgs
            .Object@knownTargets <- knownTargets
            .Object@TF <- TF
            .Object@sharedModel <- sharedModel
            .Object@datasetName <- datasetName
            .Object@experimentSet <- experimentSet
            .Object
          })


setMethod("show", "scoreList",
          function(object) {
            if (length(object@loglikelihoods) != 1)
              genetext <- "genes"
            else
              genetext <- "gene"
            
            if (object@TF == "")
              cat("scoreList of ", length(object@loglikelihoods), " ", genetext, ".\n", sep="")
            else
              cat("scoreList of ", length(object@loglikelihoods), " ", genetext, " for TF ", object@TF, ".\n", sep="")
            if (all(object@knownTargets != "")) {
              cat("  Known targets: ", paste(object@knownTargets, collapse=", "), "\n")
            }
            idx <- .listSelectSomeIndex(object@genes, maxToShow=4)
            l <- object@genes[c(idx[[1]], idx[[3]]), drop=FALSE]
            itms <- c(l[idx[[1]]], idx[[2]],
                      if (!is.null(idx[[1]])) l[-idx[[1]]] else NULL)
            cat("  Genes: ", paste(itms, collapse=", "), sep="")
            if (length(object@genes)>length(itms))
              cat(" (",length(object@genes)," total)", sep="")
            cat("\n")
          })


setGeneric("loglikelihoods",    function(object) standardGeneric("loglikelihoods"))
setGeneric("loglikelihoods<-",  function(object, value) standardGeneric("loglikelihoods<-"))
setMethod("loglikelihoods", "scoreList", function(object) object@loglikelihoods)
setReplaceMethod("loglikelihoods", c("scoreList", "numeric"),
                 function(object, value) {
                   if (length(value) != length(object@loglikelihoods))
                     stop(paste("the length of replacement (",
                                length(value),
                                ") should equal the existing length (",
                                length( object@loglikelihoods ), ")",sep=""))
                   object@loglikelihoods <- value
                   object
                 })

setGeneric("baseloglikelihoods",    function(object) standardGeneric("baseloglikelihoods"))
setGeneric("baseloglikelihoods<-",  function(object, value) standardGeneric("baseloglikelihoods<-"))
setMethod("baseloglikelihoods", "scoreList", function(object) object@baseloglikelihoods)
setReplaceMethod("baseloglikelihoods", c("scoreList", "numeric"),
                 function(object, value) {
                   if (length(value) != length(object@baseloglikelihoods))
                     stop(paste("the length of replacement (",
                                length(value),
                                ") should equal the existing length (",
                                length( object@baseloglikelihoods ), ")",sep=""))
                   object@baseloglikelihoods <- value
                   object
                 })

setGeneric("params",    function(object) standardGeneric("params"))
setGeneric("params<-",  function(object, value) standardGeneric("params<-"))
setMethod("params", "scoreList", function(object) object@params)
setReplaceMethod("params", c("scoreList", "list"),
                 function(object, value) {
                   if (length(value) != length(object@params))
                     stop(paste("the length of replacement (",
                                length(value),
                                ") should equal the existing length (",
                                length( object@params ), ")",sep=""))
                   object@params <- value
                   object
                 })

setGeneric("genes",    function(object) standardGeneric("genes"))
setGeneric("genes<-",  function(object, value) standardGeneric("genes<-"))
setMethod("genes", "scoreList", function(object) object@genes)
setReplaceMethod("genes", c("scoreList", "list"),
                 function(object, value) {
                   if (length(value) != length(object@genes))
                     stop(paste("the length of replacement (",
                                length(value),
                                ") should equal the existing length (",
                                length( object@genes ), ")",sep=""))
                   object@genes <- value
                   object
                 })

setGeneric("modelArgs",    function(object) standardGeneric("modelArgs"))
setGeneric("modelArgs<-",  function(object, value) standardGeneric("modelArgs<-"))
setMethod("modelArgs", "scoreList", function(object) object@modelArgs)
setReplaceMethod("modelArgs", c("scoreList", "list"),
                 function(object, value) {
                   if (length(value) != length(object@modelArgs))
                     stop(paste("the length of replacement (",
                                length(value),
                                ") should equal the existing length (",
                                length( object@modelArgs ), ")",sep=""))
                   object@modelArgs <- value
                   object
                 })

setGeneric("knownTargets",    function(object) standardGeneric("knownTargets"))
setGeneric("knownTargets<-",  function(object, value) standardGeneric("knownTargets<-"))
setMethod("knownTargets", "scoreList", function(object) object@knownTargets)
setReplaceMethod("knownTargets", c("scoreList", "character"),
                 function(object, value) {
                   object@knownTargets <- value
                   object
                 })

setGeneric("TF",    function(object) standardGeneric("TF"))
setGeneric("TF<-",  function(object, value) standardGeneric("TF<-"))
setMethod("TF", "scoreList", function(object) object@TF)
setReplaceMethod("TF", c("scoreList", "character"),
                 function(object, value) {
                   object@TF <- value
                   object
                 })

setGeneric("sharedModel",    function(object) standardGeneric("sharedModel"))
setGeneric("sharedModel<-",  function(object, value) standardGeneric("sharedModel<-"))
setMethod("sharedModel", "scoreList", function(object) object@sharedModel)
setReplaceMethod("sharedModel", c("scoreList", "list"),
                 function(object, value) {
                   object@sharedModel <- value
                   object
                 })

setGeneric("datasetName",    function(object) standardGeneric("datasetName"))
setGeneric("datasetName<-",  function(object, value) standardGeneric("datasetName<-"))
setMethod("datasetName", "scoreList", function(object) object@datasetName)
setReplaceMethod("datasetName", c("scoreList", "character"),
                 function(object, value) {
                   object@datasetName <- value
                   object
                 })

setGeneric("experimentSet",    function(object) standardGeneric("experimentSet"))
setGeneric("experimentSet<-",  function(object, value) standardGeneric("experimentSet<-"))
setMethod("experimentSet", "scoreList", function(object) object@experimentSet)
setReplaceMethod("experimentSet", c("scoreList", "character"),
                 function(object, value) {
                   object@experimentSet <- value
                   object
                 })

setMethod("length", "scoreList", function(x) length(x@loglikelihoods))

setMethod("updateObject", signature(object="scoreList"),
          function(object, ..., verbose=FALSE) {
            if (verbose) message("updateObject(object = 'scoreList')")
            data <- getObjectSlots(object)
            do.call(new, c(class(object), data))
          })

setMethod("[",
          signature(x="scoreList"),
          function(x, i, j, ..., drop) {
            if (! "datasetName" %in% slotNames(x))
              x <- updateObject(x)
            par <- x@params[i]
            ll <- x@loglikelihoods[i]
            bll <- x@baseloglikelihoods[i]
            genes <- x@genes[i]
            args <- x@modelArgs[i]
            new("scoreList", params=par, loglikelihoods=ll,
                baseloglikelihoods=bll, genes=genes,
                modelArgs=args, knownTargets=x@knownTargets, TF=x@TF,
                sharedModel=x@sharedModel,
                datasetName=x@datasetName,
                experimentSet=x@experimentSet)
          })

setMethod("c", signature(x="scoreList"),
          function(x, ..., recursive=FALSE) {
            lists <- unlist(list(x, ...))
            if (! "datasetName" %in% slotNames(lists[[1]]))
              lists[[1]] <- updateObject(lists[[1]])
            params <- do.call(c, lapply(lists, function(y) y@params))
            loglikelihoods <- do.call(c, lapply(lists, function(y) y@loglikelihoods))
            baseloglikelihoods <- do.call(c, lapply(lists, function(y) y@baseloglikelihoods))
            genes <- do.call(c, lapply(lists, function(y) y@genes))
            modelArgs <- do.call(c, lapply(lists, function(y) y@modelArgs))
            new("scoreList", params=params, loglikelihoods=loglikelihoods,
                baseloglikelihoods=baseloglikelihoods, genes=genes,
                modelArgs=modelArgs, knownTargets=lists[[1]]@knownTargets,
                TF=lists[[1]]@TF, sharedModel=lists[[1]]@sharedModel,
                datasetName=lists[[1]]@datasetName,
                experimentSet=lists[[1]]@experimentSet)
          })

setMethod("sort", signature(x="scoreList"), 
          function(x, decreasing=FALSE, ...) {
            x[order(loglikelihoods(x), decreasing=decreasing, na.last=NA)]
          })

setGeneric("write.scores", function(x, ...) standardGeneric("write.scores"))
setMethod("write.scores", signature(x="scoreList"), 
          function(x, ...) {
            v <- cbind(loglikelihoods(x), baseloglikelihoods(x))
            colnames(v) <- c('log-likelihood', 'null_log-likelihood')
            write.table(v, ...)
          })

setClass("GPModel", 
         representation(model = "list", type = "character"),
         prototype(model=list(), type=""))

setMethod("initialize", "GPModel",
          function(.Object, model) {
            .Object@model <- model
            .Object@type <- model$type
            .Object
          })

is.GPModel <- function(object) {
  return (class(object) == "GPModel")
}

setMethod("show", "GPModel",
          function(object) {
            if (object@type == "cgpdisim")
              gpdisimDisplay(modelStruct(object)$comp[[1]])
            else
              gpsimDisplay(modelStruct(object)$comp[[1]])
            cat("  Log-likelihood:", modelLogLikelihood(object), "\n")
          })

setGeneric("modelStruct",    function(object) standardGeneric("modelStruct"))
setGeneric("modelStruct<-",  function(object, value) standardGeneric("modelStruct<-"))
setMethod("modelStruct", "GPModel", function(object) object@model)
setReplaceMethod("modelStruct", signature(object="GPModel",value="list"),
                 function(object, value) {
                   object@model <- value
                   object@type <- value$type
                   object
                 })

setGeneric("modelType",    function(object) standardGeneric("modelType"))
setMethod("modelType", "GPModel", function(object) object@model)


setClass("ExpressionTimeSeries", contains="ExpressionSet")

setMethod("initialize", "ExpressionTimeSeries", function(.Object, 
                                           assayData = assayDataNew(exprs = exprs,
                                             var.exprs = var.exprs),
                                           exprs = new("matrix"),
                                           var.exprs = new("matrix"), ...) { 
  if (!missing(assayData) && any(!missing(exprs), !missing(var.exprs))) {
    warning("using 'assayData'; ignoring 'exprs', 'var.exprs'") 
  }
  callNextMethod(.Object, assayData = assayData, ...) 
})

setValidity("ExpressionTimeSeries", function(object) {
  if ("experiments" %in% varLabels(object) && "modeltime" %in% varLabels(object))
    TRUE
  else
    "Missing phenoData annotation field(s)."
})

setGeneric("var.exprs",    function(object) standardGeneric("var.exprs"))
setGeneric("var.exprs<-",  function(object, value) standardGeneric("var.exprs<-"))
setMethod("var.exprs", "ExpressionTimeSeries", function(object) assayDataElement(object,"var.exprs"))
setReplaceMethod("var.exprs", "ExpressionTimeSeries",
                 function(object, value) assayDataElementReplace(object, "var.exprs", value))

### R code from vignette source 'tigre.Rnw'

###################################################
### code chunk number 1: style
###################################################
BiocStyle::latex()


###################################################
### code chunk number 2: tigre.Rnw:41-42
###################################################
options(width = 60)


###################################################
### code chunk number 3: tigre.Rnw:60-63 (eval = FALSE)
###################################################
## if (!requireNamespace("BiocManager", quietly=TRUE))
##     install.packages("BiocManager")
## BiocManager::install("tigre")


###################################################
### code chunk number 4: tigre.Rnw:72-73
###################################################
library(tigre)


###################################################
### code chunk number 5: tigre.Rnw:89-102 (eval = FALSE)
###################################################
## # Names of CEL files
## expfiles <- c(paste("embryo_tc_4_", 1:12, ".CEL", sep=""),
##               paste("embryo_tc_6_", 1:12, ".CEL", sep=""),
##               paste("embryo_tc_8_", 1:12, ".CEL", sep=""))
## # Load the CEL files
## expdata <- ReadAffy(filenames=expfiles,
##                     celfile.path="embryo_tc_array_data")
## # Setup experimental data (observation times)
## pData(expdata) <- data.frame("time.h" = rep(1:12, 3),
##                              row.names=rownames(pData(expdata)))
## # Run mmgMOS processing (requires several minutes to complete)
## drosophila_mmgmos_exprs <- mmgmos(expdata)
## drosophila_mmgmos_fragment <- drosophila_mmgmos_exprs


###################################################
### code chunk number 6: tigre.Rnw:107-110 (eval = FALSE)
###################################################
## drosophila_gpsim_fragment <-
##   processData(drosophila_mmgmos_fragment,
##               experiments=rep(1:3, each=12))


###################################################
### code chunk number 7: tigre.Rnw:118-119
###################################################
data(drosophila_gpsim_fragment)


###################################################
### code chunk number 8: tigre.Rnw:126-157
###################################################
# FBgn names of target genes
targets <- c('FBgn0003486', 'FBgn0033188', 'FBgn0035257')

# Load gene annotations
library(annotate)
aliasMapping <- getAnnMap("ALIAS2PROBE",
                  annotation(drosophila_gpsim_fragment))
# Get the probe identifier for TF 'twi'
twi <- get('twi', env=aliasMapping)
# Load alternative gene annotations
fbgnMapping <- getAnnMap("FLYBASE2PROBE",
                 annotation(drosophila_gpsim_fragment))
# Get the probe identifiers for target genes
targetProbes <- mget(targets, env=fbgnMapping)

st_models <- list()
# Learn single-target models for each gene individually
for (i in seq(along=targetProbes)) {
  st_models[[i]] <- GPLearn(drosophila_gpsim_fragment,
                            TF=twi, targets=targetProbes[i],
                            quiet=TRUE)
}
# Learn a joint model for all targets
mt_model <- GPLearn(drosophila_gpsim_fragment, TF=twi,
                    targets=targetProbes,
                    quiet=TRUE)
# Display the joint model parameters
show(mt_model)
# Learn a model without TF mRNA and TF protein translation
nt_model <- GPLearn(drosophila_gpsim_fragment,
                    targets=c(twi, targetProbes[1:2]), quiet=TRUE)


###################################################
### code chunk number 9: tigre.Rnw:163-169 (eval = FALSE)
###################################################
## GPPlot(st_models[[1]], nameMapping=getAnnMap("FLYBASE",
##                         annotation(drosophila_gpsim_fragment)))
## GPPlot(mt_model, nameMapping=getAnnMap("FLYBASE",
##                   annotation(drosophila_gpsim_fragment)))
## GPPlot(nt_model, nameMapping=getAnnMap("FLYBASE",
##                   annotation(drosophila_gpsim_fragment)))


###################################################
### code chunk number 10: tigre.Rnw:174-176
###################################################
GPPlot(st_models[[1]], nameMapping=getAnnMap("FLYBASE",
                         annotation(drosophila_gpsim_fragment)))


###################################################
### code chunk number 11: tigre.Rnw:185-187
###################################################
GPPlot(mt_model, nameMapping=getAnnMap("FLYBASE",
                   annotation(drosophila_gpsim_fragment)))


###################################################
### code chunk number 12: tigre.Rnw:196-198
###################################################
GPPlot(nt_model, nameMapping=getAnnMap("FLYBASE",
                   annotation(drosophila_gpsim_fragment)))


###################################################
### code chunk number 13: tigre.Rnw:209-218
###################################################
## Rank the targets, filtering weakly expressed genes with average
## expression z-score below 1.8
scores <- GPRankTargets(drosophila_gpsim_fragment, TF=twi,
                        testTargets=targetProbes,
                        options=list(quiet=TRUE),
                        filterLimit=1.8)
## Sort the returned list according to log-likelihood
scores <- sort(scores, decreasing=TRUE)
write.scores(scores)


###################################################
### code chunk number 14: tigre.Rnw:225-228
###################################################
topmodel <- generateModels(drosophila_gpsim_fragment,
                           scores[1])
show(topmodel)


###################################################
### code chunk number 15: tigre.Rnw:235-245
###################################################
## Rank the targets, filtering weakly expressed genes with average
## expression z-score below 1.8
scores <- GPRankTargets(drosophila_gpsim_fragment, TF=twi,
                        knownTargets=targetProbes[1],
                        testTargets=targetProbes[2:3],
                        options=list(quiet=TRUE),
                        filterLimit=1.8)
## Sort the returned list according to log-likelihood
scores <- sort(scores, decreasing=TRUE)
write.scores(scores)


###################################################
### code chunk number 16: tigre.Rnw:259-277 (eval = FALSE)
###################################################
## for (i in seq(1, 3)) {
##   targetIndices <- seq(i,
##     length(featureNames(drosophila_gpsim_fragment)), by=3)
##   outfile <- paste('ranking_results_', i, '.Rdata', sep='')
##   scores <- GPrankTargets(preprocData, TF=twi,
##                           testTargets=targetIndices,
##                           scoreSaveFile=outfile)
## }
## 
## for (i in seq(1, 3)) {
##   outfile <- paste('ranking_results_', i, '.Rdata', sep='')
##   load(outfile)
##   if (i==1)
##     scores <- scoreList
##   else
##     scores <- c(scores, scoreList)
## }
## show(scores)


###################################################
### code chunk number 17: tigre.Rnw:299-301 (eval = FALSE)
###################################################
## procData <- processRawData(data, times=c(...),
##                            experiments=c(...))


###################################################
### code chunk number 18: tigre.Rnw:321-327 (eval = FALSE)
###################################################
## export.scores(scores, datasetName='Drosophila',
##               experimentSet='GPSIM/GPDISIM',
##               database='database.sqlite',
##               preprocData=drosophila_gpsim_fragment,
##               models=models,
##               aliasTypes=c('SYMBOL', 'GENENAME', 'FLYBASE', 'ENTREZID'))


###################################################
### code chunk number 19: sessionInfo
###################################################
sessionInfo()

optimiDefaultConstraint <- function (constraint) {
  if ( constraint == "positive" ) {
    return (list(func="expTransform", hasArgs=FALSE))
  } else if ( constraint == "zeroone" ) {
    return (list(func="sigmoidTransform", hasArgs=FALSE))
  } else if ( constraint == "bounded" ) {
    return (list(func="boundedTransform", hasArgs=TRUE))
  }
}



## optimiFdefaultOptions <- function () {
##   options <- list(maxit=100, tolf=1e-4, tol=1e-4, display=TRUE)
##   return (options)
## }



optimiDefaultOptions <- function() {
  ## options: trace, maximum iteration, fnscale, reltol, default optimiser
  ## return (list(trace=TRUE, maxit=1000, fnscale=1e1, reltol=1e-4, optimiser="CG", gradcheck=FALSE, hessian=FALSE))
  return (list(maxit=3000, ln=c(0,2), xtol=1e-4, fnTol=1e-4, optimiser="SCG", gradcheck=FALSE, display=TRUE))
}



modelOptimise <- function (model, options, ...) {
  if (is.GPModel(model)) {
    haveGPModel <- TRUE
    model <- modelStruct(model)
  }
  else
    haveGPModel <- FALSE

  funcName <- paste(model$type, "Optimise", sep="")
  if ( exists(funcName, mode="function") ) {
    func <- get(funcName, mode="function")
    model <- func(model, options, ...)
  } else {
    if ( "optimiser" %in% names(options) ) {
      funcName <- paste(options$optimiser, "optim", sep="")
    } else {
      funcName <- "CGoptim"
    }
    optFunc <- get(funcName, mode="function")

    params <- modelExtractParam(model)
    newParams <- optFunc(params, modelObjective, modelGradient, options, model)
    
    model <- modelExpandParam(model, newParams$xmin)
    model$llscore <- newParams$objective
  }

  if (haveGPModel)
    return (new("GPModel", model))
  else
    return (model)
}



.fn_line <- function (linemin, fun, para0, direction, ...) {
  ## y = fn (x)
  func <- function(x, ...) fun(x, ...)
  
  para <- para0 + linemin * direction
  
  ans <- func(para, ...)
  
  return (ans)
}


CGoptim <- function (x, fn, grad, options, ...) {
  ## option[1] : number of iterations
  ## option[2] : interval for the line search
  ## option[3] : tolerence for x to terminate the loop
  ## option[4] : tolerence for fn to terminate the loop
  ## option$display : option of showing the details of optimisaton

  ## y = fn (x)
  func <- function(x, ...) fn(x, ...)
      
  ## gradient function = gr (x)
  gradfunc <- function(x, ...) grad(x, ...)
	
  fn_new <- func(x, ...)
  #if ( display ) 
  #  cat ("fn0 :",fn_new, "\n")

  grad_new <- gradfunc(x, ...)
  #if ( options$display )  
  #  cat ("grad0 :",grad_new, "\n\n")
	
  direction <- -grad_new
  lnSchFail <- FALSE
  for ( ind in 1:options[[1]] ) {
	
    x_old <- x
    fn_old <- fn_new
    grad_old <- grad_new
    
    grad2 <- crossprod(grad_old)	
    
    if ( grad2 == 0 ) {
      objective <- fn_new
      xmin <- x
      ans <- list(xmin=xmin, objective=objective, lnSchFail=lnSchFail)
      return (ans)
    }

    dnorm <- sqrt(sum(direction*direction))
    line_dir <- direction / dnorm
    ## cat ("\n line_dir :", line_dir, "\n\n")
    ow <- options("warn")
    options(warn=2)
    lnSch <- try( optimize(.fn_line, options[[2]], para0=x_old, direction=line_dir, fun=fn, ...), silent=TRUE )
    options(ow)

    if ( is.list(lnSch) ) {
      x <- x_old + lnSch$minimum * line_dir		
      fn_new <- lnSch$objective
      fnmin <- min(fn_old, fn_new)
      if ( fnmin==fn_new ) {
        xnmin <- x
      } else {
        xnmin <- x_old
      }
    } else {
      warning("Line search failed! \n")
      x <- xnmin
      fn_new <- fnmin
      lnSchFail <- TRUE

      xmin <- xnmin
      objective <- fnmin
      ans <- list(xmin=xmin, objective=objective, lnSchFail=lnSchFail)
      return (ans)
    }
    
    if ( max(abs(x-x_old))<options[[3]] & max(abs(fn_new-fn_old))<options[[4]] ) {
      xmin <- x
      objective <- fn_new
      ans <- list(xmin=xmin, objective=objective, lnSchFail=lnSchFail)
      return (ans)
    }
    
    grad_new <- gradfunc(x, ...)
    
    eta <- ( t(grad_new-grad_old) %*% grad_new ) / grad2
    direction <- direction * eta - grad_new

    if ( options$display )
      cat(ind, "-th objective = :", fn_new, "\t max xi: ", max(abs(x-x_old)), "\n")
  }

  warning("Maximum iteration reached! \n")
  xmin <- x
  objective <- fn_new
  
  ans <- list(xmin=xmin, objective=objective, lnSchFail=lnSchFail)
  ##if ( options$display ) 
  ##  cat("\n Optimisation ends! \n")
  return (ans)
}



SCGoptim <- function (x, fn, grad, options, ...) {
  ## options = list(maxit, ln, xtol, fnTol, optimiser="SCG", gradcheck=FALSE)
  ##cat ("\n SCG Optimisation begins! \n")

  if ( "maxit" %in% names(options) && !is.na(options$maxit) ) {
    niters <- options$maxit
  } else {
    niters <- 100
  }

  display <- options$display
  gradcheck <- options$gradcheck
  
  ## y = fn (x)
  func <- function(x, ...) fn(x, ...)
      
  ## gradient function = gr (x)
  gradfunc <- function(x, ...) grad(x, ...)

  nparams <- length(x)

  sigma0 <- 1e-4
  fold <- func(x, ...)
  fnow <- fold
  gradnew <- gradfunc(x, ...)
  gradold <- gradnew
  d <- -gradnew
  success <- 1
  nsuccess <- 0
  beta <- 1
  betamin <- 1e-15
  betamax <- 1e100
  eps <- 2.2204e-16
  j <- 1

  while ( j<=niters ) {
    if ( success == 1 ) {
      mu <- crossprod(d, gradnew)
      if ( mu>=0 ) {
        d <- -gradnew
        mu <- crossprod(d, gradnew)
      }
      kappa <- crossprod(d, d)
      if ( kappa<eps ) {
        xmin <- x
        objective <- fnow
        ans <- list(xmin=xmin, objective=objective)
        return (ans)
      }
      sigma <- (sigma0/sqrt(kappa))[1]
      xplus <- x+sigma*d
      gplus <- gradfunc(xplus, ...)
      theta <- crossprod(d, gplus-gradnew)/sigma
    }

    delta <- theta + beta*kappa
    if ( delta<=0 ) {
      delta <- beta*kappa
      beta <- beta - theta/kappa
    }
    alpha <- (-mu/delta)[1]

    xnew <- x+alpha*d
    ow <- options("warn")
    options(warn=2)
    fnew <- try( func(xnew, ...), silent=TRUE )
    options(ow)
    if ( !is.finite(fnew) ) fi <- 1
    while ( !is.finite(fnew) ) {
      alpha <- alpha/2
      xnew <- x+alpha*d
      ow <- options("warn")
      options(warn=2)
      fnew <- try( func(xnew, ...), silent=TRUE )
      options(ow)
      fi <- fi+1
      if ( is.finite(fnew) ) {
        fi <- 0
      }
    }

    Delta <- 2*(fnew-fold)/(alpha*mu)
    if ( Delta>=0 ) {
      success <- 1
      nsuccess <- nsuccess+1
      x <- xnew
      fnow <- fnew
    } else {
      success <- 0
      fnow <- fold
    }
    if (display)
      cat("Cycle ", j, "Error ", round(fnow, digits=4), "Scale ", beta, "\n")

    if ( success == 1 )
      if ( (max(abs(alpha*d))<options$xtol) & (max(abs(fnew-fold))<options$fnTol) ) {
        xmin <- x
        objective <- fnew
        ans <- list(xmin=xmin, objective=objective)
        return (ans)
      } else {
        fold <- fnew
        gradold <- gradnew
        gradnew <- gradfunc(x, ...)
        if ( crossprod(gradnew, gradnew) == 0 ) {
          xmin <- x
          objective <- fnew
          ans <- list(xmin=xmin, objective=objective)
          return (ans)
        }
      }

    if ( Delta < 0.25 ) 
      beta <- min(2*beta, betamax)

    if ( Delta > 0.75 )
      beta <- max(0.5*beta, betamin)

    if ( nsuccess == nparams ) {
      d <- -gradnew
      nsuccess <- 0
    } else {
      if ( success==1 ) {
        gamma <- (crossprod(gradold-gradnew, gradnew)/mu)[1]
        d <- gamma*d-gradnew
      }
    }

    j <- j+1
  }

  xmin <- x
  objective <- fold
  ans <- list(xmin=xmin, objective=objective)
  warning("Maximum number of iterations has been exceeded.\n")
  return (ans)
}

.baselineOptimise <- function(y, yvar, options) {
  if (options$includeNoise) {
    # Check for special case of constant expression
    if (sd(y) == 0) {
      return (Inf);
    }
    oldsigma <- 10
    newsigma <- 0
    oldval <- .baselineLogLikelihood(expTransform(newsigma, 'atox'), y, yvar)
    l <- 0
    while ((abs(newsigma - oldsigma) > 1e-10) && l < 1000) {
      oldsigma <- newsigma
      grad <- .baselineLogLikeGradient(expTransform(oldsigma, 'atox'), y, yvar)
      step <- expTransform(oldsigma, 'atox') * grad$d1 /
        (expTransform(2*oldsigma, 'atox') * grad$d2
         + expTransform(oldsigma, 'atox') * grad$d1)
      k <- 0
      newval <- oldval - 10
      while (newval < (oldval - 1e-10) && k < 20) {
        newsigma <- oldsigma - step
        newval <- .baselineLogLikelihood(expTransform(newsigma, 'atox'), y, yvar)
        step <- step / 2
        k <- k+1
      }
      oldval <- newval
      l <- l+1
    }
    sigma <- expTransform(newsigma, 'atox')
  }
  else
    sigma <- 0

  return (.baselineLogLikelihood(sigma, y, yvar))
}


.baselineLogLikeGradient <- function(sigma, y, yvar) {
  sigma <- sigma[1]
  mu <- sum(y / (yvar + sigma)) / sum(1/(yvar+sigma))
  return (list(d1=0.5 * sum((y - mu)^2 / (yvar + sigma)^2 - 1/(yvar + sigma)),
               d2=0.5 * sum(1/(yvar + sigma)^2) - sum((y - mu)^2 / (yvar + sigma)^3)))
}


.baselineLogLikelihood <- function(sigma, y, yvar) {
  sigma <- sigma[1]
  mu <- sum(y / (yvar + sigma)) / sum(1/(yvar+sigma))
  return (-0.5 * sum(log(2*pi*(yvar+sigma)) + (y - mu)^2 / (yvar + sigma)))
}

priorCreate <- function(type) {
  if (!is.list(type)) {
    prior <- list(type=type)
    return (priorParamInit(prior))
  } else {
    prior <- list(type=type$type)
    prior <- priorParamInit(prior)
    if ("index" %in% names(type))
      prior$index <- type$index
    return (priorExpandParam(prior, type$params, untransformed.values=TRUE))
  }
}


priorParamInit <- function(prior) {
  func <- get(paste(prior$type, 'PriorParamInit', sep=''), mode='function')
  return (func(prior))
}


priorExpandParam <- function (prior, params, untransformed.values=FALSE) {
  if ( is.list(params) )
    params <- params$values
  
  if ( "transforms" %in% names(prior) && (length(prior$transforms) > 0)
      && !untransformed.values )
    for ( i in seq(along=prior$transforms) ) {
      index <- prior$transforms[[i]]$index
      funcName <- optimiDefaultConstraint(prior$transforms[[i]]$type)
      func <- get(funcName$func, mode="function")
      if (funcName$hasArgs)
        params[index] <- func(params[index], "atox", prior$transformArgs[[i]])
      else
        params[index] <- func(params[index], "atox")
    }

  funcName <- paste(prior$type, "PriorExpandParam", sep="")
  func <- get(funcName, mode="function")
  return (func(prior, params))
}


priorExtractParam <- function (prior, only.values=TRUE, untransformed.values=FALSE) {
  funcName <- paste(prior$type, "PriorExtractParam", sep="")
  func <- get(funcName, mode="function")

  params <- func(prior, only.values=only.values, untransformed.values=untransformed.values)

  if ( any(is.nan(params)) )
    warning("Parameter has gone to NaN.")

  if ( "transforms" %in% names(prior) && (length(prior$transforms) > 0)
      && !untransformed.values )
    for ( i in seq(along=prior$transforms) ) {
      index <- prior$transforms[[i]]$index
      funcName <- optimiDefaultConstraint(prior$transforms[[i]]$type)
      func <- get(funcName$func, mode="function")
      if (funcName$hasArgs)
        params[index] <- func(params[index], "xtoa", prior$transformArgs[[i]])
      else
        params[index] <- func(params[index], "xtoa")
    }

  return (params)
}


priorGradient <- function(prior, params) {
  func <- get(paste(prior$type, 'PriorGradient', sep=''), mode='function')
  return (func(prior, params))
}


priorLogProb <- function(prior, x) {
  func <- get(paste(prior$type, 'PriorLogProb', sep=''), mode='function')
  return (func(prior, x))
}

simKernParamInit <- function (kern) {

  if ( kern$inputDimension > 1 )
    stop("SIM kernel is only valid for one-D input.")
  kern$delay <- 0
  kern$decay <- 1
  kern$initVal <- 1
  kern$variance <- 1
  kern$sensitivity <- sqrt(kern$variance)
  kern$inverseWidth <- 1
  if ("options" %in% names(kern) && "gaussianInitial" %in% names(kern$options) && kern$options$gaussianInitial) {
    kern$gaussianInitial <- TRUE
    kern$initialVariance <- 1
    kern$nParams <- 4
    kern$paramNames <- c("decay", "inverseWidth", "variance", "initialVariance")
  }
  else {
    kern$gaussianInitial <- FALSE
    kern$nParams <- 3
    kern$paramNames <- c("decay", "inverseWidth", "variance")
  }

  if ("options" %in% names(kern) && "isNegativeS" %in% names(kern$options) && kern$options$isNegativeS) {
    kern$isNegativeS <- TRUE
    kern$transforms <- list(list(index=setdiff(1:kern$nParams, 3), type="positive"))
    kern$paramNames[3] <- "sensitivity"
  }
  else {
    kern$isNegativeS <- FALSE
    kern$transforms <- list(list(index=1:kern$nParams, type="positive"))
  }

  if ("options" %in% names(kern) && "isNormalised" %in% names(kern$options) && kern$options$isNormalised)
    kern$isNormalised <- TRUE
  else
    kern$isNormalised <- FALSE
  
  if ("options" %in% names(kern) && "inverseWidthBounds" %in% names(kern$options)) {
    kern$transforms[[1]]$index <- setdiff(kern$transforms[[1]]$index, 2)
    kern$transforms[[2]] <- list(index=2, type="bounded")
    kern$transformArgs <- list()
    kern$transformArgs[[2]] <- kern$options$inverseWidthBounds
    kern$inverseWidth <- mean(kern$options$inverseWidthBounds)
  }

  kern$isStationary <- FALSE

  return (kern)

}

simXrbfKernCompute <- function (simKern, rbfKern, t1, t2=t1) {
  if ( ( dim(as.matrix(t1))[2] > 1 ) | ( dim(as.matrix(t2))[2] > 1 ) )
    stop("Input can only have one column.")

  if (rbfKern$variance != 1)
    warning('Non-unit RBF kernel variance. The SIM kernel can only be cross combined with an RBF kernel with variance 1.')

  if ( simKern$inverseWidth != rbfKern$inverseWidth )
    stop("Kernels cannot be cross combined if they have different inverse widths.")

  if ( simKern$isNormalised != rbfKern$isNormalised )
    stop("Both the SIM and the RBF kernels have to be either normalised or not.")

  dim1 <- dim(as.matrix(t1))[1]
  dim2 <- dim(as.matrix(t2))[1]
  t1 <- t1 - simKern$delay
  t1Mat <- matrix(t1, dim1, dim2)
  t2Mat <- t(matrix(t2, dim2, dim1))
  diffT <- t1Mat-t2Mat
  sigma <- sqrt(2/simKern$inverseWidth)

  invSigmaDiffT <- 1/sigma*diffT
  halfSigmaDi <- 0.5*sigma*simKern$decay

  lnPart <- lnDiffErfs(halfSigmaDi + t2Mat/sigma, halfSigmaDi - invSigmaDiffT)

  K <- lnPart[[2]] * exp(halfSigmaDi*halfSigmaDi - simKern$decay*diffT + lnPart[[1]])

  #K <- 0.5*sqrt(simKern$variance)*sqrt(rbfKern$variance)*K*sqrt(pi)*sigma
  K <- 0.5*simKern$sensitivity*K

  if (!simKern$isNormalised)
    K <- K*sigma*sqrt(pi)

  return (K)
}



simXsimKernCompute <- function (simKern1, simKern2, t1, t2=t1) {
  if ( ( dim(as.matrix(t1))[2] > 1 ) | ( dim(as.matrix(t2))[2] > 1 ) )
    stop("Input can only have one column.")

  if ( simKern1$inverseWidth != simKern2$inverseWidth )
    stop("Kernels cannot be cross combined if they have different inverse widths.")

  if ( simKern1$isNormalised != simKern2$isNormalised )
    stop("Both the SIM kernels have to be either normalised or not.")

  sigma <- sqrt(2/simKern1$inverseWidth)
  h1 <- .simComputeH(t1, t2, simKern1$decay, simKern2$decay, simKern1$delay, simKern2$delay, sigma)
  h2 <- .simComputeH(t2, t1, simKern2$decay, simKern1$decay, simKern2$delay, simKern1$delay, sigma)
  K <- h1 + t(h2)
  K <- 0.5*simKern1$sensitivity*simKern2$sensitivity*K

  if (!simKern1$isNormalised)
    K <- K*sigma*sqrt(pi)

  return (K)
}



# untransformed.values is ignored
simKernExtractParam <- function (kern, only.values=TRUE,
                                 untransformed.values=TRUE) {
  if (kern$gaussianInitial) {
    if (kern$isNegativeS)
      params <- c(kern$decay, kern$inverseWidth, kern$sensitivity, kern$initialVariance)
    else
      params <- c(kern$decay, kern$inverseWidth, kern$variance, kern$initialVariance)
  }
  else {
    if (kern$isNegativeS)
      params <- c(kern$decay, kern$inverseWidth, kern$sensitivity)
    else
      params <- c(kern$decay, kern$inverseWidth, kern$variance)
  }
  if (! only.values)
    names(params) <- kern$paramNames

  return (params)
}



simKernExpandParam <- function (kern, params) {
  if ( is.list(params) )
    params <- params$values

  kern$decay <- params[1]
  kern$inverseWidth <- params[2]
  if(kern$isNegativeS) {
    kern$sensitivity <- params[3]
    kern$variance <- kern$sensitivity*kern$sensitivity
  }
  else {
    kern$variance <- params[3]
    kern$sensitivity <- sqrt(kern$variance)
  }
  if ( "gaussianInitial" %in% names(kern) && kern$gaussianInitial )
    kern$initialVariance <- params[4]

  return (kern)
}

simKernDisplay <- function (kern, spaceNum=0) {

  spacing = matrix("", spaceNum+1)
  cat(spacing)
  if(kern$isStationary)
    cat("Stationary version of the kernel\n")
  else
    cat("Non-stationary version of the kernel\n")

  cat(spacing)
  if(kern$isNormalised)
    cat("Normalised version of the kernel\n")
  else
    cat("Unnormalised version of the kernel\n")

  cat(spacing)
  if(kern$isNegativeS)
    cat("Sensitivities allowed to be negative.\n")
  else
    cat("Sensitivities constrained positive.\n")
  cat(spacing)
  cat("SIM decay: ", kern$decay, "\n", sep="")
  cat(spacing)
  cat("SIM inverse width: ", kern$inverseWidth, " (length scale ", 1/sqrt(kern$inverseWidth), ")\n", sep="")
  cat(spacing)
  if(kern$isNegativeS) 
    cat("SIM Sensitivity: ", kern$sensitivity, "\n", sep="")  
  else
    cat("SIM Variance: ", kern$variance, "\n", sep="")
  if(kern$gaussianInitial) {
    cat(spacing)
    cat("SIM Initial Variance: ", kern$initialVariance, "\n", sep="")
  }
  ## cat(spacing)
  ## cat("SIM delay: %2.4f\n", kern$delay)
}


simKernCompute <- function (kern, t, t2=t) {
  if ( ( dim(as.matrix(t))[2] > 1 ) | ( dim(as.matrix(t2))[2] > 1 ) )
    stop("Input can only have one column.")

  sigma <- sqrt(2/kern$inverseWidth)

  h <- .simComputeH(t, t2, kern$decay, kern$decay, kern$delay, kern$delay, sigma)

  if ( nargs() < 3 ) {
    k <- h + t(h)
  } else {
    h2 <- .simComputeH(t2, t, kern$decay, kern$decay, kern$delay, kern$delay, sigma)
    k <- h + t(h2)
  }

  k <- 0.5*kern$variance*k

  if (!kern$isNormalised)
    k <- k*sigma*sqrt(pi)

  if ( "gaussianInitial" %in% names(kern) && kern$gaussianInitial ) {
    dim1 <- dim(as.matrix(t))[1]
    dim2 <- dim(as.matrix(t2))[1]
    t1Mat <- matrix(t, dim1, dim2)
    t2Mat <- t(matrix(t2, dim2, dim1))

    k = k + kern$initialVariance * exp(- kern$decay * (t1Mat + t2Mat))
  }

  return (k)
}



.simComputeH <-  function (t1, t2, Di, Dj, deltai, deltaj, sigma, option=1) {
  if ( ( dim(as.matrix(t1))[2] > 1 ) | ( dim(as.matrix(t2))[2] > 1 ) )
    stop("Input can only have one column.")

  dim1 <- dim(as.matrix(t1))[1]
  dim2 <- dim(as.matrix(t2))[1]
  t1 <- t1 - deltai
  t2 <- t2 - deltaj
  t1Mat <- matrix(t1, dim1, dim2)
  t2Mat <- t(matrix(t2, dim2, dim1))
  diffT <- t1Mat-t2Mat
  invSigmaDiffT <- 1/sigma*diffT
  halfSigmaDi <- 0.5*sigma*Di
  h <- matrix(0, dim1, dim2)

  lnPart1_full <- lnDiffErfs(halfSigmaDi + t2Mat/sigma, halfSigmaDi - invSigmaDiffT)
  lnPart2_full <- lnDiffErfs(halfSigmaDi, halfSigmaDi - t1Mat/sigma)

  lnPart1 <- lnPart1_full[[1]]
  signs1 <- lnPart1_full[[2]]
  lnPart2 <- lnPart2_full[[1]]
  signs2 <- lnPart2_full[[2]]

  h <- signs1 * exp(halfSigmaDi*halfSigmaDi-Di*diffT+lnPart1-log(Di+Dj)) - signs2 * exp(halfSigmaDi*halfSigmaDi-Di*t1Mat-Dj*t2Mat+lnPart2-log(Di + Dj))

  sigma2 <- sigma*sigma

  if ( option == 1 ) {
    return (h)
  } else {
    dhdDi <- (0.5*Di*sigma2*(Di+Dj)-1)*h + (-diffT*signs1*exp(halfSigmaDi*halfSigmaDi-Di*diffT+lnPart1) + t1Mat*signs2*exp(halfSigmaDi*halfSigmaDi-Di*t1Mat-Dj*t2Mat+lnPart2)) + sigma/sqrt(pi)*(-exp(-diffT*diffT/sigma2)+exp(-t2Mat*t2Mat/sigma2-Di*t1Mat)+exp(-t1Mat*t1Mat/sigma2-Dj*t2Mat)-exp(-(Di*t1Mat+Dj*t2Mat)))
    dhdDi <- Re(dhdDi/(Di+Dj))

    dhdDj <- t2Mat*signs2*exp(halfSigmaDi*halfSigmaDi-(Di*t1Mat+Dj*t2Mat)+lnPart2)-h
    dhdDj <- Re(dhdDj/(Di+Dj))

    dhdsigma <- 0.5*Di*Di*sigma*h + 2/(sqrt(pi)*(Di+Dj))*((-diffT/sigma2-Di/2)*exp(-diffT*diffT/sigma2) + (-t2Mat/sigma2+Di/2)*exp(-t2Mat*t2Mat/sigma2-Di*t1Mat) - (-t1Mat/sigma2-Di/2)*exp(-t1Mat*t1Mat/sigma2-Dj*t2Mat) - Di/2*exp(-(Di*t1Mat+Dj*t2Mat)))

    simH <- list(h=h, dhdDi=dhdDi, dhdDj=dhdDj, dhdsigma=dhdsigma)
    return (simH)
  }
}



simKernGradient <- function (kern, t, t2, covGrad) {
  if ( nargs() == 3 ) {
    covGrad <- t2
    t2 <- t
  }

  gFull <- simXsimKernGradient(kern, kern, t, t2, covGrad)

  g <- gFull$g1 + gFull$g2

  if ( "gaussianInitial" %in% names(kern) && kern$gaussianInitial ) {
    dim1 <- dim(as.matrix(t))[1]
    dim2 <- dim(as.matrix(t2))[1]
    t1Mat <- matrix(t, dim1, dim2)
    t2Mat <- t(matrix(t2, dim2, dim1))

    return (c(g, sum(exp(-kern$decay*(t1Mat + t2Mat)) * covGrad)))
  }
  else
    return (g)
}



simXsimKernGradient <- function (simKern1, simKern2, t1, t2, covGrad) {
  if ( nargs() < 5 ) {
    covGrad <- t2
    t2 <- t1
  }

  if ( dim(as.matrix(t1))[2]>1 | dim(as.matrix(t2))[2]>1 )
    stop("Input can only have one column for SIM kernel.")

  if ( simKern1$inverseWidth != simKern2$inverseWidth )
    stop("Kernels cannot be cross combined if they have different inverse widths.")

  if ( simKern1$isNormalised != simKern2$isNormalised )
    stop("Both the SIM kernels have to be either normalised or not.")

  option <- 2
  sigma <- sqrt(2/simKern1$inverseWidth)
  simH1 <- .simComputeH(t1, t2, simKern1$decay, simKern2$decay, simKern1$delay, simKern2$delay, sigma, option)
  h1 <- simH1$h
  dh1dD1 <- simH1$dhdDi
  dh1dD2 <- simH1$dhdDj
  dh1dsigma <- simH1$dhdsigma

  simH2 <- .simComputeH(t2, t1, simKern2$decay, simKern1$decay, simKern2$delay, simKern1$delay, sigma, option)
  h2 <- simH2$h
  dh2dD2 <- simH2$dhdDi
  dh2dD1 <- simH2$dhdDj
  dh2dsigma <- simH2$dhdsigma

  dKdD1 <- dh1dD1 + t(dh2dD1)
  dKdD2 <- dh1dD2 + t(dh2dD2)
  dKdsigma <- dh1dsigma + t(dh2dsigma)

  C1 <- simKern1$sensitivity
  C2 <- simKern2$sensitivity

  K <- 0.5 * (h1 + t(h2))
  var2 <- C1*C2

  if (!simKern1$isNormalised) {
    K <- K*sqrt(pi)
    dkdD1 <- (sum(covGrad*dh1dD1)+sum(covGrad*t(dh2dD1)))*0.5*sqrt(pi)*sigma*var2
    dkdD2 <- (sum(covGrad*dh1dD2)+sum(covGrad*t(dh2dD2)))*0.5*sqrt(pi)*sigma*var2
    dkdsigma <- sum(covGrad*(dKdsigma*0.5*sqrt(pi)*sigma + K))*var2
    dkdC1 <- sigma*C2*sum(covGrad*K)
    dkdC2 <- sigma*C1*sum(covGrad*K)
  }
  else {
    dkdD1 <- (sum(covGrad*dh1dD1)+sum(covGrad*t(dh2dD1)))*0.5*var2
    dkdD2 <- (sum(covGrad*dh1dD2)+sum(covGrad*t(dh2dD2)))*0.5*var2
    dkdsigma <- 0.5*sum(covGrad*dKdsigma)*var2
    dkdC1 <- C2*sum(covGrad*K)
    dkdC2 <- C1*sum(covGrad*K)
  }

  if(simKern1$isNegativeS)
    dkdSim1Variance <- dkdC1
  else
    dkdSim1Variance <- dkdC1*0.5/C1

  if(simKern2$isNegativeS)
    dkdSim2Variance <- dkdC2
  else
    dkdSim2Variance <- dkdC2*0.5/C2

  dkdinvWidth <- -0.5*sqrt(2)/(simKern1$inverseWidth*sqrt(simKern1$inverseWidth))*dkdsigma

  g1 <- c(dkdD1, dkdinvWidth, dkdSim1Variance)
  g2 <- c(dkdD2, 0, dkdSim2Variance)

  g <- list(g1=g1, g2=g2)
  return (g)
}



simXrbfKernGradient <- function (simKern, rbfKern, t1, t2, covGrad) {
  if ( nargs() < 5 ) {
    covGrad <- t2
    t2 <- t1
  }

  if ( dim(as.matrix(t1))[2]>1 | dim(as.matrix(t2))[2]>1 )
    stop("Input can only have one column for SIM kernel.")

  if ( simKern$inverseWidth != rbfKern$inverseWidth )
    stop("Kernels cannot be cross combined if they have different inverse widths.")

  if ( simKern$isNormalised != rbfKern$isNormalised )
    stop("Both the SIM and the RBF kernels have to be either normalised or not.")

  if ( nargs()<5 ) {
    k <- simXrbfKernCompute(simKern, rbfKern, t1)
  } else {
    k <- simXrbfKernCompute(simKern, rbfKern, t1, t2)
  }

  dim1 <- dim(as.matrix(t1))[1]
  dim2 <- dim(as.matrix(t2))[1]
  t1Mat <- matrix(t1, dim1, dim2)
  t2Mat <- t(matrix(t2, dim2, dim1))
  diffT <- t1Mat-t2Mat
  sigma <- sqrt(2/simKern$inverseWidth)
  sigma2 <- sigma*sigma
  Ci <- simKern$sensitivity
  Cj <- sqrt(rbfKern$variance)
  Di <- simKern$decay

  part2 <- exp(-t2Mat*t2Mat/sigma2-t1Mat*Di) - exp(-diffT*diffT/sigma2)

  if (!simKern$isNormalised) {
    dkdD <- sum((k*(0.5*sigma2*Di - diffT) + 0.5*Ci*Cj*sigma2*part2)*covGrad)

    dkdsigma <- sum((k*(1/sigma+0.5*sigma*Di*Di)+Ci*Cj*sigma*((-diffT/sigma2-Di/2)*exp(-diffT*diffT/sigma2)+(-t2Mat/sigma2+Di/2)*exp(-t2Mat*t2Mat/sigma2-t1Mat*Di)))*covGrad)

    dkdC <- sum(k*covGrad)/Ci
  }
  else {
    dkdD <- sum((k*(0.5*sigma2*Di - diffT) + 0.5*Ci*Cj*sigma/sqrt(pi)*part2)*covGrad)

    dkdsigma <- sum((0.5*sigma*Di*Di*k + Ci*Cj/sqrt(pi)*((-diffT/sigma2-Di/2)*exp(-diffT*diffT/sigma2)+(-t2Mat/sigma2+Di/2)*exp(-t2Mat*t2Mat/sigma2-t1Mat*Di)))*covGrad)

    dkdC <- sum(k*covGrad)/Ci
  }

  dkdRbfVariance <- 0.5*sum(k*covGrad)/rbfKern$variance

  dkdinvWidth <-  -0.5*sqrt(2)/(simKern$inverseWidth*sqrt(simKern$inverseWidth))*dkdsigma
  dkdSimVariance <- dkdC*0.5/Ci

  g1 <- c(dkdD, dkdinvWidth, dkdSimVariance)
  g2 <- c(0, dkdRbfVariance)

  g <- list(g1=g1, g2=g2)
  return (g)
}



simKernDiagCompute <- function (kern, t) {
  if ( dim(as.matrix(t))[2]>1 )
    stop("Input can only have one column.")

  sigma <- sqrt(2/kern$inverseWidth)
  t <- t - kern$delay
  halfSigmaD <- 0.5*sigma*kern$decay

  lnPart1_full <- lnDiffErfs(halfSigmaD + t/sigma, halfSigmaD)
  lnPart2_full <- lnDiffErfs(halfSigmaD, halfSigmaD - t/sigma)

  lnPart1 <- lnPart1_full[[1]]
  signs1 <- lnPart1_full[[2]]
  lnPart2 <- lnPart2_full[[1]]
  signs2 <- lnPart2_full[[2]]

  h <- signs1 * exp(halfSigmaD*halfSigmaD + lnPart1) - signs2 * exp(halfSigmaD*halfSigmaD-(2*kern$decay*t) + lnPart2)

  # h <- exp(halfSigmaD*halfSigmaD)*(erff(-halfSigmaD)+erff(t/sigma+halfSigmaD))-exp(halfSigmaD*halfSigmaD-(2*kern$decay*t))*(erff(t/sigma-halfSigmaD)+erff(halfSigmaD))

  k <- kern$variance*h/(2*kern$decay)

  if (!kern$isNormalised) {
    k <- k*sqrt(pi)*sigma
  }

  if ( "gaussianInitial" %in% names(kern) && kern$gaussianInitial )
    k = k + kern$initialVariance*exp(-2*kern$decay*t);

  return (k)
}

gpsimCreate <- function(Ngenes, Ntf, times, y, yvar, options, genes = NULL, annotation = NULL) {

  if ( any(dim(y)!=dim(yvar)) )
    stop("The gene variances have a different size matrix to the gene values.")
  
  if ( Ngenes != dim(y)[2] )
    stop("The number of genes given does not match the dimension of the gene values given.")

  if ( length(times) != dim(y)[1] )
    stop("The number of time points given does not match the number of gene values given.")
  
  model <- list(type="gpsim", y=as.array(y), yvar=as.array(yvar))

  kernType1 <- list(type="multi", comp=list())
  tieParam <- list(tieWidth="inverseWidth")

  model$uniqueT <- sort(unique(times))
  lBounds <- c(min(diff(model$uniqueT)),
               (model$uniqueT[length(model$uniqueT)]-model$uniqueT[1]))
  invWidthBounds <- c(1/(lBounds[2]^2), 1/(lBounds[1]^2))

  if ("isNegativeS" %in% names(options) && options$isNegativeS)
    isNegativeS <- TRUE
  else
    isNegativeS <- FALSE

  if ("debug" %in% names(options))
    model$debug <- options$debug

  ## proteinPrior encodes observation of the latent function.
  if ( "proteinPrior" %in% names(options) ) {
    model$proteinPrior <- options$proteinPrior
    kernType1$comp[[1]] <- list(type="parametric", realType="rbf",
                                options=list(isNormalised=TRUE,
                                  inverseWidthBounds=invWidthBounds))

    if ( "times" %in% names(model$proteinPrior) )
      timesCell <- list(protein=model$proteinPrior$times)
    else
      timesCell <- list(protein=times)

    for ( i in 1:Ngenes ) {
      kernType1$comp[[i+1]] <- list(type="parametric", realType="sim",
                                    options=list(isNormalised=TRUE,
                                      inverseWidthBounds=invWidthBounds,
                                      isNegativeS=isNegativeS))
      timesCell <- c(timesCell, list(mRNA=times))
    }

    model$timesCell <- timesCell
  } else {
    timesCell <- times
    
    kernType1 <- list(type="multi", comp=list())
    for ( i in 1:Ngenes ) {
      kernType1$comp[[i]] <- list(type="parametric", realType="sim",
                                  options=list(isNormalised=TRUE,
                                    inverseWidthBounds=invWidthBounds,
                                    isNegativeS=isNegativeS))
    }
  }

  if ("fixedBlocks" %in% names(options))
    kernType1 <- list(type="parametric", realType=kernType1,
                      options=list(fixedBlocks=options$fixedBlocks))

  model$includeNoise <- options$includeNoise

  ## can be removed
  ## if ( model$includeNoise )
  ##   model$yvar <- array(0, length(yvar))

  if ( model$includeNoise ) {

    kernType2 <- list(type="multi", comp=array())
    if ( "proteinPrior" %in% names(options) ) {
      for ( i in 1:(Ngenes+1) )
        kernType2$comp[i] <- "white"
    } else {
      for ( i in 1:Ngenes )
        kernType2$comp[i] <- "white"        
    }     

    if ("singleNoise" %in% names(options) && options$singleNoise) {
      tieParam$tieNoise <- "white._variance"
    }

    model$kern <- kernCreate(timesCell,
                             list(type="cmpnd", comp=list(kernType1, kernType2)))
    simMultiKernName <- 'model$kern$comp[[1]]'
    simMultiKern <- model$kern$comp[[1]]
  } else {
    model$kern <- kernCreate(timesCell, kernType1)
    simMultiKernName <- 'model$kern'
    simMultiKern <- model$kern
  }

  ## This is if we need to place priors on parameters ...
  ## ...
  ## ...

  model$kern <- modelTieParam(model$kern, tieParam)

  if ( "proteinPrior" %in% names(options) ) {
    for ( i in seq(2,simMultiKern$numBlocks,length.out=simMultiKern$numBlocks-1) ) {
      model$D[i-1] <- simMultiKern$comp[[i]]$decay
      model$S[i-1] <- simMultiKern$comp[[i]]$sensitivity
    }
  } else {
    for ( i in seq(along=simMultiKern$comp) ) {
      model$D[i] <- simMultiKern$comp[[i]]$decay
      model$S[i] <- simMultiKern$comp[[i]]$sensitivity
    }
  }

  model$numParams <- Ngenes + model$kern$nParams
  model$numGenes <- Ngenes
  model$mu <- apply(y, 2, mean)
  model$B <- model$D*model$mu

  if ( "proteinPrior" %in% names(model) ) {
    model$m <- c(model$proteinPrior$values, model$y)
  } else {
    model$m <- c(model$y)
    model$t <- times
  }

  if ( "bTransform" %in% names(options) ) {
    model$bTransform <- options$bTransform
  } else {
    model$bTransform <- "positive"
  }

  model$optimiser <- options$optimiser

  if (!is.null(genes)) {
    model$genes <- genes
  }

  if (!is.null(annotation)  && annotation != "") {
    model$annotation <- annotation
  }

  if ( "fix" %in% names(options) ) {
    params <- modelExtractParam(model, only.values=FALSE)
    model$fix <- options$fix
    if (! "index" %in% names(model$fix)) {
      for ( i in seq(along=model$fix$names) ) {
        J <- grep(model$fix$names[i], names(params))
        if (length(J) != 1) {
          stop("gpsimCreate: inconsistent fixed parameter specification")
        }
        model$fix$index[i] <- J
      }
    }
  }

  params <- gpsimExtractParam(model)
  model <- gpsimExpandParam(model, params)
  
  return (model)
}


gpsimDisplay <- function(model, spaceNum=0)  {
  spacing = matrix("", spaceNum+1)
  cat(spacing)
  cat("Gaussian process single input motif model:\n")
  cat(spacing)
  cat(c("  Number of time points: ", dim(model$t)[1], "\n"), sep="")
  cat(spacing)
  cat(c("  Number of genes: ", model$numGenes, "\n"), sep="")
  
  if(any(model$mu!=0)) {
    cat(spacing)
    cat("  Basal transcription rate:\n")
    for(i in seq(along=model$mu)) {
      cat(spacing);
      cat(c("    Gene ", i, ": ", model$B[i], "\n"), sep="")
    }
  }
  cat(spacing)
  cat("  Kernel:\n")
  kernDisplay(model$kern, 4+spaceNum)
}
  

gpsimExtractParam <- function (model, only.values=TRUE,
                               untransformed.values=FALSE) {
  funcName <- optimiDefaultConstraint(model$bTransform)
  func <- get(funcName$func, mode="function")

  if (untransformed.values && "fix" %in% names(model)) {
    params <- gpsimExtractParam(model, only.values=TRUE,
                                untransformed.values=FALSE)
    origparams <- params
    for ( i in seq(along=model$fix$index) )
      params[model$fix$index[i]] <- model$fix$value[i]

    if (! all(params==origparams)) {
      model <- gpsimExpandParam(model, params)
    }
  }
  
  if ( only.values ) {
    params <- kernExtractParam(model$kern,
                               untransformed.values=untransformed.values)
    if (untransformed.values) {
      params <- c(params, model$B)
    } else {
      # Note: ignores funcName$hasArgs
      params <- c(params, func(model$B, "xtoa"))
    }
  } else {
    params <- kernExtractParam(model$kern, only.values=only.values,
                               untransformed.values=untransformed.values)
    if (untransformed.values) {
      Bparams <- model$B
    } else {
      # Note: ignores funcName$hasArgs
      Bparams <- func(model$B, "xtoa")
    }
    for ( i in seq(along=Bparams) ) {
      names(Bparams)[i] <- paste("Basal", i, sep="")
    }
    params <- c(params, Bparams)
  }

  params <- Re(params)        

  return (params)
}



gpsimExpandParam <- function (model, params) {
  if ( is.list(params) )
    params <- params$values

  params <- Re(params)
  if ( "fix" %in% names(model) ) 
    for ( i in seq(along=model$fix$index) )
      params[model$fix$index[i]] <- model$fix$value[i]

  if ( length(params) != model$numParams )
    stop("Parameter vector is incorrect length.")

  startVal <- 1
  endVal <- model$kern$nParams
  model$kern <- kernExpandParam(model$kern, params[startVal:endVal])

  funcName <- optimiDefaultConstraint(model$bTransform)
  func <- get(funcName$func, mode="function")

  # Note: ignores funcName$hasArgs
  model$B <- func(params[(endVal+1):length(params)], "atox")

  if (model$includeNoise)
    simMultiKern <- model$kern$comp[[1]]
  else
    simMultiKern <- model$kern

  if ( "proteinPrior" %in% names(model) ) {
    for ( i in seq(2,model$kern$numBlocks,length.out=model$kern$numBlocks-1) ) {
      model$D[i-1] <- simMultiKern$comp[[i]]$decay
      model$S[i-1] <- simMultiKern$comp[[i]]$sensitivity
    }
  } else {
    for ( i in seq(length.out=model$kern$numBlocks) ) {
      model$D[i] <- simMultiKern$comp[[i]]$decay
      model$S[i] <- simMultiKern$comp[[i]]$sensitivity
    }
  }

  model$mu <- model$B/model$D

  model <- .gpsimUpdateKernels(model)

  if ( "proteinPrior" %in% names(model) ) {
    yInd <- seq(1, simMultiKern$diagBlockDim[2])
    mInd <- simMultiKern$diagBlockDim[1] + yInd

    for ( i in seq(length=model$numGenes) ) {
      model$m[mInd] <- model$y[yInd]-model$mu[i]*array(1, c(length(yInd), 1))
      yInd <- yInd+simMultiKern$diagBlockDim[i+1]
      mInd <- mInd+simMultiKern$diagBlockDim[i+1]
    }
  } else {
    ind <- seq(along=model$t)
    lengthObs <- length(ind)
    for ( i in seq(length=model$numGenes) ) {
      model$m[ind] <- model$y[ind]-model$mu[i]*array(1, c(lengthObs, 1))
      ind <- ind+lengthObs
    }
  }

  return (model)
}



.gpsimUpdateKernels <- function (model) {
  eps <-  1e-6

  if ( ("proteinPrior" %in% names(model)) && ("timesCell" %in% names(model)) ) {
    k <- Re(kernCompute(model$kern, model$timesCell))
    noiseVar <- c(rep(eps, length(model$timesCell$protein)), model$yvar)
  } else {
    k <- Re(kernCompute(model$kern, model$t))
    noiseVar <- c(as.array(model$yvar))
  }

  model$K <- k+diag(as.array(noiseVar))
  invK <- .jitCholInv(model$K, silent=TRUE)

  if ( any(is.nan(invK$invM)) ) {
    if ("debug" %in% names(model) && model$debug) {
      cat("kern$decay = \n", model$D, "\n")
      cat("\n")
      cat("kern$sensitivity = \n", model$S, "\n")
      cat("\n")
      cat("kern$inverseWidth = \n", model$kern$comp[[1]]$inverseWidth, "\n")
      cat("\n")
    }
    stop("Singular chol(K) matrix!")
  }
  
  model$invK <- invK$invM

  if ( invK$jitter > 1e-4 && "debug" %in% names(model) && model$debug )
    warning(paste("Warning: gpsimUpdateKernels added jitter of", signif(invK$jitter, digits=4)))

  model$logDetK <- 2* sum( log ( diag(invK$chol) ) )
 
  return (model)
}



cgpsimOptimise <- function (model, options, ...) {
  if ( "optimiser" %in% names(options) ) {
    funcName <- paste(options$optimiser, "optim", sep="")
  } else {
    funcName <- "CGoptim"
  }
  func <- get(funcName, mode="function")
  
  params <- modelExtractParam(model)
  newParams <- func(params, fn=modelObjective, grad=modelGradient, options, model)
  
  model <- cgpsimExpandParam(model, newParams$xmin)
  model$llscore <- newParams$objective
  if ( funcName == "CGoptim" )
    model$lnSchFail <- newParams$lnSchFail

##  if ( length(options) < 7 ) {
##    newOptions <- options
##    options <- optimiDefaultOptions()
##    for ( i in seq(along=newOptions) ) 
##      if ( !is.na(newOptions[[i]]) )
##        options[[i]] <- newOptions[[i]]
##  }

##  params <- cgpsimExtractParam(model)

##  options1 <- optimiDefaultOptions()
##  options1$maxit <- 200
##  options1$fnscale <- 1e3
##  options1$trace <- TRUE

##  modelopt <- optim(params, modelObjective, gr=modelGradient, method="CG", control=list(trace=FALSE, type=2, maxit=options1$maxit, fnscale=options1$fnscale, reltol=options1$reltol), hessian=FALSE, model, options1$trace)
  
##  modelopt <- optim(modelopt$par, modelObjective, gr=modelGradient, method="CG", control=list(trace=FALSE, type=2, maxit=options$maxit, fnscale=options$fnscale, reltol=options$reltol), hessian=options$hessian, model, options$trace)

##  model <- cgpsimExpandParam(model, modelopt$par)
  
  return (model)
}



gpsimObjective <- function (params, model) {
  model <- gpsimExpandParam(model, params)
  f <- -gpsimLogLikelihood(model)
  return (f)
}



gpsimLogLikelihood <- function (model) {
  dim <- length(model$y)

  ll <- -dim*log(2*pi) - model$logDetK - t(model$m) %*% model$invK %*% model$m
  ll <- 0.5*ll

  ## prior contributions
  ll <- ll + kernPriorLogProb(model$kern)
  if ( "bprior" %in% names(model) ) {
    ll <- ll + priorLogProb(model$bprior, model$B)
  }
  return (ll)
}



gpsimLogLikeGradients <- function (model) {
  covGrad <- -model$invK + model$invK %*% model$m %*% t(model$m) %*% model$invK
  covGrad <- 0.5*covGrad

  if ( "proteinPrior" %in% names(model) ) {
    g <- kernGradient(model$kern, model$timesCell, covGrad)
  } else {
    g <- kernGradient(model$kern, model$t, covGrad)
  }

  g <- g + kernPriorGradient(model$kern)
  
  gmuFull <- t(model$m) %*% model$invK

  if ( "proteinPrior" %in% names(model) ) {
    if ( model$includeNoise ) {
      ind <- model$kern$comp[[1]]$diagBlockDim[1]+(1:model$kern$comp[[1]]$diagBlockDim[2])
      gmu <- array(0, model$numGenes)

      for ( i in seq(length=model$numGenes) ) {
        gmu[i] <- sum(gmuFull[ind])
        ind <- ind + model$kern$comp[[1]]$diagBlockDim[i+1]
      }
    } else {
      ind <- model$kern$diagBlockDim[1]+(1:model$kern$diagBlockDim[2])
      gmu <- array(0, model$numGenes)

      for ( i in seq(length=model$numGenes) ) {
        gmu[i] <- sum(gmuFull[ind])
        ind <- ind + model$kern$diagBlockDim[i+1]
      }
    }
  } else {
    numData <- length(model$t)
    ind <- 1:numData
    gmu <- array(0, model$numGenes)
    for ( i in seq(length=model$numGenes) ) {
      gmu[i] <- sum(gmuFull[ind])
      ind <- ind + numData
    }    
  }

  gb <- gmu/model$D

  funcName <- optimiDefaultConstraint(model$bTransform)
  func <- get(funcName$func, mode="function")

  ## prior contribution
  if ( "bprior" %in% names(model) ) {
    gb <- gb + priorGradient(model$bprior, model$B)
  }

  # Note: ignores funcName$hasArgs
  gb <- gb*func(model$B, "gradfact")

  ## gradient for D
  gd <- -gmu*model$B/(model$D*model$D)
  if ( model$kern$numBlocks == 1 ) {
    decayIndices <- 1
  } else if ( model$kern$numBlocks>1 ) {
    if ( "proteinPrior" %in% names(model) ) {
      decayIndices <- 3
      for ( i in seq(3, model$kern$numBlocks, length=(model$kern$numBlocks-2)) )
        decayIndices <- c(decayIndices, decayIndices[length(decayIndices)]+2)
    } else {
      decayIndices <- c(1, 4)
      for ( i in seq(3, model$kern$numBlocks, length=(model$kern$numBlocks-2)) )
        decayIndices <- c(decayIndices, decayIndices[length(decayIndices)]+2)
    }
  }

  g[decayIndices] <- g[decayIndices]+gd*expTransform(model$D, "gradfact")

  g <- c(g, gb)

  if ( "fix" %in% names(model) ) 
    g[model$fix$index] <- 0

  return (g)  
}
 


cgpsimLogLikeGradients <- function (model) {
  g <- gpsimLogLikeGradients(model$comp[[1]])

  for ( i in seq(2, length(model$comp), length=(length(model$comp)-1)) )
    g <- g + gpsimLogLikeGradients(model$comp[[i]])
  
  return (g)
}



cgpsimLogLikelihood <- function (model) {
  ll <- 0
  for ( i in seq(along=model$comp) )
    ll <- ll + gpsimLogLikelihood(model$comp[[i]])

  return (ll)
}



cgpsimExtractParam <- function (model, only.values=TRUE,
                                untransformed.values=FALSE) {
  return (gpsimExtractParam(model$comp[[1]], only.values=only.values,
                            untransformed.values=untransformed.values))
}



cgpsimExpandParam <- function (model, params) {
  for ( i in seq(along=model$comp) )
    model$comp[[i]] <- gpsimExpandParam(model$comp[[i]], params)

  return (model)
}



cgpsimObjective <- function (params, model, trace=0) {
  model <- cgpsimExpandParam(model, params)
  ll <- - cgpsimLogLikelihood (model)

  if ( trace & !is.na(ll) )
    cat("Negative Log-Likelihood: ", ll, "\n")

  return (ll)
}



cgpsimGradient <- function (params, model, ...) {
  model <- cgpsimExpandParam(model, params)
  g <- - cgpsimLogLikeGradients (model)

  return (g)
}



cgpsimUpdateProcesses <- function (model, predt=NULL) {
  for ( i in seq(along=model$comp) )
    model$comp[[i]] <- gpsimUpdateProcesses(model$comp[[i]], predt=predt)

  return (model)
}



gpsimGradient <- function (params, model, ...) {
  model <- gpsimExpandParam(model, params)
  g <- - gpsimLogLikeGradients (model)

  return (g)
}


gpsimUpdateProcesses <- function (model, predt=NULL) {
  if ( "proteinPrior" %in% names(model) ) {
    t <- model$timesCell[[2]]
  } else {
    t <- model$t
  }

  ##numData <- length(t)
  if (is.null(predt))
    predt <- c(seq(min(t), max(t), length=100), t)
  ## ymean <- t(matrix(model$y[1,], model$numGenes, numData))

  if (model$includeNoise)
    simMultiKern <- model$kern$comp[[1]]
  else
    simMultiKern <- model$kern

  if ( "proteinPrior" %in% names(model) ) {
    predTimeCell <- list()
    for ( i in seq(length=simMultiKern$numBlocks) )
      predTimeCell[[i]] <- predt

    Kxx <- multiKernCompute(simMultiKern, predTimeCell, model$timesCell)
    diagKxx <- kernDiagCompute(simMultiKern, predTimeCell)
    ## x <- c(model$proteinPrior$values, model$y-ymean)
    ind <- 1:length(predTimeCell[[1]])
    predFull <- list()
    varFull <- list()
    for ( indBlock in seq(length=simMultiKern$numBlocks) ) {
      K <- Kxx[ind,]
      diagK <- diagKxx[ind,]
      predFull[[indBlock]] <- Re( K %*% model$invK %*% model$m )
      varFull[[indBlock]] <- Re( diagK - t(apply(t(K)*(model$invK %*% t(K)), 2, sum)) )
      ind <- ind + length(predTimeCell[[indBlock]])
    }

    meanPredX <- t(matrix(model$B/model$D, model$numGenes, length(predt)))

    predF <- predFull[[1]]
    varF <- varFull[[1]]
    predExprs <- matrix(, nrow=length(predt), ncol=model$numGenes)
    varExprs <- matrix(, nrow=length(predt), ncol=model$numGenes)

    for ( i in seq(length=model$numGenes) ) {
      predExprs[,i] <- meanPredX[,i] + predFull[[i+1]]
      varExprs[,i] <- varFull[[i+1]]
    }

    predExprs <- predExprs[1:(length(predt)-length(t)),,drop=FALSE]
    varExprs <- varExprs[1:(length(predt)-length(t)),,drop=FALSE]

  } else {
    proteinKern <- kernCreate(model$t, "rbf")
    proteinKern$inverseWidth <- simMultiKern$comp[[1]]$inverseWidth

    K <- simXrbfKernCompute(simMultiKern$comp[[1]], proteinKern, model$t, predt)
    for ( i in seq(2, length=(simMultiKern$numBlocks-1)) ) 
      K <- rbind(K, simXrbfKernCompute(simMultiKern$comp[[i]], proteinKern, model$t, predt))

    predF <- Re( t(K)%*%model$invK%*%model$m)
    varF <- Re( kernDiagCompute(proteinKern, predt) - apply(K*(model$invK%*%K), 2, sum) )
    meanPredX <- t(matrix(model$B/model$D, model$numGenes, length(predt)))

    Kxx <- multiKernCompute(simMultiKern, predt, t)
    predX <- c(meanPredX) + Re( Kxx%*%model$invK%*%model$m)
    varX <- Re( kernDiagCompute(simMultiKern, predt)-apply(t(Kxx)*(model$invK%*%t(Kxx)), 2, sum) ) 

    predExprs <- matrix(predX, length(predt), model$numGenes)
    varExprs <- matrix(varX, length(predt), model$numGenes)
    predExprs <- predExprs[1:(length(predt)-length(t)),,drop=FALSE]
    varExprs <- varExprs[1:(length(predt)-length(t)),,drop=FALSE]
  }

  predF <- predF[1:(length(predt)-length(t))]
  varF <- varF[1:(length(predt)-length(t))]   

  model$predt <- predt[1:(length(predt)-length(t))]
  model$predF <- predF
  model$varF <- abs(varF)

  model$ypred <- predExprs
  model$ypredVar <- abs(varExprs)

  return (model)
}

gpdisimCreate <- function(Ngenes, Ntf, times, y, yvar, options, genes = NULL, annotation=NULL) {

  if ( any(dim(y)!=dim(yvar)) )
    stop("The gene variances have a different size matrix to the gene values.")

  if ( Ngenes != dim(y)[2] - 1 )
    stop("The number of genes given does not match the dimension of the gene values given.")

  if ( length(times) != dim(y)[1] )
    stop("The number of time points given does not match the number of gene values given.")

  y <- as.matrix(y)
##   if (options$includeNoise)
##     yvar <- 0 * y
##   else
  yvar <- as.matrix(yvar)

  model <- list(type="gpdisim", y=as.array(y), yvar=as.array(yvar))
  model$includeNoise <- options$includeNoise
  if (("gaussianInitial" %in% names(options)) && options$gaussianInitial)
    model$gaussianInitial <- TRUE
  else
    model$gaussianInitial <- FALSE

  if ("debug" %in% names(options))
    model$debug <- options$debug

  if ("timeSkew" %in% names(options)) {
    model$timeSkew <- options$timeSkew
    times <- times + model$timeSkew
  }
  else
    model$timeSkew <- 0.0

  model$uniqueT <- sort(unique(times))
  lBounds <- c(min(diff(model$uniqueT)),
               (model$uniqueT[length(model$uniqueT)]-model$uniqueT[1]))
  invWidthBounds <- c(1/(lBounds[2]^2), 1/(lBounds[1]^2))

  if (model$gaussianInitial)
    myopts <- list(gaussianInitial=TRUE, isNormalised=TRUE,
                   inverseWidthBounds=invWidthBounds)
  else
    myopts <- list(isNormalised=TRUE, inverseWidthBounds=invWidthBounds)
  
  kernType1 <- .gpsimKernelSpec(c('rbf', rep('disim', Ngenes)),
                                myopts, exps=NULL)

  tieParam <- list(tieDelta="di_decay", tieWidth="inverseWidth",
                   tieSigma="di_variance", tieRBFVariance="rbf.?_variance")

  if ("fixedBlocks" %in% names(options))
    kernType1 <- list(type="parametric", realType=kernType1,
                      options=list(fixedBlocks=options$fixedBlocks))

  if (model$includeNoise) {
    kernType2 <- list(type="multi", comp=array())
    for ( i in seq(1, Ngenes+1) )
      kernType2$comp[i] <- "white"        

    if ("singleNoise" %in% names(options) && options$singleNoise) {
      tieParam$tieNoise <- "white\\d+_variance"
    }

    model$kern <- kernCreate(times,
                             list(type="cmpnd", comp=list(kernType1, kernType2)))
    simMultiKernName <- 'model$kern$comp[[1]]'
    simMultiKern <- model$kern$comp[[1]]
  } else {
    model$kern <- kernCreate(times, kernType1)
    simMultiKernName <- 'model$kern'
    simMultiKern <- model$kern
  }
  
  model$kern <- modelTieParam(model$kern, tieParam)

  if (model$includeNoise) {
    for ( i in seq(1, Ngenes+1) ) {
      model$kern$comp[[2]]$comp[[i]]$variance <- 1e-2
    }
  }
  
  model$delta <- 10
  model$sigma <- 1
  for ( i in seq(2, simMultiKern$numBlocks) ) {
    eval(parse(text=paste(simMultiKernName, '$comp[[i]]$di_decay <- model$delta', sep="")))
    eval(parse(text=paste(simMultiKernName, '$comp[[i]]$di_variance <- model$sigma^2', sep="")))
    model$D[i-1] <- simMultiKern$comp[[i]]$decay
    model$S[i-1] <- sqrt(simMultiKern$comp[[i]]$variance)
  }

  set.seed(1)

  yArray <- array(y[,2:(Ngenes+1)], dim = c(dim(y)[1], Ngenes))

  model$numParams <- Ngenes + model$kern$nParams
  model$numGenes <- Ngenes
  model$mu <- apply(yArray, 2, mean)
  model$B <- model$D*yArray[1, ]
  model$m <- array(model$y, length(model$y))
  model$t <- times
  model$realt <- times - model$timeSkew

  model$optimiser <- options$optimiser

  if ( "bTransform" %in% names(options) ) {
    model$bTransform <- options$bTransform
  } else {
    model$bTransform <- "positive"
  }

  if ( !is.null(annotation) && annotation != "" ) {
    model$annotation <- annotation
  }

  if (!is.null(genes)) {
    model$genes <- genes
  }

  if ( "fix" %in% names(options) ) {
    params <- gpdisimExtractParam(model, only.values=FALSE)
    model$fix <- options$fix
    if (! "index" %in% names(model$fix)) {
      for ( i in seq(along=model$fix$names) ) {
        J <- grep(model$fix$names[i], names(params))
        if (length(J) != 1) {
          stop("gpdisimCreate: inconsistent fixed parameter specification")
        }
        model$fix$index[i] <- J
      }
    }
  }

  params <- gpdisimExtractParam(model)
  model <- gpdisimExpandParam(model, params)

  return (model)
}


gpdisimDisplay <- function(model, spaceNum=0)  {
  spacing = matrix("", spaceNum+1)
  cat(spacing)
  cat("Gaussian process driving input single input motif model:\n")
  cat(spacing)
  cat(c("  Number of time points: ", dim(model$t)[1], "\n"), sep="")
  cat(spacing)
  cat(c("  Driving TF: ", model$genes[[1]], "\n"), sep="")
  cat(spacing)
  cat(c("  Target genes (", model$numGenes, "):\n"), sep="")
  for (i in seq(2, length(model$genes))) {
    cat(spacing)
    cat(c("    ", model$genes[[i]], "\n"), sep="")
  }

  if(any(model$mu!=0)) {
    cat(spacing)
    cat("  Basal transcription rate:\n")
    for(i in seq(along=model$mu)) {
      cat(spacing);
      cat(c("    Gene ", i, ": ", model$B[i], "\n"), sep="")
    }
  }
  cat(spacing)
  cat("  Kernel:\n")
  kernDisplay(model$kern, 4+spaceNum)
}
  

gpdisimExtractParam <- function (model, only.values=TRUE,
                                 untransformed.values=FALSE) {
  return (gpsimExtractParam(model, only.values=only.values,
                            untransformed.values=untransformed.values))
}



gpdisimExpandParam <- function (model, params) {

  if ( is.list(params) )
    params <- params$values

  params <- Re(params)
  if ( "fix" %in% names(model) )
    for ( i in seq(along=model$fix$index) )
      params[model$fix$index[i]] <- model$fix$value[i]

  if ( length(params) != model$numParams )
    stop("Parameter vector is incorrect length.")

  startVal <- 1
  endVal <- model$kern$nParams
  model$kern <- kernExpandParam(model$kern, params[startVal:endVal])

  funcName <- optimiDefaultConstraint(model$bTransform)
  # Note: ignores funcName$hasArgs
  func <- get(funcName$func, mode="function")

  model$B <- func(params[(endVal+1):length(params)], "atox")

  if (model$includeNoise)
    simMultiKern <- model$kern$comp[[1]]
  else
    simMultiKern <- model$kern
  
  model$delta <- simMultiKern$comp[[2]]$di_decay
  model$sigma <- simMultiKern$comp[[2]]$di_variance

  for ( i in seq(2, simMultiKern$numBlocks) ) {
    model$D[i-1] <- simMultiKern$comp[[i]]$decay
    model$S[i-1] <- sqrt(simMultiKern$comp[[i]]$variance)
  }

  model$mu <- model$B/model$D
  model <- .gpsimUpdateKernels(model)

  ind <- seq(along=model$t)
  lengthObs <- length(ind)
  model$m[ind] <- model$y[ind]
  ind <- ind + lengthObs
  for ( i in seq(length=model$numGenes) ) {
    model$m[ind] <- model$y[ind]-model$mu[i]*array(1, c(lengthObs, 1))
    ind <- ind+lengthObs
  }

  return (model)
}




gpdisimObjective <- function (params, model) {
  model <- gpdisimExpandParam(model, params)
  f <- -gpdisimLogLikelihood(model)
  return (f)
}



gpdisimLogLikelihood <- function (model) {
  dim <- length(model$y)

  ll <- -dim*log(2*pi) - model$logDetK - t(model$m) %*% model$invK %*% model$m
  ll <- 0.5*ll

  # prior contributions
  ll <- ll + kernPriorLogProb(model$kern)
  if ( "bprior" %in% names(model) ) {
    ll <- ll + priorLogProb(model$bprior, model$B)
  }
  return (ll)
}



gpdisimGradient <- function (params, model, ...) {
  model <- gpdisimExpandParam(model, params)
  g <- - gpdisimLogLikeGradients (model)

  return (g)
}



gpdisimLogLikeGradients <- function (model) {

  covGrad <- -model$invK + model$invK %*% model$m %*% t(model$m) %*% model$invK
  covGrad <- 0.5*covGrad

  if ( "proteinPrior" %in% names(model) ) {
    g <- kernGradient(model$kern, model$timesCell, covGrad)
  } else {
    g <- kernGradient(model$kern, model$t, covGrad)
  }

  ## Prior contribution (will be zero if no prior)
  g <- g + kernPriorGradient(model$kern)

  gmuFull <- t(model$m) %*% model$invK

  if ( "proteinPrior" %in% names(model) ) {
    if ( model$includeNoise ) {
      ind <- model$kern$comp[[1]]$diagBlockDim[1]+(1:model$kern$comp[[1]]$diagBlockDim[2])
      gmu <- array(0, model$numGenes)

      for ( i in seq(length=model$numGenes) ) {
        gmu[i] <- sum(gmuFull[ind])
        ind <- ind + model$kern$comp[[1]]$diagBlockDim[i+1]
      }
    } else {
      ind <- model$kern$diagBlockDim[1]+(1:model$kern$diagBlockDim[2])
      gmu <- array(0, model$numGenes)

      for ( i in seq(length=model$numGenes) ) {
        gmu[i] <- sum(gmuFull[ind])
        ind <- ind + model$kern$diagBlockDim[i+1]
      }
    }
  } else {
    numData <- length(model$t)
    ind <- 1:numData
    ind <- ind + numData
    gmu <- array(0, model$numGenes)
    for ( i in seq(length=model$numGenes) ) {
      gmu[i] <- sum(gmuFull[ind])
      ind <- ind + numData
    }
  }

  gb <- gmu/model$D

  funcName <- optimiDefaultConstraint(model$bTransform)
  # Note: ignores funcName$hasArgs
  func <- get(funcName$func, mode="function")

  ## prior contribution
  if ( "bprior" %in% names(model) ) {
    gb <- gb + priorGradient(model$bprior, model$B)
  }

  gb <- gb*func(model$B, "gradfact")

  ## gradient for D
  gd <- -gmu*model$B/(model$D*model$D)
  decayIndices <- 5

  if (model$includeNoise)
    simMultiKern <- model$kern$comp[[1]]
  else
    simMultiKern <- model$kern

  for ( i in seq(3, simMultiKern$numBlocks, length=(simMultiKern$numBlocks-2)) )
    decayIndices <- c(decayIndices, tail(decayIndices, 1)+2)

  g[decayIndices] <- g[decayIndices]+gd*expTransform(model$D, "gradfact")

  g <- c(g, gb)

  if ( "fix" %in% names(model) )
    g[model$fix$index] <- 0

  return (g)
}



cgpdisimLogLikeGradients <- function (model) {
  g <- gpdisimLogLikeGradients(model$comp[[1]])

  for ( i in seq(2, length(model$comp), length=(length(model$comp)-1)) )
    g <- g + gpdisimLogLikeGradients(model$comp[[i]])

  return (g)
}



cgpdisimLogLikelihood <- function (model) {
  ll <- 0
  for ( i in seq(along=model$comp) )
    ll <- ll + gpdisimLogLikelihood(model$comp[[i]])

  return (ll)
}



cgpdisimExtractParam <- function (model, only.values=TRUE,
                                  untransformed.values=FALSE) {
  return (gpdisimExtractParam(model$comp[[1]], only.values=only.values,
                              untransformed.values=untransformed.values))
}



cgpdisimExpandParam <- function (model, params) {
  for ( i in seq(along=model$comp) )
    model$comp[[i]] <- gpdisimExpandParam(model$comp[[i]], params)

  return (model)
}



cgpdisimObjective <- function (params, model, trace=0) {
  model <- cgpdisimExpandParam(model, params)
  ll <- - cgpdisimLogLikelihood (model)

  if ( trace & !is.na(ll) )
    cat("Negative Log-Likelihood: ", ll, "\n")

  return (ll)
}



cgpdisimGradient <- function (params, model, ...) {
  model <- cgpdisimExpandParam(model, params)
  g <- - cgpdisimLogLikeGradients (model)

  return (g)
}



cgpdisimUpdateProcesses <- function (model, predt=NULL) {
  for ( i in seq(along=model$comp) )
    model$comp[[i]] <- gpdisimUpdateProcesses(model$comp[[i]], predt=predt)

  return (model)
}



gpdisimUpdateProcesses <- function (model, predt=NULL) {

  if ( "proteinPrior" %in% names(model) ) {
    t <- model$timesCell[[2]]
  } else {
    t <- model$t
  }

  numData <- length(t)
  if (is.null(predt)) {
    predt <- c(seq(min(t), max(t), length=100), t)
  }
  else {
    predt <- c(predt + model$timeSkew, t)
  }

  if (model$includeNoise)
    simMultiKern <- model$kern$comp[[1]]
  else
    simMultiKern <- model$kern

  if (model$gaussianInitial) {
    proteinKern <- kernCreate(model$t, list(type="parametric", realType="sim",
                                            options=list(gaussianInitial=TRUE,
                                              isNormalised=TRUE)))
    proteinKern$initialVariance <- simMultiKern$comp[[2]]$initialVariance
  }
  else
    proteinKern <- kernCreate(model$t, list(type="parametric", realType="sim",
                                            options=list(isNormalised=TRUE)))
  proteinKern$inverseWidth <- simMultiKern$comp[[1]]$inverseWidth
  proteinKern$decay <- model$delta
  proteinKern$variance <- simMultiKern$comp[[2]]$di_variance
  inputKern <- kernCreate(model$t, list(type="parametric", realType="rbf",
                                        options=list(isNormalised=TRUE)))
  inputKern$inverseWidth <- simMultiKern$comp[[1]]$inverseWidth
  inputKern$variance <- 1
  K <- simXrbfKernCompute(proteinKern, inputKern, predt, model$t)
  K <- K * simMultiKern$comp[[1]]$variance
  for ( i in seq(2, length=(simMultiKern$numBlocks-1)) )
    K <- cbind(K,t(disimXsimKernCompute(simMultiKern$comp[[i]], proteinKern, model$t, predt)))

  ymean <- t(matrix(c(0, model$mu), model$numGenes+1, numData))

  predF <- K %*% model$invK %*% c(model$y-ymean)
  varF <- simMultiKern$comp[[1]]$variance * kernDiagCompute(proteinKern, predt) - apply(t(K)*(model$invK %*% t(K)), 2, sum) + 1e-15

  Kxx <- multiKernCompute(simMultiKern, predt, model$t)
  meanPredX <- t(matrix(c(0, model$B/model$D), model$numGenes+1, length(predt)))
  predX <- c(meanPredX) + Re(Kxx %*% model$invK %*% c(model$y-ymean))
  varX <- Re( kernDiagCompute(simMultiKern, predt)-apply(t(Kxx)*(model$invK%*%t(Kxx)), 2, sum) ) + 1e-13

  predExprs <- matrix(predX, length(predt), model$numGenes+1)
  predExprs <- predExprs[1:(length(predt)-length(t)),]

  varExprs <- matrix(varX, length(predt), model$numGenes+1)
  varExprs <- varExprs[1:(length(predt)-length(t)),]

  predF <- predF[1:(length(predt)-length(t))]
  varF <- varF[1:(length(predt)-length(t))]
  predt <- predt[1:(length(predt)-length(t))]

  model$predt <- predt - model$timeSkew
  model$predF <- predF
  #model$varF <- abs(varF)
  model$varF <- varF

  model$ypred <- predExprs
  #model$ypredVar <- abs(varExprs)
  model$ypredVar <- varExprs

  return (model)
}

gammaPriorExpandParam <- function(prior, params) {
  prior$a <- params[1]
  prior$b <- params[2]

  return (prior)
}


gammaPriorExtractParam <- function(prior, only.values=TRUE,
                                   untransformed.values=TRUE) {
  params <- c(prior$a, prior$b)

  if ( !only.values )
    names(params) <- c("gamma a", "gamma b")

  return (params)
}


gammaPriorGradient <- function(prior, x) {
  return ((prior$a - 1) / x - prior$b)
}


gammaPriorLogProb <- function(prior, x) {
  D <- length(x)
  return (D*prior$a*log(prior$b) - D*lgamma(prior$a) + (prior$a-1)*sum(log(x))
          - prior$b*sum(x))
}


gammaPriorParamInit <- function(prior) {
  prior$a <- 1e-6
  prior$b <- 1e-6

  prior$transforms <- list(list(index=c(1,2), type="positive"))
  prior$nParams <- 2

  return (prior)
}

invgammaPriorExpandParam <- function(prior, params) {
  prior$a <- params[1]
  prior$b <- params[2]

  return (prior)
}


invgammaPriorExtractParam <- function(prior, only.values=TRUE,
                                   untransformed.values=TRUE) {
  params <- c(prior$a, prior$b)

  if ( !only.values )
    names(params) <- c("inv gamma a", "inv gamma b")

  return (params)
}


invgammaPriorGradient <- function(prior, x) {
  return (- (prior$a + 1) / x + prior$b / (x*x))
}


invgammaPriorLogProb <- function(prior, x) {
  D <- length(x)
  return (D*prior$a*log(prior$b) - D*lgamma(prior$a) - (prior$a+1)*sum(log(x))
          - prior$b*sum(1/x))
}


invgammaPriorParamInit <- function(prior) {
  prior$a <- 1e-6
  prior$b <- 1e-6

  prior$transforms <- list(list(index=c(1,2), type="positive"))
  prior$nParams <- 2

  return (prior)
}

set -xe 

#set nvcc_version=9.2
#check version matches

NVCC_FOUND=`nvcc --version | egrep -o "V[0-9]+.[0-9]" | cut -c2-`

if [ ${NVCC_FOUND} != ${nvcc_version} ]; then
    echo "CUDA version ${nvcc_version} targetted. CUDA version ${NVCC_FOUND} found."
    echo "break"
    exit 1
fi

cd ${SRC_DIR}/Python

${PYTHON} setup.py install

#!/bin/bash

control_c() {
    rm $DIR/*.npy
    exit
}

trap control_c SIGINT

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"

# make new test file and save what test we are on (targetdir)

python $DIR/make_output_directory.py

# make configurations

python $DIR/generate_configurations.py

# decide what tests to run
# TODO: for now this is hardcoded but it should check the gitrepo for changes and run tests accordingly


algs=("FDK" "fbp" "sirt" "ossart" "cgls" "asd_pocs" "awasd_pocs")

# RUN algorithm tests
for testnr in {1..4}; do
	for alg in "${algs[@]}"; do

			python $DIR/test_config_gen.py TestSequence.test_${testnr}_${alg}

		done
	done

# run other tests
# clean
rm $DIR/*.npy

%\VignetteIndexEntry{tigre User Guide}
%\VignetteKeywords{TimeCourse, GeneExpression, Transcription}
%\VignetteDepends{Biobase, annotate, puma, BiocStyle}
%\VignettePackage{tigre}
\documentclass[a4paper]{article}
\usepackage{url}

<<style, eval=TRUE, echo=FALSE, results=tex>>=
BiocStyle::latex()
@

\title{tigre User Guide}
\author{Antti Honkela, Pei Gao,\\
  Jonatan Ropponen, Miika-Petteri Matikainen,\\
  Magnus Rattray, and Neil D. Lawrence}

\newcommand{\tigre}{\Biocpkg{tigre}}

\begin{document}
\maketitle
\SweaveOpts{keep.source=TRUE}

\section{Abstract}

The \tigre{} package implements our methodology of Gaussian process
differential equation models for analysis of gene expression time
series from single input motif networks.  The package can be used for
inferring unobserved transcription factor (TF) protein concentrations
from expression measurements of known target genes, or for ranking
candidate targets of a TF.

\section{Citing \tigre{}}

The \tigre{} package is based on a body of methodological research.
Citing \tigre{} in publications will usually involve citing one or
more of the methodology papers
\cite{Honkela2010PNAS,Gao2008,Lawrence2007} that the software is
based on as well as citing the software package itself
\cite{Honkela2011}.

<<echo=FALSE, eval=TRUE>>=
options(width = 60)
@

\section{Introductory example analysis - Drosophila development}
\label{section:Introductory example}

In this section we introduce the main functions of the \Rpackage{puma}
package by repeating some of the analysis from the PNAS
paper~\cite{Honkela2010PNAS}\footnote{Note that the results reported
  in the paper were run using an earlier version of this package for
  MATLAB, so there can be minor differences.}.

\subsection{Installing the \tigre{} package}

The recommended way to install \tigre{} is to use the
\Rfunction{BiocManager::install} function. Installing in this way
should ensure that all appropriate dependencies are met.

<< eval=FALSE >>==
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("tigre")
@

% To install the tigre software, unpack the software and run
% \begin{verbatim}
% R CMD INSTALL tigre
% \end{verbatim}

To load the package start R and run
<<>>=
library(tigre)
@ 

\subsection{Loading the data}

To get started, you need some preprocessed time series expression
data.  If the data originates from Affymetrix arrays, we highly
recommend processing it with \Rfunction{mmgmos} from the
\Rpackage{puma} package.  This processing extracts error bars on the
expression measurements directly from the array data to allow judging
the reliability of individual measurements.  This information is
directly utilised by all the models in this package.

To start from scratch on Affymetrix data, the .CEL files from
\url{ftp://ftp.fruitfly.org/pub/embryo_tc_array_data/} may be
processed using:
<<eval=FALSE>>=
# Names of CEL files
expfiles <- c(paste("embryo_tc_4_", 1:12, ".CEL", sep=""),
              paste("embryo_tc_6_", 1:12, ".CEL", sep=""),
              paste("embryo_tc_8_", 1:12, ".CEL", sep=""))
# Load the CEL files
expdata <- ReadAffy(filenames=expfiles,
                    celfile.path="embryo_tc_array_data")
# Setup experimental data (observation times)
pData(expdata) <- data.frame("time.h" = rep(1:12, 3),
                             row.names=rownames(pData(expdata)))
# Run mmgMOS processing (requires several minutes to complete)
drosophila_mmgmos_exprs <- mmgmos(expdata)
drosophila_mmgmos_fragment <- drosophila_mmgmos_exprs
@ 

This data needs to be further processed to make it suitable for our
models.  This can be done using
<<eval=FALSE>>=
drosophila_gpsim_fragment <-
  processData(drosophila_mmgmos_fragment,
              experiments=rep(1:3, each=12))
@ 

Here the last argument specifies that we have three independent time
series of measurements.

In order to save time with the demos, a part of the result of this is
included in this package and can be loaded using
<<>>=
data(drosophila_gpsim_fragment)
@ 

\subsection{Learning individual models}

Let us now recreate some the models shown in the plots of the PNAS
paper~\cite{Honkela2010PNAS}:
<<>>=
# FBgn names of target genes
targets <- c('FBgn0003486', 'FBgn0033188', 'FBgn0035257')

# Load gene annotations
library(annotate)
aliasMapping <- getAnnMap("ALIAS2PROBE",
                  annotation(drosophila_gpsim_fragment))
# Get the probe identifier for TF 'twi'
twi <- get('twi', env=aliasMapping)
# Load alternative gene annotations
fbgnMapping <- getAnnMap("FLYBASE2PROBE",
                 annotation(drosophila_gpsim_fragment))
# Get the probe identifiers for target genes
targetProbes <- mget(targets, env=fbgnMapping)

st_models <- list()
# Learn single-target models for each gene individually
for (i in seq(along=targetProbes)) {
  st_models[[i]] <- GPLearn(drosophila_gpsim_fragment,
                            TF=twi, targets=targetProbes[i],
                            quiet=TRUE)
}
# Learn a joint model for all targets
mt_model <- GPLearn(drosophila_gpsim_fragment, TF=twi,
                    targets=targetProbes,
                    quiet=TRUE)
# Display the joint model parameters
show(mt_model)
# Learn a model without TF mRNA and TF protein translation
nt_model <- GPLearn(drosophila_gpsim_fragment,
                    targets=c(twi, targetProbes[1:2]), quiet=TRUE)
@ 

\subsection{Visualising the models}

The models can be plotted using commands like
<<eval=FALSE>>=
GPPlot(st_models[[1]], nameMapping=getAnnMap("FLYBASE",
                        annotation(drosophila_gpsim_fragment)))
GPPlot(mt_model, nameMapping=getAnnMap("FLYBASE",
                  annotation(drosophila_gpsim_fragment)))
GPPlot(nt_model, nameMapping=getAnnMap("FLYBASE",
                  annotation(drosophila_gpsim_fragment)))
@ 

\begin{figure}
  \begin{center}
<<fig=TRUE, echo=FALSE>>=
GPPlot(st_models[[1]], nameMapping=getAnnMap("FLYBASE",
                         annotation(drosophila_gpsim_fragment)))
@
\end{center}
\caption{Single target models for the gene FBgn0003486. The models for
  each repeated time series are shown in different columns.}
\end{figure}

\begin{figure}
  \begin{center}
<<fig=TRUE, echo=FALSE>>=
GPPlot(mt_model, nameMapping=getAnnMap("FLYBASE",
                   annotation(drosophila_gpsim_fragment)))
@
\end{center}
\caption{Multiple-target model for all the example genes.  The
  call creates independent figures for each repeated time series.}
\end{figure}

\begin{figure}
  \begin{center}
<<fig=TRUE, echo=FALSE>>=
GPPlot(nt_model, nameMapping=getAnnMap("FLYBASE",
                   annotation(drosophila_gpsim_fragment)))
@
\end{center}
\caption{Multiple-target model without TF protein translation for
  selected example genes without.  The
  call creates independent figures for each repeated time series.}
\end{figure}

\subsection{Ranking the targets}

Bulk ranking of candidate targets can be accomplished using
<<>>=
## Rank the targets, filtering weakly expressed genes with average
## expression z-score below 1.8
scores <- GPRankTargets(drosophila_gpsim_fragment, TF=twi,
                        testTargets=targetProbes,
                        options=list(quiet=TRUE),
                        filterLimit=1.8)
## Sort the returned list according to log-likelihood
scores <- sort(scores, decreasing=TRUE)
write.scores(scores)
@ 

To save space, \Rfunction{GPRankTargets} does not return the models by
default.  If those are needed later e.g. for plotting, they can be
recreated using the inferred parameters saved together with the
ranking using
<<>>=
topmodel <- generateModels(drosophila_gpsim_fragment,
                           scores[1])
show(topmodel)
@ 

\subsection{Ranking using known targets with multiple-target models}

Ranking using known targets with multiple-target models can be
accomplished simply by adding the \texttt{knownTargets} argument
<<>>=
## Rank the targets, filtering weakly expressed genes with average
## expression z-score below 1.8
scores <- GPRankTargets(drosophila_gpsim_fragment, TF=twi,
                        knownTargets=targetProbes[1],
                        testTargets=targetProbes[2:3],
                        options=list(quiet=TRUE),
                        filterLimit=1.8)
## Sort the returned list according to log-likelihood
scores <- sort(scores, decreasing=TRUE)
write.scores(scores)
@ 

\subsection{Running ranking in a batch environment}

\Rfunction{GPRankTargets} can be easily run in a batch environment
using the argument \texttt{scoreSaveFile}.  This indicates a file to
which scores are saved after processing each gene.  Thus one could,
for example, split the data to, say, 3 separate blocks according to
the reminder after division by 3 and run each of these independently.
The first for loop could then be run in parallel (e.g. as separate
jobs on a cluster), as each step is independent of the others.  After
these have all completed, the latter loop could be used to gather the
results.
<<eval=FALSE>>=
for (i in seq(1, 3)) {
  targetIndices <- seq(i,
    length(featureNames(drosophila_gpsim_fragment)), by=3)
  outfile <- paste('ranking_results_', i, '.Rdata', sep='')
  scores <- GPrankTargets(preprocData, TF=twi,
                          testTargets=targetIndices,
                          scoreSaveFile=outfile)
}

for (i in seq(1, 3)) {
  outfile <- paste('ranking_results_', i, '.Rdata', sep='')
  load(outfile)
  if (i==1)
    scores <- scoreList
  else
    scores <- c(scores, scoreList)
}
show(scores)
@ 

\section{Experimental feature: Using non-Affymetrix data}

Using non-Affymetrix data, or data without associated uncertainty
information for the expression data in general, requires more because
of two reasons
\begin{itemize}
\item noise variances need to be estimated together with other model
  parameters; and
\item weakly expressed genes cannot be easily filtered \emph{a
    priori}.
\end{itemize}

The first of these is automatically taken care of by all the above
functions, but the latter requires some extra steps after fitting the
models.

In order to get started, you need to create an
\Rfunction{ExpressionTimeSeries} object of your data set.  This can be
accomplished with the function
<<eval=FALSE>>=
procData <- processRawData(data, times=c(...),
                           experiments=c(...))
@ 

Filtering of weakly expressed genes requires more care and visualising
the fitted models is highly recommended to avoid mistakes.

Based on initial experiments, it seems possible to perform the
filtering based on the statistic \texttt{loglikelihoods(scores) -
  baseloglikelihoods(scores)}, but selection of suitable threshold is
highly dataset specific.

\section{Exporting results to an SQLite database}

The results of the analysis can be stored to an SQLite database. The
database can then be browsed and queried using the
\href{https://github.com/PROBIC/tigreBrowser}{tigreBrowser}
result browser. The data
is inserted to the database by using \Rfunction{export.scores} function.

An example of the usage of \Rfunction{export.scores} is given below
<<eval=FALSE>>=
export.scores(scores, datasetName='Drosophila',
              experimentSet='GPSIM/GPDISIM',
              database='database.sqlite',
              preprocData=drosophila_gpsim_fragment,
              models=models,
              aliasTypes=c('SYMBOL', 'GENENAME', 'FLYBASE', 'ENTREZID'))
@

In this example, \texttt{scores} is the return value of
\Rfunction{GPRankTargets}, \texttt{'Drosophila'} is the name of a dataset in
database and \texttt{'GPSIM/GPDISIM'} is the name of an experiment set in
database. In general, results with the same dataset name are considered to be
part of same dataset. That is, if no results with a given dataset are already
in the database, a new dataset entry is created.  On the other hand, if the
database already contains results with the same dataset name, new results will
be added to the old dataset.

Also, results from different experiments can be combined into a set of
experiments by giving them the same experiment set name. This is useful as a
result browser may display results depending on the experiment set.

\texttt{database.sqlite} is the filename of a database file. The file will
be created if it does not exist already.

The function will create model figures and add them to the database if
preprocessed data is given. In this example, models are given to the
function as a parameter. This is not necessary, however, as the function can
create models if preprocessed data is supplied. Nevertheless, the function will
finish faster if it does not have to (re-)create models.

In addition to log likelihoods and z-scores, this function will also export
different gene names and aliases to the database. By default, the function will
read GENENAME, SYMBOL and ENTREZID datas from relevant annotations and insert
those into the database. The function takes also \texttt{aliasTypes} argument
which is used to define which annotation information is inserted. In the
example above, FLYBASE gene numbers are also added to the genes in the
database. The insertion of alias annotations and z-scores requires that the
preprocessed data is supplied.

\section{Session Info}

<<sessionInfo>>=
sessionInfo()
@ 

\bibliography{gpsim}

\end{document}

\name{plotTimeseries}
\Rdversion{1.0}
\alias{plotTimeseries}
\title{Plot ExpressionTimeSeries data}
\description{
  Plots ExpressionTimeSeries data.
}
\usage{
plotTimeseries(data, nameMapping = NULL)
}
\arguments{
  \item{data}{An ExpressionTimeSeries object.}
  \item{nameMapping}{The annotation used for mapping the names of the
    genes for the figures.  By default, the SYMBOL annotation for the
    array is used, if available.}
}
\details{
  The function plots the expression levels from an ExpressionTimeSeries
  object and the associated standard deviations.  If the object
  includes multiple time series, they will be plotted in the same
  figure, but slightly shifted.
}
\author{Antti Honkela}
\seealso{
  \code{\link{processData}}.
}
\examples{
  # Load a mmgmos preprocessed fragment of the Drosophila developmental
  # time series
  data(drosophila_gpsim_fragment)

  # Plot the first two genes
  plotTimeseries(drosophila_gpsim_fragment[1:2,])
}
\keyword{model}

\name{modelDisplay}
\Rdversion{1.0}
\alias{modelDisplay}
\alias{gpdisimDisplay}
\alias{gpsimDisplay}
\alias{cmpndKernDisplay}
\alias{disimKernDisplay}
\alias{kernDisplay}
%\alias{mlpKernDisplay}
\alias{multiKernDisplay}
\alias{rbfKernDisplay}
\alias{simKernDisplay}
%\alias{translateKernDisplay}
\alias{whiteKernDisplay}
\title{Display a model.}
\description{
  displays the parameters of the model/kernel and the model/kernel type to
  the console.
}
\usage{
  modelDisplay(model, ...)
}
\arguments{
  \item{model}{the model/kernel structure to be displayed.}
  \item{...}{(optional) indent level for the display.}
}
\seealso{
\code{\link{modelExtractParam}}
}
\examples{
  # Load a mmgmos preprocessed fragment of the Drosophila developmental
  # time series
  data(drosophila_gpsim_fragment)

  # The probe identifier for TF 'twi'
  twi <- "143396_at"
  # The probe identifier for the target gene
  targetProbe <- "152715_at"

  # Create the model, but do not optimise
  model <- GPLearn(drosophila_gpsim_fragment,
                   TF=twi, targets=targetProbe,
                   useGpdisim=TRUE, quiet=TRUE,
                   dontOptimise=TRUE)

  # Display the initial model
  modelDisplay(model)
}
\keyword{model}

\name{modelGradient}
\Rdversion{1.0}
\alias{modelGradient}
\alias{modelObjective}
\alias{modelLogLikelihood}
\alias{cgpdisimGradient}
\alias{cgpdisimLogLikeGradients}
\alias{cgpdisimObjective}
\alias{cgpdisimLogLikelihood}
\alias{cgpsimGradient}
\alias{cgpsimLogLikeGradients}
\alias{cgpsimObjective}
\alias{cgpsimLogLikelihood}
\alias{gpdisimGradient}
\alias{gpdisimLogLikeGradients}
\alias{gpdisimObjective}
\alias{gpdisimLogLikelihood}
\alias{gpsimGradient}
\alias{gpsimLogLikeGradients}
\alias{gpsimObjective}
\alias{gpsimLogLikelihood}
\alias{gammaPriorGradient}
\alias{invgammaPriorGradient}
\alias{kernPriorGradient}
\alias{priorGradient}
\alias{gammaPriorLogProb}
\alias{invgammaPriorLogProb}
\alias{kernPriorLogProb}
\alias{priorLogProb}
\title{Model log-likelihood/objective error function and its gradient.}
\description{
  \code{modeGradient} gives the gradient of the objective function for a
  model. By default the objective function (\code{modelObjective}) is
  a negative log likelihood (\code{modelLogLikelihood}).
}
\usage{
  modelObjective(params, model, ...)
  modelLogLikelihood(model)
  modelGradient(params, model, ...)
}
\arguments{
  \item{params}{parameter vector to evaluate at.}
  \item{model}{model structure.}
  \item{...}{optional additional arguments.}
}
\value{
  \item{g}{the gradient of the error function to be minimised. }
  \item{v}{the objective function value (lower is better).}
  \item{ll}{the log-likelihood value.}
}
\seealso{
\code{\link{modelOptimise}}.
}
\examples{
  # Load a mmgmos preprocessed fragment of the Drosophila developmental
  # time series
  data(drosophila_gpsim_fragment)

  # The probe identifier for TF 'twi'
  twi <- "143396_at"
  # The probe identifier for the target gene
  targetProbe <- "152715_at"

  # Create the model but do not optimise
  model <- GPLearn(drosophila_gpsim_fragment,
                   TF=twi, targets=targetProbe,
                   useGpdisim=TRUE, quiet=TRUE,
                   dontOptimise=TRUE)
  params <- modelExtractParam(model, only.values=FALSE)
  ll <- modelLogLikelihood(model)
  paramValues <- modelExtractParam(model, only.values=TRUE)
  modelGradient(paramValues, model)
}
\keyword{model}

\name{export.scores}
\Rdversion{1.0}
\alias{export.scores}
\title{Export results to an SQLite database}
\description{
  Exports the results to an SQLite database which can then be browsed
  with a result browser. The function will export log likelihoods,
  z-scores, model figures and gene aliases.
}
\usage{
  export.scores(scores, datasetName='', experimentSet='',
    databaseFile='database.sqlite', preprocData=NULL, models=NULL,
    figpath=NULL, aliasTypes=c("SYMBOL", "GENENAME", "ENTREZID"),
    datasetSource='', datasetDescription='',
    datasetSaveLocation='', datasetFigureFilename='',
    experimentTimestamp=as.character(Sys.Date()),
    figureDesc='', figurePrio=0, regulator=NULL)
}
\arguments{
  \item{scores}{The scoreList to export.}
  \item{datasetName}{Name of the dataset in the database.}
  \item{experimentSet}{Name of the experiment set in the database.}
  \item{databaseFile}{Filename of the database. New database is created if
    the file does not exist.}
  \item{preprocData}{Preprocessed data. This is required in order to generate
    models and figures and to calculate z-scores. Also, inserting aliases
    requires preprocessed data.}
  \item{models}{Learned models. If not given, the function will generate
    models if preprocessed data is available.}
  \item{figpath}{Figure path. If this is defined, the function will generate
    figures to the given path instead of inserting them to the database.}
  \item{aliasTypes}{Types of aliases that are inserted to the database.}
  \item{datasetSource}{Additional information that is inserted to the
    database if defined.}
  \item{datasetDescription}{Additional information that is inserted to the
    database if defined.}
  \item{datasetSaveLocation}{Additional information that is inserted to the
    database if defined.}
  \item{datasetFigureFilename}{Additional information that is inserted to the
    database if defined.}
  \item{experimentTimestamp}{Timestamp that is inserted to the database.
    The default value is current date in ISO-8601 format.}
  \item{figureDesc}{Additional information that is inserted to the
    database if defined.}
  \item{figurePrio}{Additional information that is inserted to the
    database if defined.}
  \item{regulator}{If defined, override the regulator name from scoreList.}
}
\author{Miika-Petteri Matikainen, Antti Honkela}
\seealso{
  \code{\link{GPRankTargets}, \link{GPRankTFs}}.
}
\examples{\dontrun{
  # Load a mmgmos preprocessed fragment of the Drosophila developmental
  # time series
  data(drosophila_gpsim_fragment)

  # FBgn names of target genes
  targets <- c('FBgn0003486', 'FBgn0033188', 'FBgn0035257')
  # Load gene annotations
  library(annotate)
  aliasMapping <- getAnnMap("ALIAS2PROBE",
                  annotation(drosophila_gpsim_fragment))

  # Get the probe identifier for TF 'twi'
  twi <- get('twi', env=aliasMapping)
  # Load alternative gene annotations
  fbgnMapping <- getAnnMap("FLYBASE2PROBE",
                 annotation(drosophila_gpsim_fragment))

  # Get the probe identifiers for target genes
  targetProbes <- mget(targets, env=fbgnMapping)

  # Rank the targets, filtering weakly expressed genes with average
  # expression z-score below 1.8
  scores <- GPRankTargets(drosophila_gpsim_fragment, TF=twi,
                          testTargets=targetProbes,
                          options=list(quiet=TRUE),
                          filterLimit=1.8)

  # Export data from scoreList and preprocessed data to a database
  export.scores(scores, datasetName='Drosophila',
                experimentSet='GPSIM/GPDISIM',
                database='database.sqlite',
                preprocData=drosophila_gpsim_fragment,
                aliasTypes=c('SYMBOL', 'GENENAME', 'FLYBASE', 'ENTREZID'))
}}
\keyword{export}

\name{kernDiagGradX}
\Rdversion{1.0}
\alias{kernGradX}
\alias{kernDiagGradX}
\alias{cmpndKernGradX}
\alias{cmpndKernDiagGradX}
\alias{mlpKernDiagGradX}
\alias{mlpKernGradX}
\title{Compute the gradient of the  kernel wrt X.}
\description{
  computes the gradient of the (diagonal of the) kernel matrix with respect to the elements of the design matrix given in X.
}
\usage{
  kernDiagGradX(kern, x)
  kernGradX(kern, x, x2)
}
\arguments{
  \item{kern}{the kernel structure for which gradients are being computed.}
  \item{x}{if only argument: the input data in the form of a design
    matrix, if two arguments: row locations against which gradients are
    being computed.}
  \item{x2}{(optional) column locations against which gradients are being computed.}
}
\value{
  \item{gX}{the gradients of the diagonal with respect to each element of X. The returned matrix has the same dimensions as X.}
  \item{gX2}{the returned gradients. The gradients are returned in a matrix which is numData x numInputs x numData. Where numData is the number of data points and numInputs is the number of input dimensions in X.}
}
\seealso{
\code{\link{kernGradient}}
}
\examples{
kern <- kernCreate(1, 'mlp')
g <- kernDiagGradX(kern, as.matrix(3:8))
}
\keyword{model}

\name{generateModels}
\Rdversion{1.0}
\alias{generateModels}
\title{Generating models with the given data}
\description{
  'generateModels' recreates models based on the parameters
  stored in a scoreList.
}
\usage{
  generateModels(preprocData, scores)
}
\arguments{
  \item{preprocData}{The preprocessed data to be used.}
  \item{scores}{A scoreList object containing data of the models to be
    generated.}
}
%\details{
%  'generateModels' first creates a model with 'gpsimCreate' or 'gpdisimCreate'. Then 'gpsimExpandParam' or 'gpdisimExpandParam' is used to generate the original models without having to optimize them again.
%}
\value{
  'generateModels' returns a list of the generated models.
}
\author{Antti Honkela, Jonatan Ropponen}
\seealso{
  \code{\link{GPLearn}, \link{GPRankTargets}, \link{GPRankTFs}, \linkS4class{scoreList}}.
}
\examples{\dontrun{
  # Load a mmgmos preprocessed fragment of the Drosophila developmental
  # time series
  data(drosophila_gpsim_fragment)

  # Get the target probe names
  targets <- c('FBgn0003486', 'FBgn0033188', 'FBgn0035257')
  library(annotate)
  aliasMapping <- getAnnMap("ALIAS2PROBE",
                    annotation(drosophila_gpsim_fragment))
  twi <- get('twi', env=aliasMapping)
  fbgnMapping <- getAnnMap("FLYBASE2PROBE",
                   annotation(drosophila_gpsim_fragment))
  targetProbes <- mget(targets, env=fbgnMapping)

  scores <- GPRankTargets(drosophila_gpsim_fragment, TF=twi,
                          testTargets=targetProbes,
                          options=list(quiet=TRUE),
                          filterLimit=1.8)

  models <- generateModels(drosophila_gpsim_fragment, scores)
}}
\keyword{model}

\name{modelExtractParam}
\Rdversion{1.0}
\alias{modelExtractParam}
\alias{cgpdisimExtractParam}
\alias{cgpsimExtractParam}
\alias{gpdisimExtractParam}
\alias{gpsimExtractParam}
\alias{cmpndKernExtractParam}
\alias{disimKernExtractParam}
\alias{kernExtractParam}
\alias{mlpKernExtractParam}
\alias{multiKernExtractParam}
\alias{rbfKernExtractParam}
\alias{simKernExtractParam}
\alias{translateKernExtractParam}
\alias{whiteKernExtractParam}
\alias{gammaPriorExtractParam}
\alias{invgammaPriorExtractParam}
\alias{priorExtractParam}

\title{Extract the parameters of a model.}
\description{
  Extract parameters from the model into a vector of parameters for optimisation.
}
\usage{
  modelExtractParam(model, only.values=TRUE, untransformed.values=FALSE)
}
\arguments{
  \item{model}{the model structure containing the parameters to be extracted.}
  \item{only.values}{include parameter names in the returned vector.}
  \item{untransformed.values}{return actual values, not transformed
    values used by the optimisers.}
}
\value{
  \item{param}{vector of parameters extracted from the model.}
}
\seealso{
  \code{\link{modelExpandParam}}
}
\examples{
  # Load a mmgmos preprocessed fragment of the Drosophila developmental
  # time series
  data(drosophila_gpsim_fragment)

  # The probe identifier for TF 'twi'
  twi <- "143396_at"
  # The probe identifier for the target gene
  targetProbe <- "152715_at"

  # Create the model, but do not optimise
  model <- GPLearn(drosophila_gpsim_fragment,
                   TF=twi, targets=targetProbe,
                   useGpdisim=TRUE, quiet=TRUE,
                   dontOptimise=TRUE)

  # Get the initial parameter values
  params <- modelExtractParam(model, only.values=FALSE)
}
\keyword{model}

\name{ExpressionTimeSeries-class}
\Rdversion{1.1}
\docType{class}
\alias{ExpressionTimeSeries}
\alias{ExpressionTimeSeries-class}
\alias{var.exprs}
\alias{var.exprs<-}
\alias{initialize,ExpressionTimeSeries-method}
\alias{var.exprs,ExpressionTimeSeries-method}
\alias{var.exprs<-,ExpressionTimeSeries-method}

\title{Class to contain time series expression assays}
\description{Container for time series expression assays and
  experimental metadata. \code{ExpressionTimeSeries} class is derived
  from \code{\linkS4class{ExpressionSet}}, and requires fields
  \code{experiments} and \code{modeltime} in \code{phenoData}.}
\section{Extends}{
Directly extends class \code{\linkS4class{ExpressionSet}}.
}
\section{Objects from the Class}{
  \code{new("ExpressionTimeSeries")}

  \code{new("ExpressionTimeSeries",
    phenoData = new("AnnotatedDataFrame"),
    featureData = new("AnnotatedDataFrame"),
    experimentData = new("MIAME"),
    annotation = character(0),
    protocolData = phenoData[,integer(0)],
    exprs = new("matrix"),
    var.exprs = new("matrix"))
  }

  This creates an \code{ExpressionTimeSeries} with \code{assayData} implicitly
  created to contain \code{exprs} and \code{var.exprs}.

  \code{new("ExpressionTimeSeries",
    assayData = assayDataNew(exprs=new("matrix")),
    phenoData = new("AnnotatedDataFrame"),
    featureData = new("AnnotatedDataFrame"),
    experimentData = new("MIAME"),
    annotation = character(0),
    protocolData = phenoData[,integer(0)])
  }

  This creates an \code{ExpressionTimeSeries} with \code{assayData} provided
  explicitly. In this form, the only required named argument is
  \code{assayData}.

  \code{ExpressionTimeSeries} instances are usually created through
  \code{new("ExpressionTimeSeries", ...)}. Usually the arguments to \code{new}
  include \code{exprs} (a matrix of expression data, with features
  corresponding to rows and samples to columns), \code{var.exprs},
  \code{phenoData},
  \code{featureData}, \code{experimentData}, \code{annotation}, and
  \code{protocolData}. 
  \code{phenoData}, \code{featureData}, \code{experimentData},
  \code{annotation}, and \code{protocolData} can be missing, in which case
  they are assigned default values.
}
\section{Slots}{
  \describe{
    \item{\code{assayData}:}{Inherited from
      \code{\linkS4class{ExpressionSet}}.
      The models in \code{gpsim} package assume that \code{exprs}
      contains absolute (i.e. non-logarithmic) expression values.
      The member \code{var.exprs} may contain variances of the values.}
    \item{\code{phenoData}:}{Inherited from
      \code{\linkS4class{ExpressionSet}}.
      The following fields are required: \code{experiments} which
      contains integers from 1 to N with measurements from the same
      biological assay having the same number; \code{modeltime}
      which contains observation times in model units.
    }
    \item{\code{featureData}:}{Inherited from \code{\linkS4class{ExpressionSet}}.}
    \item{\code{experimentData}:}{Inherited from \code{\linkS4class{ExpressionSet}}.}
    \item{\code{annotation}:}{Inherited from \code{\linkS4class{ExpressionSet}}.}
    \item{\code{protocolData}:}{Inherited from \code{\linkS4class{ExpressionSet}}.}
    \item{\code{.__classVersion__}:}{Inherited from \code{\linkS4class{ExpressionSet}}.}
  }
}
\section{Methods}{
  See also methods for \code{\linkS4class{ExpressionSet}}.
  \describe{
    \item{\code{var.exprs(object)}, \code{var.exprs(object)<- value}}{Access and set \code{var.exprs}}
    \item{\code{initialize("ExpressionTimeSeries")}}{Object instantiation, used by new; not to be called directly by the user.}
  }
}
\author{Antti Honkela, Jonatan Ropponen}
\seealso{
  \code{\link{processData}}, \code{\link{processRawData}}.
}
\examples{
showClass("ExpressionTimeSeries")
}
\keyword{classes}

\name{kernCompute}
\Rdversion{1.0}
\alias{kernCompute}
\alias{kernDiagCompute}
\alias{cmpndKernCompute}
\alias{cmpndKernDiagCompute}
\alias{disimKernCompute}
\alias{disimKernDiagCompute}
\alias{mlpKernCompute}
\alias{multiKernCompute}
\alias{multiKernDiagCompute}
\alias{rbfKernCompute}
\alias{rbfKernDiagCompute}
\alias{simKernCompute}
\alias{simKernDiagCompute}
\alias{translateKernCompute}
\alias{translateKernDiagCompute}
\alias{whiteKernCompute}
\alias{whiteKernDiagCompute}
\alias{disimXdisimKernCompute}
\alias{disimXrbfKernCompute}
\alias{disimXsimKernCompute}
\alias{simXrbfKernCompute}
\alias{simXsimKernCompute}
\alias{whiteXwhiteKernCompute}
\title{Compute the kernel given the parameters and X.}
\description{
  Compute the kernel given the parameters and X.
}
\usage{
  kernCompute(kern, x, x2)
  kernDiagCompute(kern, x)
}
\arguments{
  \item{kern}{kernel structure to be computed.}
  \item{x}{first or only input data matrix (rows are data points) to the kernel computation.}
  \item{x2}{(optional) second input matrix to the kernel computation (forms the columns of the kernel).}
}
\details{
  \code{K <- kernCompute(kern, X)}
  computes a kernel matrix for the given kernel type given an input data matrix.

  \code{K <- kernCompute(kern, X1, X2)}
  computes a kernel matrix for the given kernel type given two input data matrices, one for the rows and one for the columns.
  
  \code{K <- kernDiagCompute(kern, X)}
  computes the diagonal of a kernel matrix for the given kernel.
  
  \code{K <- *X*kernCompute(kern1, kern2, X)}
  \code{K <- *X*kernCompute(kern1, kern2, X1, X2)}
  same as above, but for cross combinations of two kernels, \code{kern1} and \code{kern2}.
}
\value{
  \item{K}{computed elements of the kernel structure.}
  \item{Kd}{vector containing computed diagonal elements of the kernel structure.}
}
\seealso{
\code{\link{kernCreate}}
}
\examples{
kern <- kernCreate(1, 'rbf')
K <- kernCompute(kern, as.matrix(3:8))
}
\keyword{model}

\name{drosophila_mmgmos_fragment}
\docType{data}
\alias{drosophila_mmgmos_fragment}
\title{Fragment of 12 time point Drosophila embryonic development
  microarray gene expression time series}
\description{
  Four genes from the 12 time point Drosophila embryonic development
  Affymetrix microarray gene expression data set by Tomancak et
  al. (2002).

  The data has been processed using \code{mmgmos} from the
  \code{puma} package.
}
\usage{data(drosophila_mmgmos_fragment)}
\format{A \code{puma} package \code{exprReslt} object with
  3 repeats of the 12 time points for 4 probes.}
\source{\url{ftp://ftp.fruitfly.org/pub/embryo_tc_array_data/}}
\references{
  Tomancak, P et al.
  Systematic determination of patterns of gene expression during
  Drosophila embryogenesis.
  \emph{Genome Biol} 3:RESEARCH0088, 2002.
}
\keyword{datasets}

\name{lnDiffErfs}
\Rdversion{1.0}
\alias{lnDiffErfs}
\title{Helper function for computing the log of difference}
\description{
  Helper function for computing the log of difference
}
\usage{
  lnDiffErfs(x1, x2)
}
\arguments{
  \item{x1}{argument of the positive erf}
  \item{x2}{argument of the negative erf}
}
\details{
  \code{v <- lnDiffErfs(x1, x2)}
  computes the log of the difference of two erfs in a numerically stable manner.

}
\value{
  \item{v}{list(c(log(abs(erf(x1) - erf(x2))), sign(erf(x1) - erf(x2))))}
}
\examples{
  lnDiffErfs(100, 10)
}
\keyword{model}

\name{kernGradient}
\Rdversion{1.0}
\alias{kernGradient}
\alias{cmpndKernGradient}
\alias{disimKernGradient}
\alias{disimXdisimKernGradient}
\alias{disimXrbfKernGradient}
\alias{disimXsimKernGradient}
\alias{mlpKernGradient}
\alias{multiKernGradient}
\alias{rbfKernGradient}
\alias{simKernGradient}
\alias{simXrbfKernGradient}
\alias{simXsimKernGradient}
\alias{translateKernGradient}
\alias{whiteKernGradient}
\alias{whiteXwhiteKernGradient}
\title{Compute the gradient wrt the kernel parameters.}
\description{
  Compute the gradient wrt the kernel parameters.
}
\usage{
  kernGradient(kern, x, ...)
}
\arguments{
  \item{kern}{the kernel structure for which the gradients are being computed.}
  \item{x}{the input locations for which the gradients are being computed,
    specifically those associated with the rows of the kernel matrix
    if there are two arguments of input locations.}
  \item{...}{optional arguments including potentially:
    the input locations associated with the columns of the kernel matrix;
    matrix of partial derivatives of the function of interest with
    respect to the kernel matrix. With single input, the argument
    takes the form of a square matrix of dimension numData, where numData
    is the number of rows in x, with two input arguments
    the matrix should have the same number of rows as the first and the same
    number of columns as the second has rows.
    }
}
\details{
  \code{g <- kernGradient(kern, x, partial)}
  \code{g <- *kernGradient(kern, x, partial)}
  computes the gradient of functions with respect to the kernel parameters. As well as the kernel structure and the input positions, the user provides a matrix PARTIAL which gives the partial derivatives of the function with respect to the relevant elements of the kernel matrix.

  \code{g <- kernGradient(kern, x1, x2, partial_)}
  \code{g <- *kernGradient(kern, x1, x2, partial_)}
  computes the derivatives as above, but input locations are now provided in two matrices associated with rows and columns of the kernel matrix.

  \code{g <- *X*kernGradient(kern1, kern2, x, partial)}
  \code{g <- *X*kernGradient(kern1, kern2, x1, x2, partial_)}
  same as above, but for cross combinations of two kernels, \code{kern1} and \code{kern2}.
}
\value{
  \item{g}{gradients of the function of interest with respect to the kernel parameters. The ordering of the vector should match that provided by the function kernExtractParam.}
}
\seealso{
\code{\link{kernCompute}}, \code{\link{kernExtractParam}}.
}
\examples{
kern <- kernCreate(1, 'rbf')
g <- kernGradient(kern, as.matrix(c(1, 4)), array(1, c(2, 2)))
}
\keyword{model}

\name{optimiDefaultConstraint}
\Rdversion{1.0}
\alias{optimiDefaultConstraint}
\title{Returns function for parameter constraint.}
\description{
  returns the current default function for constraining a
  parameter.
}
\usage{
  optimiDefaultConstraint(constraint)
}
\arguments{
  \item{constraint}{the type of constraint you want to place on the parameter, options include 'positive' (gives an 'exp' constraint) and 'zeroone' (gives a 'sigmoid' constraint).}
}
\value{
  \item{val}{a list with two components: 'func' for the name of function
    used to apply the constraint, and 'hasArgs' for a boolean flag if
    the function requires additional arguments.}
}
\seealso{
\code{\link{expTransform}, \link{sigmoidTransform}}.
}
\examples{
  optimiDefaultConstraint('positive')
  optimiDefaultConstraint('bounded')
}
\keyword{model}

\name{modelTieParam}
\Rdversion{1.0}
\alias{modelTieParam}
\title{Tie parameters of a model together.}
\description{
  groups of parameters of a model to be seen as one parameter during optimisation of the model.
}
\usage{
  modelTieParam(model, paramsList)
}
\arguments{
  \item{model}{the model for which parameters are being tied together.}
  
  \item{paramsList}{indices of parameteres to group together. The
  indices are provided in a list. Each element in the list contains
  a vector of indices of parameters that should be considered as one
  parameter. Each group of parameters in each cell should obviously be
  mutually exclusive.
  
  Alternatively, the specification may consist of strings, which are
  interpreted as regular expressions that are matched against the
  parameter names returned by \code{modelExtractParam} or
  \code{kernExtractParam}, as appropriate fot the current object.}
}
\value{
  \item{model}{the model with the parameters grouped together.}
}
\seealso{
\code{\link{modelExtractParam}, \link{modelExpandParam}, \link{modelGradient}}.
}
\examples{
# Create a multi kernel with two rbf blocks with bounded inverse widths
invWidthBounds <- c(0.5, 2)
kernType <- list(type="multi", comp=list())
for (i in 1:2)
  kernType$comp[[i]] <- list(type="parametric", realType="rbf",
                              options=list(isNormalised=TRUE,
                                inverseWidthBounds=invWidthBounds))
kern <- kernCreate(1, kernType)

# Tie the inverse with parameters of the component RBF kernels
kern <- modelTieParam(kern, list(tieWidth="inverseWidth"))
kernDisplay(kern)
}
\keyword{model}

\name{SCGoptim}
\Rdversion{1.0}
\alias{SCGoptim}
\alias{CGoptim}
\alias{optimiDefaultOptions}
\alias{modelOptimise}
\alias{cgpsimOptimise}

\title{Optimise the given function using (scaled) conjugate gradients.}
\description{
  Optimise the given function using (scaled) conjugate gradients.
}
\usage{
  optimiDefaultOptions()
  SCGoptim(x, fn, grad, options, ...)
  CGoptim(x, fn, grad, options, ...)
  modelOptimise(model, options, ...)
}
\arguments{
  \item{model}{the model to be optimised.}
  \item{x}{initial parameter values.}
  \item{fn}{objective function to minimise}
  \item{grad}{gradient function of the objective}
  \item{options}{options structure like one returned by
    \code{optimiDefaultOptions}. The fields are interpreted as\\
    option[1] : number of iterations\\
    option[2] : interval for the line search\\
    option[3] : tolerence for x to terminate the loop\\
    option[4] : tolerence for fn to terminate the loop\\
    option$display : option of showing the details of optimisaton
  }
  \item{...}{extra arguments to pass to fn and grad}
}
\value{
  \item{options}{an options structure}
  \item{newParams}{optimised parameter values}
  \item{model}{the optimised model.}
}
\seealso{
\code{\link{modelObjective}, \link{modelGradient}}
}
\examples{
## Not run to speed up package checks
# model <- GPLearn(..., dontOptimise=TRUE)
# options <- optimiDefaultOptions()
# model <- modelOptimise(model, options)
}
\keyword{model}

\name{GPLearn}
\Rdversion{1.0}
\alias{GPLearn}
\title{Fit a GP model}
\description{
  Forms an optimized model of the desired genes. The function can form a
  model with GPsim or GPdisim and it's also possible to use initial
  parameters or fix parameters for future use. The genes can also be
  filtered based on ratios calculated from the expression values. The
  given data can also be searched for the data of specific genes.
}
\usage{
  GPLearn(preprocData, TF = NULL, targets = NULL,
    useGpdisim = !is.null(TF), randomize = FALSE, addPriors = FALSE,
    fixedParams = FALSE, initParams = NULL, initialZero = TRUE,
    fixComps = NULL, dontOptimise = FALSE,
    allowNegativeSensitivities = FALSE, quiet = FALSE,
    gpsimOptions = NULL, allArgs = NULL)
}
\arguments{
  \item{preprocData}{The preprocessed data to be used.}
  \item{TF}{The probe corresponding to the transcription factor (TF) mRNA
    if TF protein translation model is used, or NULL (default) if the
    translation model is not used.}
  \item{targets}{The target genes of the model.}
  \item{useGpdisim}{A logical value determining whether a model of
    translation is included.  By default TRUE if TF is set, FALSE
    if TF is unset.}
  \item{randomize}{A logical value determining whether the parameters
    of the model are randomized before optimization.}
  \item{addPriors}{A logical value determining whether priors are
    added to the model.}
  \item{fixedParams}{A logical value determining whether the initial
    parameters are fixed.}
  \item{initParams}{The initial parameters for the model. In
    combination with fixedParams a value NA denotes parameters to
    learn.}
  \item{initialZero}{Assume a zero initial TF protein concentration,
    default = TRUE.}
  \item{fixComps}{The blocks of the kernel the parameters of which are
    to be fixed. To be used together with fixedParams and initParams.}
  \item{dontOptimise}{Just create the model, do not run optimisation.}
  \item{allowNegativeSensitivities}{Allow sensitivities to go negative.
    This is an experimental feature, and the negative values have no
    physical interpretation.}
  \item{quiet}{Suppress optimiser output.}
  \item{gpsimOptions}{Internal: additional options to pass to
    gp[di]simCreate.}
  \item{allArgs}{A list of arguments that can be used to override
    ones with the same name.}
}
\value{
  Returns the optimized model.
}
\author{Antti Honkela, Pei Gao, Jonatan Ropponen, Magnus Rattray, Neil D. Lawrence}
\seealso{
  \code{\link{GPRankTargets}, \link{GPRankTFs}}.
}
\examples{
  # Load a mmgmos preprocessed fragment of the Drosophila developmental
  # time series
  data(drosophila_gpsim_fragment)

  # Get the target probe names
  library(annotate)
  aliasMapping <- getAnnMap("ALIAS2PROBE",
                    annotation(drosophila_gpsim_fragment))
  twi <- get('twi', env=aliasMapping)
  fbgnMapping <- getAnnMap("FLYBASE2PROBE",
                   annotation(drosophila_gpsim_fragment))
  targetProbe <- get('FBgn0035257', env=fbgnMapping)

  # Create the model but do not optimise (rarely needed...)
  model <- GPLearn(drosophila_gpsim_fragment,
                   TF=twi, targets=targetProbe,
                   useGpdisim=TRUE, quiet=TRUE,
                   dontOptimise=TRUE)
\dontrun{
  # Create and learn the model
  model <- GPLearn(drosophila_gpsim_fragment,
                   TF=twi, targets=targetProbe,
                   useGpdisim=TRUE, quiet=TRUE)
}}
\keyword{model}

\name{GPModel-class}
\Rdversion{1.1}
\docType{class}
\alias{GPModel}
\alias{GPModel-class}
\alias{is.GPModel}
\alias{modelStruct}
\alias{modelStruct<-}
\alias{modelType}
\alias{initialize,GPModel-method}
\alias{is.GPModel,GPModel-method}
\alias{modelStruct,GPModel-method}
\alias{modelStruct<-,GPModel,list-method}
\alias{modelType,GPModel-method}
\alias{show,GPModel-method}

\title{A container for gpsim models}
\description{The class is a container for the internal representation
  of models used by the \code{gpsim} package.}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("GPModel", model)}.
}
\section{Slots}{
  \describe{
    \item{\code{model}:}{A model object used internally by the code of
      the \code{gpsim} package}
    \item{\code{type}:}{Type of the model object}
  }
}
\section{Methods}{
  \describe{
    \item{\code{modelStruct(object)}, \code{modelStruct(object)<-
	value}}{Access and set the internal \code{model} structure}
    \item{\code{modelType(object)}}{Access the internal \code{type} values}
    \item{\code{show(object)}}{Informatively display object contents.}
    \item{\code{is.GPModel(object)}}{Check if object is a GPModel.}
    \item{\code{initialize("GPModel")}}{Object instantiation, used by new; not to be called directly by the user.}
  }
}
%\references{ ~put references to the literature/web site here ~ }
\author{Antti Honkela, Jonatan Ropponen}
%\note{ ~~further notes~~ }
%
% ~Make other sections like Warning with \section{Warning }{....} ~
%
\seealso{
  \code{\link{GPLearn}}, \code{\link{GPRankTargets}}, \code{\link{GPRankTFs}},
  \code{\link{generateModels}}, \code{\link{modelExtractParam}},
  \code{\link{modelLogLikelihood}}.
}
\examples{
showClass("GPModel")
}
\keyword{classes}

\name{tigre-package}
\alias{tigre-package}
\alias{tigre}
\docType{package}
\title{
  tigre - Transcription factor Inference through Gaussian process
  Reconstruction of Expression
}
\description{
  This package implements the method of Gao et al. (2008) and Honkela et
  al. (2010) for Gaussian process modelling single input motif
  regulatory systems with time-series expression data. The method can be
  used to rank potential targets of transcription factors based on such
  data.
}
\details{
  \tabular{ll}{
    Package: \tab tigre\cr
    Type: \tab Package\cr
    Version: \tab 1.12.0\cr
    Date: \tab 2012-10-02\cr
    License: \tab A-GPL Version 3\cr
  }
  For details of using the package please refer to the Vignette.
}
\author{
  Antti Honkela, Pei Gao, Jonatan Ropponen, Miika-Petteri Matikainen, Magnus Rattray, Neil D. Lawrence

  Maintainer: Antti Honkela <antti.honkela@hiit.fi>
}
\references{
  A.~Honkela, P.~Gao, J.~Ropponen, M.~Rattray, and N.~D.~Lawrence.
  tigre: Transcription factor Inference through Gaussian
  process Reconstruction of Expression for Bioconductor.
  \emph{Bioinformatics} 27(7):1026-1027, 2011.
  DOI: 10.1093/bioinformatics/btr057.

  P.~Gao, A.~Honkela, M.~Rattray, and N.~D.~Lawrence.
  Gaussian process modelling of latent chemical species:
  applications to inferring transcription factor activities.
  \emph{Bioinformatics} 24(16):i70--i75, 2008.
  DOI: 10.1093/bioinformatics/btn278.

  A.~Honkela, C.~Girardot, E.~H. Gustafson, Y.-H. Liu,
  E.~E.~M. Furlong, N.~D. Lawrence, and M.~Rattray.
  Model-based method for transcription factor target
  identification with limited data.
  \emph{Proc Natl Acad Sci USA} 107(17):7793-7798, 2010.
  DOI: 10.1073/pnas.0914285107.
}
\keyword{ package }
\seealso{
  \code{\link[puma:puma-package]{puma}}
}
\examples{\dontrun{
  # Load a mmgmos preprocessed fragment of the Drosophila developmental
  # time series
  data(drosophila_gpsim_fragment)

  # Get the target probe names
  library(annotate)
  aliasMapping <- getAnnMap("ALIAS2PROBE",
                    annotation(drosophila_gpsim_fragment))
  twi <- get('twi', env=aliasMapping)
  fbgnMapping <- getAnnMap("FLYBASE2PROBE",
                   annotation(drosophila_gpsim_fragment))
  targetProbe <- get('FBgn0035257', env=fbgnMapping)

  # Learn the model
  model <- GPLearn(drosophila_gpsim_fragment,
                   TF=twi, targets=targetProbe,
                   useGpdisim=TRUE, quiet=TRUE)

  # Plot it
  GPPlot(model, nameMapping=getAnnMap("FLYBASE",
                   annotation(drosophila_gpsim_fragment)))
}}

\name{scoreList-class}
\Rdversion{1.1}
\docType{class}
\alias{scoreList}
\alias{scoreList-class}
\alias{write.scores}
\alias{genes}
\alias{genes<-}
\alias{knownTargets}
\alias{knownTargets<-}
\alias{loglikelihoods}
\alias{loglikelihoods<-}
\alias{baseloglikelihoods}
\alias{baseloglikelihoods<-}
\alias{modelArgs}
\alias{modelArgs<-}
\alias{params}
\alias{params<-}
\alias{sharedModel}
\alias{sharedModel<-}
\alias{TF}
\alias{TF<-}
\alias{datasetName}
\alias{datasetName<-}
\alias{experimentSet}
\alias{experimentSet<-}
\alias{[,scoreList-method}
\alias{[,scoreList,ANY-method}
\alias{c,scoreList-method}
\alias{write.scores,scoreList-method}
\alias{genes,scoreList-method}
\alias{genes<-,scoreList,list-method}
\alias{knownTargets,scoreList-method}
\alias{knownTargets<-,scoreList,character-method}
\alias{length,scoreList-method}
\alias{loglikelihoods,scoreList-method}
\alias{loglikelihoods<-,scoreList,numeric-method}
\alias{baseloglikelihoods,scoreList-method}
\alias{baseloglikelihoods<-,scoreList,numeric-method}
\alias{modelArgs,scoreList-method}
\alias{modelArgs<-,scoreList,list-method}
\alias{params,scoreList-method}
\alias{params<-,scoreList,list-method}
\alias{sharedModel,scoreList-method}
\alias{sharedModel<-,scoreList,list-method}
\alias{show,scoreList-method}
\alias{sort,scoreList-method}
\alias{TF,scoreList-method}
\alias{TF<-,scoreList,character-method}
\alias{datasetName,scoreList-method}
\alias{datasetName<-,scoreList,character-method}
\alias{experimentSet,scoreList-method}
\alias{experimentSet<-,scoreList,character-method}

\title{Class "scoreList"}
\description{  'scoreList' is an object which contain the genes, parameters,
  log-likelihoods and arguments of models. With the data in a scoreList
  item and the original data used for creating the models, the models
  can be reconstructed with the function 'generateModels'.}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{scoreList(params, loglikelihoods,
  genes, modelArgs, knownTargets, TF, sharedModel)}.
}
\section{Slots}{
  \describe{
    \item{\code{params}:}{The parameters of the models.}
    \item{\code{loglikelihoods}:}{The log-likelihoods of the models.}
    \item{\code{baseloglikelihoods}:}{The log-likelihoods of
      corresponding null models.}
    \item{\code{genes}:}{The genes used in the models.}
    \item{\code{modelArgs}:}{A list of arguments used to generate the models.}
    \item{\code{knownTargets}:}{The list of known targets used in the ranking.}
    \item{\code{TF}:}{The TF used in the ranking.}
    \item{\code{sharedModel}:}{Shared model for known targets.}
    \item{\code{datasetName}:}{Dataset name, used when exporting scores to a database.}
    \item{\code{experimentSet}:}{Experiment set name, used when exporting scores to a database.}
  }
}
\section{Methods}{
  Class-specific methods:
  \describe{
    \item{\code{write.scores(object, ...)}}{Writes the log-likelihoods
      and null log-likelihoods. Accepts any options \code{write.table} does.}
    \item{\code{genes(object)}, \code{genes(object)<- value}}{Access and set \code{genes}}
    \item{\code{knownTargets(object)}, \code{knownTargets(object)<- value}}{Access and set \code{knownTargets}}
    \item{\code{loglikelihoods(object)}, \code{loglikelihoods(object)<- value}}{Access and set \code{loglikelihoods}}
    \item{\code{baseloglikelihoods(object)}, \code{baseloglikelihoods(object)<- value}}{Access and set \code{baseloglikelihoods}}
    \item{\code{modelArgs(object)}, \code{modelArgs(object)<- value}}{Access and set \code{modelArgs}}
    \item{\code{params(object)}, \code{params(object)<- value}}{Access and set \code{params}}
    \item{\code{sharedModel(object)}, \code{sharedModel(object)<- value}}{Access and set \code{sharedModel}}
    \item{\code{TF(object)}, \code{TF(object)<- value}}{Access and set \code{TF}}
    \item{\code{datasetName(object)}, \code{datasetName(object)<- value}}{Access and set \code{datasetName}}
    \item{\code{experimentSet(object)}, \code{experimentSet(object)<- value}}{Access and set \code{experimentSet}}
  }

  Standard generic methods:
  \describe{
    \item{\code{object[(index)}}{Conducts subsetting of the scoreList.}
    \item{\code{c(object, ...)}}{Concatenates scoreLists.}
    \item{\code{length(object)}}{Returns the length of the list.}
    \item{\code{show(object)}}{Informatively display object contents.}
    \item{\code{sort(object, decreasing=FALSE)}}{Sort the list according
  to log-likelihood}
  }
}
%\references{ ~put references to the literature/web site here ~ }
\author{Antti Honkela, Jonatan Ropponen}
%\note{ ~~further notes~~ }
%
% ~Make other sections like Warning with \section{Warning }{....} ~
%
\seealso{
  \code{\link{GPRankTargets}}, \code{\link{GPRankTFs}},
  \code{\link{generateModels}}, \code{\link{write.table}}.
}
%\seealso{
%	~~objects to See Also as \code{\link{~~fun~~}}, ~~~
%	or \code{\linkS4class{CLASSNAME}} for links to other classes
%}
\examples{
showClass("scoreList")
}
\keyword{classes}

\name{modelExpandParam}
\Rdversion{1.0}
\alias{modelExpandParam}
\alias{cgpdisimExpandParam}
\alias{cgpsimExpandParam}
\alias{gpdisimExpandParam}
\alias{gpsimExpandParam}
\alias{cmpndKernExpandParam}
\alias{disimKernExpandParam}
\alias{kernExpandParam}
\alias{mlpKernExpandParam}
\alias{multiKernExpandParam}
\alias{rbfKernExpandParam}
\alias{simKernExpandParam}
\alias{translateKernExpandParam}
\alias{whiteKernExpandParam}
\alias{modelUpdateProcesses}
\alias{cgpdisimUpdateProcesses}
\alias{gpdisimUpdateProcesses}
\alias{cgpsimUpdateProcesses}
\alias{gpsimUpdateProcesses}
\alias{gammaPriorExpandParam}
\alias{invgammaPriorExpandParam}
\alias{priorExpandParam}

\title{Update a model structure with new parameters or update the
  posterior processes.}
\description{
  Update a model structure or component with new parameters,
  or update the posterior processes.
}
\usage{
  modelExpandParam(model, params)
  modelUpdateProcesses(model, predt=NULL)
}
\arguments{
  \item{model}{the model structure to be updated.}
  \item{params}{vector of parameters.}
  \item{predt}{(optional) a vector of times to infer the posterior at.
    By default this is 100 points spanning the time range of the
    data.}
}
\value{
  \item{model}{updated model structure.}
}
\details{
  \code{model <- modelExpandParam(model, param)}
  returns a model structure filled with the parameters in the given
  vector. This is used as a helper function to enable parameters to be
  optimised in, for example, the optimisation functions.
  
  \code{model <- modelUpdateProcesses(model)}
  updates posterior processes of the given model.
}
\seealso{
\code{\link{GPLearn}, \link{modelExtractParam}}
}
\examples{\dontrun{
  # Learn the model
  model <- GPLearn(...)
  params <- modelExtractParam(model, only.values=TRUE)
  params[1] <- 0
  new_model <- modelExpandParam(model, params)
  new_model <- modelUpdateProcesses(new_model)
}}
\keyword{model}

\name{gpsimCreate}
\Rdversion{1.0}
\alias{gpsimCreate}
\alias{gpdisimCreate}
\title{Create a GPSIM/GPDISIM model.}
\description{
  creates a model for single input motifs with Gaussian processes.
}
\usage{
  gpsimCreate(Ngenes, Ntf, times, y,
              yvar, options, genes=NULL, annotation=NULL)
  gpdisimCreate(Ngenes, Ntf, times, y,
                yvar, options, genes=NULL, annotation=NULL)
}
\arguments{
  \item{Ngenes}{number of genes to be modelled in the system.}
  \item{Ntf}{number of proteins to be modelled in the system.}
  \item{times}{the time points where the data is to be modelled.}
  \item{y}{the values of each gene at the different time points.}
  \item{yvar}{the variances of each gene at the different time points.}
  \item{options}{options structure (optional).}
  \item{genes}{names of the probes the model is for}
  \item{annotation}{(optional) annotation for the probe names}
}
\value{
  \item{model}{model structure containing default parameterisation.}
}
\details{
  These functions are meant to be used through \code{\link{GPLearn}}.
}
\seealso{
\code{\link{modelExtractParam}, \link{modelOptimise}, \link{GPLearn}}.
}
\examples{
## missing, see GPLearn
}
\keyword{model}

\name{expTransform}
\Rdversion{1.0}
\alias{expTransform}
\alias{sigmoidTransform}
\alias{boundedTransform}
\title{Constrains a parameter.}
\description{
  contains commands to constrain parameters to be positive via
  exponentiation or within a fixed interval via the sigmoid function.
}
\usage{
expTransform(x, transform)
sigmoidTransform(x, transform)
boundedTransform(x, transform, bounds)
}
\arguments{
  \item{x}{input argument.}
  \item{transform}{type of transform, 'atox' maps a value into the
  transformed space (i.e. makes it positive). 'xtoa' maps the parameter
  back from transformed space to the original space. 'gradfact' gives
  the factor needed to correct gradients with respect to the transformed
  parameter.}
  \item{bounds}{a 2-vector of bounds of allowed values in boundedTransform}
}
\value{
  Return value as selected by \code{tranform}
}
\seealso{
\code{\link{modelOptimise}}
}
\examples{
  # Transform unconstrained parameter -4 to a positive value
  expTransform(-4, 'atox')

  # Transform a bounded parameter in (1,3) to an unconstrained one
  boundedTransform(2, 'xtoa', c(1, 3))
}
\keyword{model}

\name{GPRankTargets}
\Rdversion{1.0}
\alias{GPRankTargets}
\alias{GPRankTFs}
\title{Ranking possible target genes or regulators}
\description{
  \code{GPRankTargets} ranks possible target genes by forming
  optimized models with a fixed
  transcription factor, a set of known target genes and targets to be
  tested. The transcription factor and the known targets are always
  included in the models while the tested targets are tested by
  including them in the models one at a time. The function determines
  itself whether to use GPSIM or GPDISIM based on the input
  arguments.
}
\usage{
GPRankTargets(preprocData, TF = NULL, knownTargets = NULL,
              testTargets = NULL, filterLimit = 1.8,
              returnModels = FALSE, options = NULL,
              scoreSaveFile = NULL,
              datasetName = "", experimentSet = "")
GPRankTFs(preprocData, TFs, targets,
          filterLimit = 1.8, returnModels = FALSE, options = NULL,
          scoreSaveFile = NULL, datasetName = "", experimentSet = "")

}
\arguments{
  \item{preprocData}{The preprocessed data to be used.}
  \item{TF}{The transcription factor (TF) probe present in all models
    when TF protein translation model is used. Set to NULL (default)
    when translation model is not used.}
  \item{knownTargets}{The target genes present in all models.}
  \item{testTargets}{Target genes that are tested by including them in
    the models one at a time. Can be names of genes, or a set of indices
    in preprocData.}
  \item{filterLimit}{Genes with an average expression z-score above
    this figure are accepted after filtering. If this value is 0, all
    genes will be accepted.}
  \item{returnModels}{A logical value determining whether the function
    returns the calculated models.}
  \item{options}{A list of additional arguments to pass to GPLearn.}
  \item{scoreSaveFile}{Name of file to save the scores to after processing
    each gene.}
  \item{TFs}{The transcription factors that are tested by
    including them in the models one at a time.}
  \item{targets}{The target genes present in all models.}
  \item{datasetName}{For exporting the scores using
    \code{\link{export.scores}}: Name of the dataset in the database.}
  \item{experimentSet}{For exporting the scores using
    \code{\link{export.scores}}: Name of the experiment set in the database.}
}

\details{The models are formed by calling \code{\link{GPLearn}}.
  If there is no value given to the transcription
  factor, a model without protein translation is used.
  Without protein translation model, some
  known targets are needed. If known
  targets are given, a model is first created with only the transcription
  factor and the known targets. The parameters extracted from this model
  are used as initial parameters of the models with test targets.
  
  \code{GPRankTFs} is very similar to \code{GPRankTargets}, except
  it loops over candidate regulators, not candidate targets.
}

\value{
  The function returns a scoreList
  containing the genes, parameters and log-likelihoods of the models
  If returnModels is true,
  the function returns a list of the calculated models.
}
\author{Antti Honkela, Jonatan Ropponen, Magnus Rattray, Neil D. Lawrence}
\seealso{
  \code{\link{GPLearn}, \linkS4class{scoreList}, \link{generateModels},
    \link{export.scores}}.
}
\examples{\dontrun{
  # Load a mmgmos preprocessed fragment of the Drosophila developmental
  # time series
  data(drosophila_gpsim_fragment)

  # Get the target probe names
  targets <- c('FBgn0003486', 'FBgn0033188', 'FBgn0035257')
  library(annotate)
  aliasMapping <- getAnnMap("ALIAS2PROBE",
                    annotation(drosophila_gpsim_fragment))
  twi <- get('twi', env=aliasMapping)
  fbgnMapping <- getAnnMap("FLYBASE2PROBE",
                   annotation(drosophila_gpsim_fragment))
  targetProbes <- mget(targets, env=fbgnMapping)

  scores <- GPRankTargets(drosophila_gpsim_fragment, TF=twi,
                          testTargets=targetProbes,
                          options=list(quiet=TRUE),
                          filterLimit=1.8)
}}
\keyword{model}

\name{processData}
\Rdversion{1.0}
\alias{processData}
\alias{processRawData}
\title{Processing expression time series}
\description{
  \code{processData} further processes time series data preprocessed
  by \code{puma} or \code{lumi}.
  
  \code{processRawData} performs similar processing for other data.

  Both functions return \code{\linkS4class{ExpressionTimeSeries}}
  objects that can be used as input for the functions
  \code{\link{GPLearn}} and \code{\link{GPRankTargets}}.
}
\usage{
  processData(data, times = NULL, experiments = NULL,
    do.normalisation = TRUE)
  processRawData(rawData, times, experiments = NULL,
    is.logged = TRUE, do.normalisation = ifelse(is.logged, TRUE, FALSE))
}
\arguments{
  \item{data}{The preprocessed data from \code{mmgMOS} in the
    \code{puma} package (an \code{exprReslt} object) or
    from the \code{lumi} package (a \code{LumiBatch} object).}
  \item{rawData}{Raw data matrix to be used. Each row corresponds to
    a gene and each column to a data point.}
  \item{times}{Observation times of each data point.
    If unspecified or NULL, \code{processData} attempts to infer this
    from phenoData(data) field containing 'time' in the name.}
  \item{experiments}{The replicate structure of the data indicating
    which expression data points arise from which experiments.
    This should be an array in integers from 1 to N with length
    equal to the number of data points.
    By default all the data points are assumed to be from same
    replicate.}
  \item{is.logged}{Indicates whether the expression values are on
    log scale or not. Normalisation of non-logged data is unsupported.}
  \item{do.normalisation}{Indicates whether to perform the
    normalisation.}
}
\details{
  The expression data (and percentiles, if available) are normalized
  by equalising the mean of log-expression in each time points.
  In \code{processData}, a normal
  distribution is then fitted into the data with distfit.
}
\value{
  An \code{\linkS4class{ExpressionTimeSeries}}
  object containing all provided information.
}
\author{Antti Honkela, Jonatan Ropponen}
\seealso{
  \code{\link{GPLearn}, \link{GPRankTargets}}.
}
\examples{
  ## Load a mmgmos preprocessed fragment of the Drosophila developmental
  ## time series
  data(drosophila_mmgmos_fragment)

  ## Process the data (3 experiments containing 12 time points each)
  drosophila_gpsim_fragment <- processData(drosophila_mmgmos_fragment,
    experiments=rep(1:3, each=12))
}
\keyword{model}

\name{GPPlot}
\Rdversion{1.0}
\alias{GPPlot}
\title{Plot GP(DI)SIM models}
\description{
  Plots GP(DI)SIM models.
}
\usage{
GPPlot(data, savepath = '', nameMapping = NULL, predt = NULL,
       fileOutput=FALSE, plotTime=NULL)
}
\arguments{
  \item{data}{The model to plot as returned by GPLearn.}
  \item{savepath}{The location in the file system where the images are saved.}
  \item{nameMapping}{The annotation used for mapping the names of the
    genes for the figures.}
  \item{predt}{The set of time points to use in plotting
    (default: the time interval covering the data).}
  \item{fileOutput}{Is the plot being saved to a file? If yes, do not
    open new interactive devices for each plot.}
  \item{plotTime}{The times of observations to use in the plot.
    Should usually not be changed!}
}
\details{
  The function plots
  the fitted expression level of the transcription factor (if applicable),
  the inferred activity of the transcription factor,
  and the fitted expression level of the target(s).
}
\author{Antti Honkela}
\seealso{
  \code{\link{GPLearn}}.
}
\examples{\dontrun{
  # Load a mmgmos preprocessed fragment of the Drosophila developmental
  # time series
  data(drosophila_gpsim_fragment)

  # Get the target probe names
  library(annotate)
  aliasMapping <- getAnnMap("ALIAS2PROBE",
                    annotation(drosophila_gpsim_fragment))
  twi <- get('twi', env=aliasMapping)
  fbgnMapping <- getAnnMap("FLYBASE2PROBE",
                   annotation(drosophila_gpsim_fragment))
  targetProbe <- get('FBgn0035257', env=fbgnMapping)

  # Learn the model
  model <- GPLearn(drosophila_gpsim_fragment,
                   TF=twi, targets=targetProbe,
                   useGpdisim=TRUE, quiet=TRUE)

  # Plot it
  GPPlot(model, nameMapping=getAnnMap("FLYBASE",
         annotation(drosophila_gpsim_fragment)))
}}
\keyword{model}

\name{kernCreate}
\Rdversion{1.0}
\alias{kernCreate}
\alias{kernParamInit}
\alias{cmpndKernParamInit}
\alias{disimKernParamInit}
\alias{mlpKernParamInit}
\alias{multiKernParamInit}
\alias{rbfKernParamInit}
\alias{simKernParamInit}
\alias{translateKernParamInit}
\alias{whiteKernParamInit}
\alias{priorCreate}
\alias{gammaPriorParamInit}
\alias{invgammaPriorParamInit}
\alias{priorParamInit}

\title{Initialise a kernel structure.}
\description{
  Initialise a kernel structure.
}
\usage{
  kernCreate(x, kernType, kernOptions=NULL)
}
\arguments{
  \item{x}{If list, array or matrix: input data values (from which kernel will later be computed).
	If scalar: input dimension of the design matrix (i.e. number of
    features in the design matrix).}
  
  \item{kernType}{Type of kernel to be created, some standard types are
    'rbf', 'white', 'sim' and 'disim'. If a list of the form
    \code{list(type='cmpnd', comp=c('rbf', 'rbf', 'white'))} is used a
    compound kernel based on
    the sum of the individual kernels will be created.
    Parameters can be passed to kernels using type
    \code{list(type='parametric', options=list(opt=val), realType=...)},
    where \code{realType} is the type that would be used otherwise.
    }

  \item{kernOptions}{(optional) list of kernel options}
}
\details{
  \code{kern <- kernCreate(X, type)}
  input points and a kernel type.

  \code{kern <- kernCreate(dim, type)}
  creates a kernel matrix structure given the dimensions of the design matrix and the kernel type.

  The *KernParamInit functions perform initialisation specific to
  different types of kernels. They should not be called directly.
}
\value{
  \item{kern}{The kernel structure.}
}
\seealso{
\code{\link{kernDisplay}, \link{modelTieParam}}.
}
\examples{
# Create a multi kernel with two rbf blocks with bounded inverse widths
invWidthBounds <- c(0.5, 2)
kernType <- list(type="multi", comp=list())
for (i in 1:2)
  kernType$comp[[i]] <- list(type="parametric", realType="rbf",
                              options=list(isNormalised=TRUE,
                                inverseWidthBounds=invWidthBounds))
kern <- kernCreate(1, kernType)

# Tie the inverse with parameters of the component RBF kernels
kern <- modelTieParam(kern, list(tieWidth="inverseWidth"))
kernDisplay(kern)
}
\keyword{model}
